#include "report.x.h"
#include "a4gl_libaubit4gl.h"
int input_cmdtypes(char *rn,enum cmdtypes *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_cmdtypes");
#endif
name="cmdtypes";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_varcats(char *rn,enum varcats *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_varcats");
#endif
name="varcats";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_aggtypes(char *rn,enum aggtypes *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_aggtypes");
#endif
name="aggtypes";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_expr_operands(char *rn,enum expr_operands *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_expr_operands");
#endif
name="expr_operands";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_exprtype(char *rn,enum exprtype *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_exprtype");
#endif
name="exprtype";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_expr(char *rn,expr *r,int isptr,int arr) {
char *name;
name="expr";
#ifdef DEBUG
A4GL_debug("input_expr");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_union("expr","type",(int *)&r->type,rn,isptr,arr)) return 0;
switch(r->type) {
case EXPRTYPE_NULL:
   if (!input_int("null",&r->expr_u.null,0,-1)) return 0;
         break;
case EXPRTYPE_INT:
   if (!input_int("i",&r->expr_u.i,0,-1)) return 0;
         break;
case EXPRTYPE_DOUBLE:
   if (!input_double("d",&r->expr_u.d,0,-1)) return 0;
         break;
case EXPRTYPE_STRING:
   if (!input_string("s",&r->expr_u.s,0,-1)) return 0;
         break;
case EXPRTYPE_VARIABLE:
   if (!input_int("varid",&r->expr_u.varid,0,-1)) return 0;
         break;
case EXPRTYPE_BUILTIN:
   if (!input_string("name",&r->expr_u.name,0,-1)) return 0;
         break;
case EXPRTYPE_VARIABLE_SUB:

   if (!input_ptr_ok()) r->expr_u.var_usage=0;
   else r->expr_u.var_usage=acl_malloc2_With_Context(sizeof(acerep_var_usage));
   if (!input_acerep_var_usage("var_usage",r->expr_u.var_usage,1,-1)) return 0;

         break;
case EXPRTYPE_COMPLEX:

   if (!input_ptr_ok()) r->expr_u.expr=0;
   else r->expr_u.expr=acl_malloc2_With_Context(sizeof(complex_expr));
   if (!input_complex_expr("expr",r->expr_u.expr,1,-1)) return 0;

         break;
case EXPRTYPE_COMPARE:

   if (!input_ptr_ok()) r->expr_u.cexpr=0;
   else r->expr_u.cexpr=acl_malloc2_With_Context(sizeof(compare_expr));
   if (!input_compare_expr("cexpr",r->expr_u.cexpr,1,-1)) return 0;

         break;
case EXPRTYPE_SIMPLE:

   if (!input_ptr_ok()) r->expr_u.sexpr=0;
   else r->expr_u.sexpr=acl_malloc2_With_Context(sizeof(simple_expr));
   if (!input_simple_expr("sexpr",r->expr_u.sexpr,1,-1)) return 0;

         break;
case EXPRTYPE_LIST:

   if (!input_ptr_ok()) r->expr_u.lexpr=0;
   else r->expr_u.lexpr=acl_malloc2_With_Context(sizeof(expr_list));
   if (!input_expr_list("lexpr",r->expr_u.lexpr,1,-1)) return 0;

         break;
case EXPRTYPE_FCALL:

   if (!input_ptr_ok()) r->expr_u.fcall=0;
   else r->expr_u.fcall=acl_malloc2_With_Context(sizeof(expr_call));
   if (!input_expr_call("fcall",r->expr_u.fcall,1,-1)) return 0;

         break;
case EXPRTYPE_AGG:
   if (!input_int("aggid",&r->expr_u.aggid,0,-1)) return 0;
         break;
default: A4GL_assertion(1,"Unhandled switch element");
} /* switch */
if (!input_end_union("expr","type",r->type,rn)) return 0;
 return 1;
}

int input_acerep_var_usage(char *rn,acerep_var_usage *r,int isptr,int arr) {
char *name;
name="acerep_var_usage";
#ifdef DEBUG
A4GL_debug("input_acerep_var_usage");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("acerep_var_usage",rn,isptr,arr)) return 0;
   if (!input_int("varid",&r->varid,0,-1)) return 0;

   if (!input_ptr_ok()) r->varname=0;
   else r->varname=acl_malloc2_With_Context(sizeof(char));
   if (!input_char("varname",r->varname,1,-1)) return 0;


   if (!input_ptr_ok()) r->subscript1=0;
   else r->subscript1=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("subscript1",r->subscript1,1,-1)) return 0;


   if (!input_ptr_ok()) r->subscript2=0;
   else r->subscript2=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("subscript2",r->subscript2,1,-1)) return 0;

if (!input_end_struct("acerep_var_usage",rn)) return 0;
return 1;
}

int input_expr_list(char *rn,expr_list *r,int isptr,int arr) {
char *name;
name="expr_list";
#ifdef DEBUG
A4GL_debug("input_expr_list");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("expr_list",rn,isptr,arr)) return 0;
   if (!input_start_array("elem",1,(int *)&r->elem.elem_len)) return 0;
   {
      int cnt; if (r->elem.elem_len) {
      r->elem.elem_val=acl_malloc2_With_Context(r->elem.elem_len*sizeof(r->elem.elem_val[0]));
      for (cnt=0;cnt<r->elem.elem_len;cnt++) {
         if (!input_expr("elem",&r->elem.elem_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->elem.elem_val=0;}
   }
   if (!input_end_array("expr",1)) return 0;
if (!input_end_struct("expr_list",rn)) return 0;
return 1;
}

int input_expr_call(char *rn,expr_call *r,int isptr,int arr) {
char *name;
name="expr_call";
#ifdef DEBUG
A4GL_debug("input_expr_call");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("expr_call",rn,isptr,arr)) return 0;
   if (!input_string("fname",&r->fname,0,-1)) return 0;

   if (!input_ptr_ok()) r->lexpr=0;
   else r->lexpr=acl_malloc2_With_Context(sizeof(expr_list));
   if (!input_expr_list("lexpr",r->lexpr,1,-1)) return 0;

if (!input_end_struct("expr_call",rn)) return 0;
return 1;
}

int input_complex_expr(char *rn,complex_expr *r,int isptr,int arr) {
char *name;
name="complex_expr";
#ifdef DEBUG
A4GL_debug("input_complex_expr");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("complex_expr",rn,isptr,arr)) return 0;
   if (!input_expr("expr1",&r->expr1,0,-1)) return 0;
   if (!input_expr_operands("operand",&r->operand,0,-1)) return 0;
   if (!input_expr("expr2",&r->expr2,0,-1)) return 0;
if (!input_end_struct("complex_expr",rn)) return 0;
return 1;
}

int input_compare_expr(char *rn,compare_expr *r,int isptr,int arr) {
char *name;
name="compare_expr";
#ifdef DEBUG
A4GL_debug("input_compare_expr");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("compare_expr",rn,isptr,arr)) return 0;
   if (!input_string("method",&r->method,0,-1)) return 0;
   if (!input_expr("expr1",&r->expr1,0,-1)) return 0;
   if (!input_expr("expr2",&r->expr2,0,-1)) return 0;
if (!input_end_struct("compare_expr",rn)) return 0;
return 1;
}

int input_simple_expr(char *rn,simple_expr *r,int isptr,int arr) {
char *name;
name="simple_expr";
#ifdef DEBUG
A4GL_debug("input_simple_expr");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("simple_expr",rn,isptr,arr)) return 0;
   if (!input_expr("expr",&r->expr,0,-1)) return 0;
   if (!input_expr_operands("operand",&r->operand,0,-1)) return 0;
if (!input_end_struct("simple_expr",rn)) return 0;
return 1;
}

int input_acerep_variable(char *rn,acerep_variable *r,int isptr,int arr) {
char *name;
name="acerep_variable";
#ifdef DEBUG
A4GL_debug("input_acerep_variable");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("acerep_variable",rn,isptr,arr)) return 0;
   if (!input_string("name",&r->name,0,-1)) return 0;
   if (!input_string("datatype_string",&r->datatype_string,0,-1)) return 0;
   if (!input_int("category",&r->category,0,-1)) return 0;
   if (!input_int("param_no",&r->param_no,0,-1)) return 0;
   if (!input_int("datatype",&r->datatype,0,-1)) return 0;
   if (!input_int("dim",&r->dim,0,-1)) return 0;
   if (!input_int("dataspace",&r->dataspace,0,-1)) return 0;
if (!input_end_struct("acerep_variable",rn)) return 0;
return 1;
}

int input_ascii(char *rn,ascii *r,int isptr,int arr) {
char *name;
name="ascii";
#ifdef DEBUG
A4GL_debug("input_ascii");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("ascii",rn,isptr,arr)) return 0;
   if (!input_start_array("variables",1,(int *)&r->variables.variables_len)) return 0;
   {
      int cnt; if (r->variables.variables_len) {
      r->variables.variables_val=acl_malloc2_With_Context(r->variables.variables_len*sizeof(r->variables.variables_val[0]));
      for (cnt=0;cnt<r->variables.variables_len;cnt++) {
         if (!input_acerep_variable("variables",&r->variables.variables_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->variables.variables_val=0;}
   }
   if (!input_end_array("acerep_variable",1)) return 0;
if (!input_end_struct("ascii",rn)) return 0;
return 1;
}

int input_input_vals(char *rn,input_vals *r,int isptr,int arr) {
char *name;
name="input_vals";
#ifdef DEBUG
A4GL_debug("input_input_vals");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("input_vals",rn,isptr,arr)) return 0;
   if (!input_string("prompt",&r->prompt,0,-1)) return 0;
   if (!input_string("variable_name",&r->variable_name,0,-1)) return 0;
   if (!input_int("varid",&r->varid,0,-1)) return 0;
if (!input_end_struct("input_vals",rn)) return 0;
return 1;
}

int input_output(char *rn,output *r,int isptr,int arr) {
char *name;
name="output";
#ifdef DEBUG
A4GL_debug("input_output");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("output",rn,isptr,arr)) return 0;
   if (!input_int("right_margin",&r->right_margin,0,-1)) return 0;
   if (!input_int("top_margin",&r->top_margin,0,-1)) return 0;
   if (!input_int("left_margin",&r->left_margin,0,-1)) return 0;
   if (!input_int("bottom_margin",&r->bottom_margin,0,-1)) return 0;
   if (!input_int("page_length",&r->page_length,0,-1)) return 0;
   if (!input_string("top_of_page",&r->top_of_page,0,-1)) return 0;
   if (!input_int("report_to_where",&r->report_to_where,0,-1)) return 0;
   if (!input_string("report_to_filename",&r->report_to_filename,0,-1)) return 0;
if (!input_end_struct("output",rn)) return 0;
return 1;
}

int input_whereless_select(char *rn,whereless_select *r,int isptr,int arr) {
char *name;
name="whereless_select";
#ifdef DEBUG
A4GL_debug("input_whereless_select");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("whereless_select",rn,isptr,arr)) return 0;
   if (!input_string("select_portion",&r->select_portion,0,-1)) return 0;
   if (!input_string("into_portion",&r->into_portion,0,-1)) return 0;
   if (!input_string("group_by_portion",&r->group_by_portion,0,-1)) return 0;
if (!input_end_struct("whereless_select",rn)) return 0;
return 1;
}

int input_select_stmts(char *rn,select_stmts *r,int isptr,int arr) {
char *name;
name="select_stmts";
#ifdef DEBUG
A4GL_debug("input_select_stmts");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("select_stmts",rn,isptr,arr)) return 0;
   if (!input_whereless_select("whereless_statement",&r->whereless_statement,0,-1)) return 0;
   if (!input_string("statement",&r->statement,0,-1)) return 0;
   if (!input_int("has_where",&r->has_where,0,-1)) return 0;
   if (!input_int("wherepos1",&r->wherepos1,0,-1)) return 0;
   if (!input_int("wherepos2",&r->wherepos2,0,-1)) return 0;
   if (!input_start_array("varids",1,(int *)&r->varids.varids_len)) return 0;
   {
      int cnt; if (r->varids.varids_len) {
      r->varids.varids_val=acl_malloc2_With_Context(r->varids.varids_len*sizeof(r->varids.varids_val[0]));
      for (cnt=0;cnt<r->varids.varids_len;cnt++) {
         if (!input_int("varids",&r->varids.varids_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->varids.varids_val=0;}
   }
   if (!input_end_array("int",1)) return 0;
   if (!input_start_array("varpos",1,(int *)&r->varpos.varpos_len)) return 0;
   {
      int cnt; if (r->varpos.varpos_len) {
      r->varpos.varpos_val=acl_malloc2_With_Context(r->varpos.varpos_len*sizeof(r->varpos.varpos_val[0]));
      for (cnt=0;cnt<r->varpos.varpos_len;cnt++) {
         if (!input_int("varpos",&r->varpos.varpos_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->varpos.varpos_val=0;}
   }
   if (!input_end_array("int",1)) return 0;
   if (!input_string("temp_tab_name",&r->temp_tab_name,0,-1)) return 0;
   if (!input_start_array("orderby_list",1,(int *)&r->orderby_list.orderby_list_len)) return 0;
   {
      int cnt; if (r->orderby_list.orderby_list_len) {
      r->orderby_list.orderby_list_val=acl_malloc2_With_Context(r->orderby_list.orderby_list_len*sizeof(r->orderby_list.orderby_list_val[0]));
      for (cnt=0;cnt<r->orderby_list.orderby_list_len;cnt++) {
         if (!input_int("orderby_list",&r->orderby_list.orderby_list_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->orderby_list.orderby_list_val=0;}
   }
   if (!input_end_array("int",1)) return 0;
if (!input_end_struct("select_stmts",rn)) return 0;
return 1;
}

int input_read_stmt(char *rn,read_stmt *r,int isptr,int arr) {
char *name;
name="read_stmt";
#ifdef DEBUG
A4GL_debug("input_read_stmt");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("read_stmt",rn,isptr,arr)) return 0;
   if (!input_string("filename",&r->filename,0,-1)) return 0;
   if (!input_string("delimiters",&r->delimiters,0,-1)) return 0;
   if (!input_string("orderby",&r->orderby,0,-1)) return 0;
if (!input_end_struct("read_stmt",rn)) return 0;
return 1;
}

int input_get_data(char *rn,get_data *r,int isptr,int arr) {
char *name;
name="get_data";
#ifdef DEBUG
A4GL_debug("input_get_data");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_union("get_data","select_or_read",(int *)&r->select_or_read,rn,isptr,arr)) return 0;
switch(r->select_or_read) {
case 0:
   if (!input_start_array("selects",1,(int *)&r->get_data_u.selects.selects_len)) return 0;
   {
      int cnt; if (r->get_data_u.selects.selects_len) {
      r->get_data_u.selects.selects_val=acl_malloc2_With_Context(r->get_data_u.selects.selects_len*sizeof(r->get_data_u.selects.selects_val[0]));
      for (cnt=0;cnt<r->get_data_u.selects.selects_len;cnt++) {
         if (!input_select_stmts("selects",&r->get_data_u.selects.selects_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->get_data_u.selects.selects_val=0;}
   }
   if (!input_end_array("select_stmts",1)) return 0;
         break;
case 1:
   if (!input_read_stmt("read_data",&r->get_data_u.read_data,0,-1)) return 0;
         break;
default: A4GL_assertion(1,"Unhandled switch element");
} /* switch */
if (!input_end_union("get_data","select_or_read",r->select_or_read,rn)) return 0;
 return 1;
}

int input_cmd_for(char *rn,cmd_for *r,int isptr,int arr) {
char *name;
name="cmd_for";
#ifdef DEBUG
A4GL_debug("input_cmd_for");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_for",rn,isptr,arr)) return 0;
   if (!input_int("varid",&r->varid,0,-1)) return 0;
   if (!input_expr("start",&r->start,0,-1)) return 0;
   if (!input_expr("finish",&r->finish,0,-1)) return 0;
   if (!input_expr("step",&r->step,0,-1)) return 0;

   if (!input_ptr_ok()) r->command=0;
   else r->command=acl_malloc2_With_Context(sizeof(acerep_command));
   if (!input_acerep_command("command",r->command,1,-1)) return 0;

if (!input_end_struct("cmd_for",rn)) return 0;
return 1;
}

int input_cmd_if(char *rn,cmd_if *r,int isptr,int arr) {
char *name;
name="cmd_if";
#ifdef DEBUG
A4GL_debug("input_cmd_if");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_if",rn,isptr,arr)) return 0;
   if (!input_expr("condition",&r->condition,0,-1)) return 0;

   if (!input_ptr_ok()) r->command=0;
   else r->command=acl_malloc2_With_Context(sizeof(acerep_command));
   if (!input_acerep_command("command",r->command,1,-1)) return 0;


   if (!input_ptr_ok()) r->elsecommand=0;
   else r->elsecommand=acl_malloc2_With_Context(sizeof(acerep_command));
   if (!input_acerep_command("elsecommand",r->elsecommand,1,-1)) return 0;

if (!input_end_struct("cmd_if",rn)) return 0;
return 1;
}

int input_cmd_call(char *rn,cmd_call *r,int isptr,int arr) {
char *name;
name="cmd_call";
#ifdef DEBUG
A4GL_debug("input_cmd_call");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_call",rn,isptr,arr)) return 0;

   if (!input_ptr_ok()) r->fcall=0;
   else r->fcall=acl_malloc2_With_Context(sizeof(expr_call));
   if (!input_expr_call("fcall",r->fcall,1,-1)) return 0;

if (!input_end_struct("cmd_call",rn)) return 0;
return 1;
}

int input_cmd_while(char *rn,cmd_while *r,int isptr,int arr) {
char *name;
name="cmd_while";
#ifdef DEBUG
A4GL_debug("input_cmd_while");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_while",rn,isptr,arr)) return 0;
   if (!input_expr("condition",&r->condition,0,-1)) return 0;

   if (!input_ptr_ok()) r->command=0;
   else r->command=acl_malloc2_With_Context(sizeof(acerep_command));
   if (!input_acerep_command("command",r->command,1,-1)) return 0;

if (!input_end_struct("cmd_while",rn)) return 0;
return 1;
}

int input_cmd_let(char *rn,cmd_let *r,int isptr,int arr) {
char *name;
name="cmd_let";
#ifdef DEBUG
A4GL_debug("input_cmd_let");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_let",rn,isptr,arr)) return 0;
   if (!input_int("varid",&r->varid,0,-1)) return 0;

   if (!input_ptr_ok()) r->value=0;
   else r->value=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("value",r->value,1,-1)) return 0;


   if (!input_ptr_ok()) r->sub1=0;
   else r->sub1=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("sub1",r->sub1,1,-1)) return 0;


   if (!input_ptr_ok()) r->sub2=0;
   else r->sub2=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("sub2",r->sub2,1,-1)) return 0;

if (!input_end_struct("cmd_let",rn)) return 0;
return 1;
}

int input_cmd_need(char *rn,cmd_need *r,int isptr,int arr) {
char *name;
name="cmd_need";
#ifdef DEBUG
A4GL_debug("input_cmd_need");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_need",rn,isptr,arr)) return 0;
   if (!input_int("nlines",&r->nlines,0,-1)) return 0;
if (!input_end_struct("cmd_need",rn)) return 0;
return 1;
}

int input_cmd_pause(char *rn,cmd_pause *r,int isptr,int arr) {
char *name;
name="cmd_pause";
#ifdef DEBUG
A4GL_debug("input_cmd_pause");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_pause",rn,isptr,arr)) return 0;
   if (!input_string("message",&r->message,0,-1)) return 0;
if (!input_end_struct("cmd_pause",rn)) return 0;
return 1;
}

int input_cmd_skip(char *rn,cmd_skip *r,int isptr,int arr) {
char *name;
name="cmd_skip";
#ifdef DEBUG
A4GL_debug("input_cmd_skip");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_skip",rn,isptr,arr)) return 0;
   if (!input_int("nlines",&r->nlines,0,-1)) return 0;
if (!input_end_struct("cmd_skip",rn)) return 0;
return 1;
}

int input_cmd_print(char *rn,cmd_print *r,int isptr,int arr) {
char *name;
name="cmd_print";
#ifdef DEBUG
A4GL_debug("input_cmd_print");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_print",rn,isptr,arr)) return 0;
   if (!input_expr("print",&r->print,0,-1)) return 0;
   if (!input_int("printnl",&r->printnl,0,-1)) return 0;
if (!input_end_struct("cmd_print",rn)) return 0;
return 1;
}

int input_cmd_printfile(char *rn,cmd_printfile *r,int isptr,int arr) {
char *name;
name="cmd_printfile";
#ifdef DEBUG
A4GL_debug("input_cmd_printfile");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("cmd_printfile",rn,isptr,arr)) return 0;
   if (!input_expr("filename_expr",&r->filename_expr,0,-1)) return 0;
if (!input_end_struct("cmd_printfile",rn)) return 0;
return 1;
}

int input_a4gl_report_function(char *rn,a4gl_report_function *r,int isptr,int arr) {
char *name;
name="a4gl_report_function";
#ifdef DEBUG
A4GL_debug("input_a4gl_report_function");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("a4gl_report_function",rn,isptr,arr)) return 0;
   if (!input_string("name",&r->name,0,-1)) return 0;
if (!input_end_struct("a4gl_report_function",rn)) return 0;
return 1;
}

int input_acerep_commands(char *rn,acerep_commands *r,int isptr,int arr) {
char *name;
name="acerep_commands";
#ifdef DEBUG
A4GL_debug("input_acerep_commands");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("acerep_commands",rn,isptr,arr)) return 0;
   if (!input_start_array("commands",1,(int *)&r->commands.commands_len)) return 0;
   {
      int cnt; if (r->commands.commands_len) {
      r->commands.commands_val=acl_malloc2_With_Context(r->commands.commands_len*sizeof(r->commands.commands_val[0]));
      for (cnt=0;cnt<r->commands.commands_len;cnt++) {
         if (!input_acerep_command("commands",&r->commands.commands_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->commands.commands_val=0;}
   }
   if (!input_end_array("acerep_command",1)) return 0;
if (!input_end_struct("acerep_commands",rn)) return 0;
return 1;
}

int input_acerep_command(char *rn,acerep_command *r,int isptr,int arr) {
char *name;
name="acerep_command";
#ifdef DEBUG
A4GL_debug("input_acerep_command");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_union("acerep_command","cmd_type",(int *)&r->cmd_type,rn,isptr,arr)) return 0;
switch(r->cmd_type) {
case CMD_NULL:
   if (!input_int("null",&r->acerep_command_u.null,0,-1)) return 0;
         break;
case CMD_FOR:
   if (!input_cmd_for("cmd_for",&r->acerep_command_u.cmd_for,0,-1)) return 0;
         break;
case CMD_IF:
   if (!input_cmd_if("cmd_if",&r->acerep_command_u.cmd_if,0,-1)) return 0;
         break;
case CMD_WHILE:
   if (!input_cmd_while("cmd_while",&r->acerep_command_u.cmd_while,0,-1)) return 0;
         break;
case CMD_LET:
   if (!input_cmd_let("cmd_let",&r->acerep_command_u.cmd_let,0,-1)) return 0;
         break;
case CMD_NEED:
   if (!input_cmd_need("cmd_need",&r->acerep_command_u.cmd_need,0,-1)) return 0;
         break;
case CMD_PAUSE:
   if (!input_cmd_pause("cmd_pause",&r->acerep_command_u.cmd_pause,0,-1)) return 0;
         break;
case CMD_SKIP:
   if (!input_cmd_skip("cmd_skip",&r->acerep_command_u.cmd_skip,0,-1)) return 0;
         break;
case CMD_PRINT:
   if (!input_cmd_print("cmd_print",&r->acerep_command_u.cmd_print,0,-1)) return 0;
         break;
case CMD_PRINTFILE:
   if (!input_cmd_printfile("cmd_printfile",&r->acerep_command_u.cmd_printfile,0,-1)) return 0;
         break;
case CMD_BLOCK:
   if (!input_acerep_commands("acerep_commands",&r->acerep_command_u.acerep_commands,0,-1)) return 0;
         break;
case CMD_CALL:
   if (!input_cmd_call("cmd_call",&r->acerep_command_u.cmd_call,0,-1)) return 0;
         break;
default: A4GL_assertion(1,"Unhandled switch element");
} /* switch */
if (!input_end_union("acerep_command","cmd_type",r->cmd_type,rn)) return 0;
 return 1;
}

int input_formattype(char *rn,enum formattype *r,int isptr,int arr){
char *name;
#ifdef DEBUG
A4GL_debug("input_formattype");
#endif
name="formattype";
   if (!input_enum(rn, name,(int *)r)) return 0;
return 1;
}

int input_vup(char *rn,struct acerep_var_usage **r,int isptr,int arr) { /* typedef4 */
   if (!input_ptr_ok()) {*r=0; return 1;}
   *r=acl_malloc2_With_Context(sizeof(acerep_var_usage)); if (!input_acerep_var_usage("acerep_var_usage",*r,0,-1)) return 0;
return 1;
}
int input_format(char *rn,format *r,int isptr,int arr) {
char *name;
name="format";
#ifdef DEBUG
A4GL_debug("input_format");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("format",rn,isptr,arr)) return 0;
   if (!input_formattype("category",&r->category,0,-1)) return 0;

   if (!input_ptr_ok()) r->column=0;
   else r->column=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("column",r->column,1,-1)) return 0;

   if (!input_acerep_commands("commands",&r->commands,0,-1)) return 0;
if (!input_end_struct("format",rn)) return 0;
return 1;
}

int input_agg_val(char *rn,agg_val *r,int isptr,int arr) {
char *name;
name="agg_val";
#ifdef DEBUG
A4GL_debug("input_agg_val");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("agg_val",rn,isptr,arr)) return 0;
   if (!input_int("format_id",&r->format_id,0,-1)) return 0;
   if (!input_aggtypes("type",&r->type,0,-1)) return 0;
   if (!input_int("isgroup",&r->isgroup,0,-1)) return 0;

   if (!input_ptr_ok()) r->expr=0;
   else r->expr=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("expr",r->expr,1,-1)) return 0;


   if (!input_ptr_ok()) r->wexpr=0;
   else r->wexpr=acl_malloc2_With_Context(sizeof(expr));
   if (!input_expr("wexpr",r->wexpr,1,-1)) return 0;

if (!input_end_struct("agg_val",rn)) return 0;
return 1;
}

int input_report(char *rn,report *r,int isptr,int arr) {
char *name;
name="report";
#ifdef DEBUG
A4GL_debug("input_report");
#endif
if (isptr==1&&r==0) return 1; /* Its just a null pointer */
if (!input_start_struct("report",rn,isptr,arr)) return 0;
   if (!input_string("magic",&r->magic,0,-1)) return 0;
   if (!input_string("report_name",&r->report_name,0,-1)) return 0;
   if (!input_string("dbname",&r->dbname,0,-1)) return 0;
   if (!input_ascii("ascii",&r->ascii,0,-1)) return 0;
   if (!input_start_array("functions",1,(int *)&r->functions.functions_len)) return 0;
   {
      int cnt; if (r->functions.functions_len) {
      r->functions.functions_val=acl_malloc2_With_Context(r->functions.functions_len*sizeof(r->functions.functions_val[0]));
      for (cnt=0;cnt<r->functions.functions_len;cnt++) {
         if (!input_a4gl_report_function("functions",&r->functions.functions_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->functions.functions_val=0;}
   }
   if (!input_end_array("a4gl_report_function",1)) return 0;
   if (!input_start_array("variables",1,(int *)&r->variables.variables_len)) return 0;
   {
      int cnt; if (r->variables.variables_len) {
      r->variables.variables_val=acl_malloc2_With_Context(r->variables.variables_len*sizeof(r->variables.variables_val[0]));
      for (cnt=0;cnt<r->variables.variables_len;cnt++) {
         if (!input_acerep_variable("variables",&r->variables.variables_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->variables.variables_val=0;}
   }
   if (!input_end_array("acerep_variable",1)) return 0;
   if (!input_start_array("inputs",1,(int *)&r->inputs.inputs_len)) return 0;
   {
      int cnt; if (r->inputs.inputs_len) {
      r->inputs.inputs_val=acl_malloc2_With_Context(r->inputs.inputs_len*sizeof(r->inputs.inputs_val[0]));
      for (cnt=0;cnt<r->inputs.inputs_len;cnt++) {
         if (!input_input_vals("inputs",&r->inputs.inputs_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->inputs.inputs_val=0;}
   }
   if (!input_end_array("input_vals",1)) return 0;
   if (!input_output("output",&r->output,0,-1)) return 0;
   if (!input_get_data("getdata",&r->getdata,0,-1)) return 0;
   if (!input_start_array("fmt",1,(int *)&r->fmt.fmt_len)) return 0;
   {
      int cnt; if (r->fmt.fmt_len) {
      r->fmt.fmt_val=acl_malloc2_With_Context(r->fmt.fmt_len*sizeof(r->fmt.fmt_val[0]));
      for (cnt=0;cnt<r->fmt.fmt_len;cnt++) {
         if (!input_format("fmt",&r->fmt.fmt_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->fmt.fmt_val=0;}
   }
   if (!input_end_array("format",1)) return 0;
   if (!input_start_array("aggs",1,(int *)&r->aggs.aggs_len)) return 0;
   {
      int cnt; if (r->aggs.aggs_len) {
      r->aggs.aggs_val=acl_malloc2_With_Context(r->aggs.aggs_len*sizeof(r->aggs.aggs_val[0]));
      for (cnt=0;cnt<r->aggs.aggs_len;cnt++) {
         if (!input_agg_val("aggs",&r->aggs.aggs_val[cnt],0,cnt)) return 0; /*MJALI2*/
      }
   } else {r->aggs.aggs_val=0;}
   }
   if (!input_end_array("agg_val",1)) return 0;
if (!input_end_struct("report",rn)) return 0;
return 1;
}

