%{
#define YYLEX_PARAM yystate
#define YY_DECL int yylex(int yystate)
int sqlparse_yylex(int yystate);
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "a4gl_libaubit4gl.h"
#include "dataio/fgl.xs.h"
#include "a4gl_expr.h"
#include "alias.h"
//#include "sqlcompiler.h"

#define SQL_SET_EXPLAIN_OFF 1
#define SQL_SET_LOCK_MODE_WAIT_N 2
#define SQL_SET_LOCK_MODE_NOT_WAIT 3
#define SQL_SET_ISOLATION_DIRTY_READ 4
#define SQL_SET_ISOLATION_REPEATABLE_READ 5
#define SQL_SET_ISOLATION_CURSOR_STABILITY 6 
#define SQL_SET_ISOLATION_COMMITTED_READ 7


#define A4GL_add_feature sqlc_A4GL_add_feature
#define A4GL_cursor_current sqlc_A4GL_cursor_current
#define A4GL_warn sqlc_A4GL_warn
#define add_feature sqlc_A4GL_add_feature
#define add_sql_function sqlc_add_sql_function
#define expand_slil sqlc_expand_slil
#define expand_slil sqlc_expand_slil
#define generate_update_column_list_for sqlc_generate_update_column_list_for
#define generate_update_column_list_for sqlc_generate_update_column_list_for
#define local_add_select_list_item_list sqlc_local_add_select_list_item_list
#define local_add_select_list_item_list sqlc_local_add_select_list_item_list
#define set_ignore_indicators sqlc_set_ignore_indicators
#define clr_ignore_indicators sqlc_clr_ignore_indicators
#define local_new_select_list_item_list sqlc_local_new_select_list_item_list
#define addmap sqlc_addmap
#define map_select_stmt sqlc_map_select_stmt
#define map_create_temp sqlc_map_create_temp
#define A4GL_db_used sqlc_A4GL_db_used
#define map_delete_update sqlc_map_delete_update

void add_sql_function(char *s);
void map_select_stmt (char *main_statement_type, struct s_select *select);
void map_create_temp(char *tab, char *src);

void A4GL_add_feature (char *feature);


int A4GL_cursor_current(expr_str *s);
struct s_select_list_item_list *expand_slil(struct s_select_list_item_list *l);
char *get_insert_cmd (struct struct_insert_cmd *insertCmd,int *converted);
char *get_update_cmd(struct struct_update_cmd *updateCmd, int *converted) ;
char * get_delete_cmd (struct struct_delete_cmd *deleteCmd, int *converted) ;

str_list *generate_update_column_list_for(char *tabname,struct s_select_list_item_list *valuelist);
extern int place_holder_cnt;
void A4GL_warn(char *s);

extern char *kw_space;
extern char *kw_comma;
extern char *kw_ob;
extern char *kw_cb;

#define insql c_sql_insql
int c_sql_insql=0;
static char *make_sql_string_and_free(char *,...);
char last_tmp_name[256];
#define ADDMAP(x,y) addmap_runtime(x,y)
#define ADDMAP_MODULE(x,y) addmap_runtime(x,y)

int yylineno;
//int table_cnt=0;
//char* curr_func="";
//char *infilename="";
static int doing_declare=0;
#define YY_NEVER_INTERACTIVE 1

char current_upd_table[256];
char current_del_table[256];
#define DEFINED_INS_TABLE
char current_ins_table[256];

#define a4gl_yyerror sqlparse_yyerror


static void print_sql_commit (int n) ;
static void print_exec_sql (char *s) ;
static void print_exec_select (char *s)    ;
static void conn_db (char *s) ;
static void print_unable_to_parse(void) ;
static int A4GLSQLCV_process(void);
static int sqlparse_yyerror(char *s) ;
int A4GL_4glc_push_gen_expand(int n,char *v);



static void ansi_violation(char *s,int n);
static void addmap_runtime (char *s,char *f);

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#ifdef SIMPLIFIED
#include "y_tab.h"
#else
#include "y.tab.h"
#endif
struct s_select_list_item_list * local_new_select_list_item_list(  struct s_select_list_item *i) ;
struct s_select_list_item_list * local_add_select_list_item_list( struct s_select_list_item_list *p, struct s_select_list_item *i);

#define GEN_STACK_HERE
#include "a4gl_gen_stack.h"

int sql_string_cnt=0;
int this_sql_start=0;
char *Sql=0;
FILE *Sql_file;
int input_from_file=0;
extern char* yytext;

extern FILE *yyin;
extern int sqlparse_yydebug;
int process(void) ;
char *sql_string;
int sql_type;
int was_ok=0;
/*
struct sql_stmt {
        int type;
        char *val;
};

struct sql_stmt *stmts=0;
*/

int db_used=0;
//char *acl_getenv(char *s);

%}
%name-prefix "sqlparse_yy"
%lex-param {yystate}
%start sql_statement
%union    {
        char    str[8192];
   char *sql_string;
	struct  ilist int_list;
	struct s_table *u_table;
	struct s_select_finish *s_select_finish;
        struct s_select_list_item_list *s_select_list_item_list;
        struct s_select_list_item *s_select_list_item;
        struct s_select *s_select;
        int     integer_val;
        float   float_val;
	enum e_boolean e_boolean;
	 struct expr_str_list *ptr_list;
	        struct struct_update_cmd *update_cmd;
        struct struct_insert_cmd *insert_cmd;
        struct struct_delete_cmd *delete_cmd;
        struct s_update_pair *upd_pair;
        struct expr_str *ptr;
        struct str_list *str_list;


}
//%expect 175
%token INT_VALUE
%token NAMED
%token NAMED_GEN
%token CHAR_VALUE
%token NOT_USED_1
%token NOT_USED_2
%token NOT_USED_3
%token NOT_USED_4
%token NOT_USED_5
%token NOT_USED_6
%token NOT_USED_7
%token NOT_USED_8
%token NUMBER_VALUE
%token SEMICOLON
%token QUESTION_MARK
%token CLINE
%token CH
%token MARK_VAR
%token END_MARK_VAR
%token END_DIALOG 1000
%token KW_TYPE_AS 1001
%token ACCEPT_DIALOG 1002
%token EXIT_DIALOG 1003
%token CONTINUE_DIALOG 1004
%token AFTER_DIALOG 1005
%token BEFORE_DIALOG 1006
%token BEFORE_PROMPT 1007
%token COUNT_OB 1009
%token SUM_OB 1010
%token XMAX_OB 1011
%token XMIN_OB 1012
%token AVG_OB 1013
%token PERCENT_OB 1014
%token WITH_LISTING_IN 1015
%token BACKQUOTE 1016
%token SET_UNDERLINE_ON 1017
%token SET_UNDERLINE_OFF 1018
%token SET_POSTGRESQL_SEARCH_PATH 1019
%token SET_CONSTRAINTS_ALL_DEFERRED 1020
%token KW_LIMIT 1021
%token DOCUMENT 1022
%token ON_EXCEPTION 1024
%token SET_DEBUG_FILE_TO 1025
%token CREATE_DBA_PROCEDURE 1030
%token CREATE_FUNCTION 1031
%token CREATE_DBA_FUNCTION 1032
%token USE_SESSION 1034
%token KW_RUN_CLIENT 1035
%token LEFT_JOIN 1037
%token IGNORE_ERRORS 1040
%token SQLERRMESSAGE 1041
%token DISPLAY_NULL_TO 1042
%token UNBUFFERED 1043
%token KW_PICTURE 1044
%token ON_CHANGE 1045
%token INNER_JOIN 1046
%token UI_INTERFACE_DOT_FRONTCALL 1049
%token UICOMBOBOX 1053
%token UIBROWSER 1054
%token UIPROGRESS 1055
%token UIGANTT 1056
%token UIFORM 1059
%token USING_BTREE 1075
%token USING_RTREE 1076
%token RESUME_PAGE 1087
%token FOR_EVERY_PAGE 1088
%token SET_BUFFERED_LOG 1097
%token SET_LOG 1100
%token MDY 1102
%token WEEKDAY 1103
%token MODE_ANSI 1106
%token START_DATABASE 1107
%token WITH_LOG_IN 1108
%token SET_CONSTRAINTS_ALL_IMMEDIATE 1109
%token AS_JSON 1117
%token KW_ASSIGN_JSON 1118
%token DATETIME_VALUE 1124
%token INTERVAL_VALUE 1125
%token RECOVER_TABLE 1126
%token ROLLFORWARD_DATABASE 1127
%token CONCAT_PIPES 1141
%token DROP_TRIGGER 1143
%token DROP_AUDIT_FOR 1144
%token CREATE_AUDIT_FOR 1145
%token EXECUTE_PROCEDURE 1149
%token APPEND_ROW_EQUAL_FALSE 1154
%token APPEND_ROW_EQUAL_TRUE 1155
%token AUTO_APPEND_EQUAL_FALSE 1156
%token AUTO_APPEND_EQUAL_TRUE 1157
%token CURRENT_FIELD_DISPLAY_EQUAL 1158
%token CURRENT_FIELD_DISPLAY 1159
%token CURRENT_ROW_DISPLAY 1160
%token ALTER_TABLE 1163
%token ALTER_INDEX 1164
%token NEXT_SIZE 1165
%token KW_WHENEVER_SIGNAL 1202
%token KW_SIGNAL_TOKEN 1203
%token XSET_MULTIPLY_EQUAL_OPEN_BRACKET 1204
%token XSET_ident_DOT_MULTIPLY_EQUAL_OPEN_BRACKET 1205
%token XSET_ident_DOT_MULTIPLY_EQUAL 1206
%token XSET_MULTIPLY_EQUAL 1207
%token XSET_OPEN_BRACKET 1208
%token CREATE_DATABASE 1211
%token DROP_DATABASE 1212
%token ADD_CONSTRAINT 1214
%token DROP_CONSTRAINT 1215
%token DROP_SYNONYM 1216
%token CONSTRAINT 1217
%token NOT_FIELD_TOUCHED_CURRENT 1220
%token FIELD_TOUCHED_CURRENT 1221
%token OBJECT_FUNCTION 1223
%token DOUBLE_PRECISION 1229
%token COUNT_MULTIPLY 1230
%token KW_ASCII_OPEN_BRACKET 1239
%token MODIFY_NEXT_SIZE 1251
%token LOCK_MODE_PAGE 1252
%token LOCK_MODE_ROW 1253
%token TO_UI 1258
%token UNITS_YEAR 1261
%token UNITS_MONTH 1262
%token UNITS_DAY 1263
%token UNITS_HOUR 1264
%token UNITS_MINUTE 1265
%token UNITS_SECOND 1266
%token TO_CLUSTER 1271
%token TO_NOT_CLUSTER 1272
%token CREATE_UC_IDX 1274
%token CREATE_U_IDX 1275
%token CREATE_C_IDX 1276
%token CREATE_IDX 1277
%token DOUBLE_COLON 1287
%token SQLSICS 1293
%token CREATE_SCHEMA 1294
%token SQLSIRR 1295
%token UPDATESTATS_T 1296
%token SQLSICR 1297
%token SQLSIDR 1308
%token CREATE_TEMP_TABLE 1309
%token WITH_CHECK_OPTION 1317
%token WITH_GRANT_OPTION 1318
%token SQLSLMNW 1319
%token WHERE_CURRENT_OF 1325
%token NOT_NULL_UNIQUE 1333
%token SQLSLMW 1340
%token ALL_PRIVILEGES 1342
%token CREATE_SYNONYM 1346
%token DROP_TABLE 1347
%token INEXCLUSIVE 1349
%token REPORT_TO_FILE 1350
%token REPORT_TO_UI 1351
%token UPDATESTATS 1356
%token CREATE_TABLE 1382
%token DEFAULT_NULL 1383
%token DEFAULT_TODAY 1384
%token DEFAULT_USER 1385
%token EXIT_TODO 1392
%token CONTINUE_TODO 1393
%token UNLOCK_TABLE 1400
%token ROLLBACK_W 1408
%token SQLSEON 1410
%token SQLSEOFF 1411
%token CREATE_VIEW 1415
%token DELETE_FROM 1416
%token EXTENT_SIZE 1423
%token FOREIGN_KEY 1424
%token INSERT_INTO 1427
%token IS_NOT_NULL 1429
%token NOT_MATCHES 1432
%token PRIMARY_KEY 1438
%token WITH_NO_LOG 1445
%token INSHARE 1448
%token BEGIN_WORK 1454
%token DROP_INDEX 1459
%token FOR_UPDATE_OF 1465
%token FOR_UPDATE 1466
%token LOCK_TABLE 1471
%token NOT_EXISTS 1473
%token REFERENCES 1475
%token RENCOL 1476
%token SMALLFLOAT 1478
%token COMMIT_W 1489
%token RENTAB 1496
%token KW_CHAR 1499
%token NCHAR 1500
%token NVARCHAR 1501
%token LVARCHAR 1502
%token DELIMITER 1504
%token DROP_VIEW 1506
%token EXCLUSIVE 1509
%token GREATER_THAN_EQ 1513
%token INTO_TEMP 1515
%token DATABASE 1539
%token DATETIME 1540
%token DISTINCT 1542
%token FRACTION 1549
%token GROUP_BY 1551
%token INTERVAL 1552
%token NOT_LIKE 1554
%token NOT_ILIKE 1555
%token NOT_NULL 1556
%token RESOURCE 1562
%token SMALLINT 1563
%token IS_NULL 1569
%token LESS_THAN_EQ 1570
%token BETWEEN 1572
%token CLOSE_BRACKET 1575
%token CONNECT 1578
%token KW_CURRENT 1579
%token KW_DECIMAL 1581
%token KW_DEFAULT 1583
%token FGL_SYNCFIELDS 1591
%token INTEGER 1592
%token INTEGER8 1593
%token SERIAL8 1594
%token MATCHES 1597
%token VARCHAR 1610
%token CLOSE_SQUARE 1613
%token GREATER_THAN 1614
%token KW_FALSE 1615
%token NOT_IN 1616
%token OPEN_BRACKET_SELECT 1618
%token OPEN_BRACKET 1619
%token KW_DELETE 1627
%token KW_ESCAPE 1630
%token EXISTS 1631
%token EXTEND 1632
%token HAVING 1636
%token KW_INSERT 1638
%token MINUTE 1642
%token MODIFY 1643
%token EQUAL 1645
%token NOT_EQUAL 1646
%token OPEN_SQUARE 1648
%token PUBLIC 1652
%token KW_RETURN_KEY 1655
%token REVOKE 1657
%token SECOND 1661
%token KW_SELECT 1665
%token SERIAL 1666
%token UNIQUE 1669
%token KW_UPDATE 1671
%token VALUES 1672
%token KW_NULL 1675
%token KW_TRUE 1676
%token ALTER 1678
%token CHECK 1684
%token KW_FIRST 1692
%token KW_FLOAT 1693
%token GRANT 1696
%token INDEX 1699
%token LESS_THAN 1702
%token MONEY 1704
%token MONTH 1705
%token KW_MULTIPLY 1707
%token ORDER 1708
%token OUTER 1709
%token UNION 1718
%token WHERE 1721
%token KW_BYTE 1728
%token CASE 1730
%token KW_DATE 1732
%token DESC 1733
%token KW_DIVIDE 1734
%token KW_SHTAB 1737
%token DROP 1738
%token ELSE 1739
%token FROM 1743
%token HOUR 1749
%token INTO 1750
%token LIKE 1753
%token REAL 1762
%token SOME 1767
%token KW_TEXT 1771
%token KW_THEN 1772
%token USER 1773
%token WHEN 1775
%token YEAR 1778
%token KW_DOW 1779
%token XSET 1781
%token ADD 1782
%token ALL 1783
%token KW_AND 1784
%token ANY 1785
%token ASC 1786
%token AVG 1787
%token COLON 1788
%token ESCAPEDSQLCOLON 1789
%token ESCAPEDSQLDOLLAR 1790
%token KW_COMMA 1791
%token DAY 1792
%token DBA 1793
%token KW_FOR 1797
%token XMAX 1802
%token XMIN 1803
%token KW_MINUS 1804
%token KW_MOD 1805
%token KW_NOT 1806
%token KW_SUM 1813
%token ATSIGN 1816
%token KW_PLUS 1817
%token KW_AS 1823
%token KW_BY 1825
%token KW_DOT 1826
%token KW_IN 1829
%token KW_ON 1831
%token KW_OR 1832
%token KW_TO 1833
%token BEFORE 1871
%token END 1875
%token TILDE 1882
%token ILIKE 1883
%token FILLFACTOR 1886
%token TIME 1891
%token KW_TODAY 1898
%token KW_ROWID 1899
%token TIMESTAMP 2247
%token KWPIPE 2277
%token COUNT 2290
%token DIALOG 2291
%token SUBDIALOG 2292
%token PDF_XY 2293
%token SET_VALUE 2294
%token KW_EMBEDDED 2295
%token KW_BOOLEAN 2296
%token WITHOUT_SCROLL 2297
%%

/*
=====================================================================
                        Source: update.rule
=====================================================================
*/


update_statement_c:
	KW_UPDATE table_name_not_for_column_prefix  atline set_clause_list_uc  where_upd_p {
		if ($<ptr>5==0 && $<integer_val>2>=0) {
   				if (A4GL_isyes(acl_getenv("A4GL_ERR_UPDNOWHERE"))) {
                                        yylineno=$<integer_val>3;
                                        a4gl_yyerror("UPDATE with no WHERE clause");
                                } else {
		 			A4GL_warn("UPDATE with no WHERE clause"); 
				}
		}
		$<update_cmd>$=$<update_cmd>4;
		$<update_cmd>$->table=strdup($<str>2);
		$<update_cmd>$->where_clause=$<ptr>5;
		$<update_cmd>$->value_list=expand_slil($<update_cmd>$->value_list);

		if ($<update_cmd>$->column_list==0) {
			char colname[200];
			int idtype;
			int isize;
			int rval;
			rval = A4GLSQL_get_columns ($<str>2, colname, &idtype, &isize);
			if (rval) {
				$<update_cmd>$->column_list=generate_update_column_list_for($<str>2,  $<update_cmd>$->value_list);
			}
		}
	}
;



where_upd_p : {
		$<ptr>$=0;
	}
	| WHERE_CURRENT_OF fetch_cursor_name_p { 
		if (A4GLSQLCV_check_requirement("NO_FOR_UPDATE"))  {
			a4gl_yyerror("Your database cannot seem to handle FOR UPDATE");
		} else {

		//rm_quotes($<str>2);
		// THIS IS HIGHLY DANGEROUS - NEVER SET DROP_WHERE_CURRENT_OF 
		// UNLESS YOU REALLY KNOW WHAT YOU ARE DOING!!!!
		if (A4GL_isyes(acl_getenv("DROP_WHERE_CURRENT_OF"))) {
			$<ptr>$=0;
		} else {
			$<ptr>$=A4GL_new_expr_simple_expr($<ptr>2, ET_EXPR_WHERE_CURRENT_OF);
			A4GL_cursor_current($<ptr>2);
		}
		add_feature("UPDATE_WHERE_CURRENT_OF");
		}
	}
	| WHERE search_condition_sli {
		$<ptr>$=A4GL_new_select_list_item_expr($<s_select_list_item>2);
	}
	;

where_del_p : {
		$<ptr>$=0;
	}
	| WHERE_CURRENT_OF fetch_cursor_name_p { 
		if (A4GLSQLCV_check_requirement("NO_FOR_UPDATE"))  {
			a4gl_yyerror("Your database cannot seem to handle FOR UPDATE");
		} else {

		//rm_quotes($<str>2);
		// THIS IS HIGHLY DANGEROUS - NEVER SET DROP_WHERE_CURRENT_OF 
		// UNLESS YOU REALLY KNOW WHAT YOU ARE DOING!!!!
		if (A4GL_isyes(acl_getenv("DROP_WHERE_CURRENT_OF"))) {
				$<ptr>$=0;
		} else {
			$<ptr>$=A4GL_new_expr_simple_expr($<ptr>2, ET_EXPR_WHERE_CURRENT_OF);
                        A4GL_cursor_current($<ptr>2);
		}
		add_feature("DELETE_WHERE_CURRENT_OF");
		}
	}
	| WHERE search_condition_sli {
		 $<ptr>$=A4GL_new_select_list_item_expr($<s_select_list_item>2);
	}
;

set_clause_list_uc: 
    XSET_OPEN_BRACKET upd_col_list_sl CLOSE_BRACKET EQUAL OPEN_BRACKET upd_val_list_slil CLOSE_BRACKET {
		add_feature("UPDATE_COLUMNLIST_EQ_VALUELIST");
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=$<str_list>2;
		$<update_cmd>$->value_list=$<s_select_list_item_list>6;
		$<update_cmd>$->where_clause=0;
    }
    | XSET_MULTIPLY_EQUAL_OPEN_BRACKET upd_val_list_slil CLOSE_BRACKET {	
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		/* A column list of 0 means .* */
		$<update_cmd>$->value_list=$<s_select_list_item_list>2;
		$<update_cmd>$->where_clause=0;
		add_feature("UPDATE_SET_STAR");
    }
    | XSET_ident_DOT_MULTIPLY_EQUAL_OPEN_BRACKET upd_val_list_slil CLOSE_BRACKET {	
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		/* A column list of 0 means .* */
		$<update_cmd>$->value_list=$<s_select_list_item_list>2;
		$<update_cmd>$->where_clause=0;
		 add_feature("UPDATE_SET_STAR");
    }
    | XSET upd_columns_uc  {
		$<update_cmd>$=$<update_cmd>2;
		add_feature("UPDATE_COLUMN_EQ_VALUE_LIST");
    }



    | XSET_MULTIPLY_EQUAL upd_val_list_slil {
		char buff[200];
		SPRINTF1(buff,"%s.*", $<str>2);
#ifdef SQLCOMPILER
		$<sql_string>$=strdup("IMPOSSIBLE") ;
#else
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		//* A column list of 0 means .* 
		$<update_cmd>$->value_list=$<s_select_list_item_list>2;
		$<update_cmd>$->where_clause=0;

#endif
	}
    | XSET_ident_DOT_MULTIPLY_EQUAL upd_val_list_slil  {
		char buff[200];
		SPRINTF1(buff,"%s.*", $<str>2);
#ifdef SQLCOMPILER
		$<sql_string>$=strdup("IMPOSSIBLE") ;
#else
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		//* A column list of 0 means .*
		$<update_cmd>$->value_list=$<s_select_list_item_list>2;
		//$<update_cmd>$->value_list=make_select_list_item_list_from_variable_record(buff); 
		$<update_cmd>$->where_clause=0;
#endif
	}

/*
    | XSET_MULTIPLY_EQUAL identifier KW_DOT KW_MULTIPLY  {
		char buff[200];
		SPRINTF1(buff,"%s.*", $<str>2);
#ifdef SQLCOMPILER
		$<sql_string>$=strdup("IMPOSSIBLE") ;
#else
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		//* A column list of 0 means .* 
		$<update_cmd>$->value_list=make_select_list_item_list_from_variable_record(buff); 
		$<update_cmd>$->where_clause=0;

#endif
	}
    | XSET_ident_DOT_MULTIPLY_EQUAL identifier KW_DOT KW_MULTIPLY  {
		char buff[200];
		SPRINTF1(buff,"%s.*", $<str>2);
#ifdef SQLCOMPILER
		$<sql_string>$=strdup("IMPOSSIBLE") ;
#else
		$<update_cmd>$=malloc(sizeof(struct struct_update_cmd));
		$<update_cmd>$->connid=0;
		$<update_cmd>$->table=0;
		$<update_cmd>$->column_list=0; 		//* A column list of 0 means .* 
		$<update_cmd>$->value_list=make_select_list_item_list_from_variable_record(buff); 
		$<update_cmd>$->where_clause=0;
#endif
	}
*/


;




upd_columns_uc : 
	col_1_up  {
		$<update_cmd>$=malloc(sizeof(struct_update_cmd));
		$<update_cmd>$->column_list=new_str_list($<upd_pair>1->column_name);
		$<update_cmd>$->value_list=0;
		$<update_cmd>$->where_clause=0;
		$<update_cmd>$->value_list=local_new_select_list_item_list($<upd_pair>1->value);
	}
	| upd_columns_uc KW_COMMA col_1_up {
		$<update_cmd>$=$<update_cmd>1;
		add_str_list($<update_cmd>$->column_list, $<upd_pair>3->column_name);
		local_add_select_list_item_list($<update_cmd>$->value_list, $<upd_pair>3->value);
	}
;




upd_column_name :
        upd_column_name_specific {
                strcpy($<str>$,$<str>1);
        }
        | ATSIGN upd_column_name_specific {
                strcpy($<str>$,$<str>2);
        }
;

upd_column_name_specific: identifier op_col_arr {
                struct ilist *i;
                i=&$<int_list>2;
                if (strcmp($<str>1,"rowid")==0) { add_feature("ROWID"); }
                ADDMAP("Use Column",$<str>1);
                strcpy($<str>$,A4GLSQLCV_make_substr(A4GL_confirm_colname(current_upd_table,$<str>1), i->i0,i->i1,i->i2));
        }
        | identifier KW_DOT identifier op_col_arr {
                struct ilist *i;
                if (strcmp($<str>3,"rowid")==0) { add_feature("ROWID"); }
                if (A4GLSQLCV_check_requirement("NO_UPDATE_TABLE")) {
                        strcpy($<str>$,$<str>3);
                } else {
                        if (A4GLSQLCV_check_requirement("OMIT_UPDATE_TABLE")) {
                                SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(current_upd_table,$<str>3));
                        } else {
                                SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(A4GLSQLCV_ownerize_tablename(NULL,$<str>1),$<str>3));
                        }
                }

                ADDMAP("Use Column",$<str>$);
                i=&$<int_list>4;
                strcpy($<str>$,A4GLSQLCV_make_substr($<str>$,i->i0,i->i1,i->i2));
        }
        | identifier KW_DOT identifier  KW_DOT identifier op_col_arr {
                struct ilist *i;
                if (strcmp($<str>5,"rowid")==0) { add_feature("ROWID"); }
                if (A4GLSQLCV_check_requirement("NO_UPDATE_TABLE")) {
                        strcpy($<str>$,$<str>5);
                } else {
                        if (A4GLSQLCV_check_requirement("OMIT_UPDATE_TABLE")) {
                                SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(current_upd_table,$<str>5));
                        } else {
                                SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(A4GLSQLCV_ownerize_tablename($<str>1,$<str>3),$<str>5));
                        }
                }

                ADDMAP("Use Column",$<str>$);
                i=&$<int_list>6;
                strcpy($<str>$,A4GLSQLCV_make_substr($<str>$,i->i0,i->i1,i->i2));
        }
        | identifier  KW_DOT KW_MULTIPLY {
                if (A4GLSQLCV_check_requirement("NO_UPDATE_TABLE")) {
                        strcpy($<str>$,"*");
                } else {
                if (A4GLSQLCV_check_requirement("OMIT_UPDATE_TABLE")) {
                        SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(current_upd_table,"*"));
                } else {
                        SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(A4GLSQLCV_ownerize_tablename(NULL,$<str>1),"*"));
                }
                }

                ADDMAP("Use Column",$<str>$);
        }
;






col_1_up : 
	upd_column_name EQUAL upd_val_sli {
		$<upd_pair>$=malloc(sizeof(struct s_update_pair));
		$<upd_pair>$->column_name=acl_strdup($<str>1);
		$<upd_pair>$->value=$<s_select_list_item>3;
	}
;



upd_col_list_sl  : upd_column_name	{
			$<str_list>$=new_str_list($<str>1);
		} 
		| upd_col_list_sl KW_COMMA upd_column_name {
			$<str_list>$=add_str_list($<str_list>1, $<str>3);
		}
;



upd_val_list_slil  : 
	upd_val_sli { 
		$<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
	| upd_val_list_slil KW_COMMA upd_val_sli { 
		$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	} 
;



upd_val_sli : 
	value_expression_sli  {$<s_select_list_item>$=$<s_select_list_item>1;}
	| KW_NULL  {$<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_NULL); }
;


/* ================= schema.rule ============== */


drops_statement : drops_c  { $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1), NULL);}
	;

drops_c : DROP_TABLE table_name_not_for_column_prefix {
			if (A4GLSQLCV_check_requirement("ADD_CASCADE")) {
				SPRINTF2($<str>$, "%s %s CASCADE",$<str>1, $<str>2);
			} else {
				SPRINTF2($<str>$, "%s %s",$<str>1, $<str>2);
			}
			add_feature("DROP_TABLE");
		}
	| DROP_VIEW table_name_not_for_column_prefix 		{SPRINTF2($<str>$,"%s %s ",$<str>1,$<str>2);
			add_feature("DROP_VIEW");
}
	| DROP_INDEX idx_name 		{SPRINTF2($<str>$,"%s %s",$<str>1,$<str>2);
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("DROP_INDEX_QUALIFIED_PATH");
			add_feature("DROP_INDEX");
}
	| DROP_TRIGGER identifier 	{SPRINTF2($<str>$,"%s %s",$<str>1,$<str>2);
			add_feature("DROP_TRIGGER");
}
;


create_statement_ss : create_c_1  {$<sql_string>$=acl_strdup($<str>1);}
	| create_c_2_ss  {$<sql_string>$=$<sql_string>1;}
;

create_c_2_ss  : 
	CREATE_TABLE table_name_not_for_column_prefix OPEN_BRACKET table_element_list_ss CLOSE_BRACKET opt_cr_table_extra {
                if (A4GLSQLCV_check_requirement ("ADD_WITH_OIDS")) {
                        $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),kw_space,kw_ob,$<sql_string>4,kw_cb,acl_strdup(" WITH OIDS "),acl_strdup($<str>6),NULL);
                } else {
                        $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),kw_space,kw_ob,$<sql_string>4,kw_cb,acl_strdup($<str>6),NULL);
                }

		add_feature("CREATE_TABLE");
	} 

	| CREATE_TEMP_TABLE table_name_not_for_column_prefix OPEN_BRACKET table_element_list_ss CLOSE_BRACKET op_no_log opt_cr_table_extra op_no_log {
		char *tstr;
		tstr="";
		if (strlen($<str>6)) tstr=$<str>6;
		if (strlen($<str>8)) tstr=$<str>8;
		map_create_temp($<str>2,$<sql_string>4);
		$<sql_string>$=A4GLSQLCV_create_temp_table($<str>2,$<sql_string>4,tstr,$<str>7);
		add_feature("CREATE_TEMP_TABLE");
		acl_free($<sql_string>4);
	}

;


opt_cr_table_extra : {strcpy($<str>$,"");} |
	cr_table_extra {strcpy($<str>$,$<str>1);}
;

cr_table_extra :
	cr_table_extra_entry |
	cr_table_extra cr_table_extra_entry {SPRINTF2($<str>$,"%s%s",$<str>1,$<str>2); }
;


cr_table_extra_entry : 
	KW_IN space_name {
			add_feature("CREATE_TABLE_IN");
                        if (A4GLSQLCV_check_requirement("OMIT_TABLE_IN")) {
                                strcpy($<str>$,"");
			} else {
				SPRINTF1($<str>$," IN %s",$<str>2);
			}
		}
	| EXTENT_SIZE INT_VALUE {
			add_feature("CREATE_TABLE_WITH_EXTENT_SIZE");
                        if (A4GLSQLCV_check_requirement("OMIT_TABLE_EXTENTS")) {
                                strcpy($<str>$,"");
			} else {
				SPRINTF1($<str>$," EXTENT SIZE %s",$<str>2); 
			}
	}
	| NEXT_SIZE INT_VALUE {
			add_feature("CREATE_TABLE_WITH_NEXT_EXTENT_SIZE");
                        if (A4GLSQLCV_check_requirement("OMIT_TABLE_EXTENTS")) {
                                strcpy($<str>$,"");
			} else {
				SPRINTF1($<str>$," NEXT SIZE %s",$<str>2); 
			}
	}
	| LOCK_MODE_PAGE {
			add_feature("CREATE_TABLE_LOCK_MODE"); 
                        if (A4GLSQLCV_check_requirement("OMIT_LOCK_MODE")) {
                                strcpy($<str>$,"");
			} else {
				SPRINTF0($<str>$," LOCK MODE PAGE"); 
			}
	}
	| LOCK_MODE_ROW {
			add_feature("CREATE_TABLE_LOCK_MODE");
                        if (A4GLSQLCV_check_requirement("OMIT_LOCK_MODE")) {
                                strcpy($<str>$,"");
			} else {
				SPRINTF0($<str>$," LOCK MODE ROW"); 
			}
	}
;

space_name : NAMED;

op_cr_index_extra: {strcpy($<str>$,"");} | cr_index_extra {strcpy($<str>$,$<str>1);}
;

cr_index_extra : cr_index_extra_entry 
	| cr_index_extra cr_index_extra_entry {SPRINTF2($<str>$,"%s%s",$<str>1,$<str>2);}
;

cr_index_extra_entry :
        KW_IN space_name {
                        if (A4GLSQLCV_check_requirement("OMIT_INDEX_IN")) {
                                strcpy($<str>$,"");
                        } else {
                                SPRINTF1($<str>$," IN %s",$<str>2); add_feature("INDEX_IN");
                        }
        }
        | FILLFACTOR INT_VALUE {
                        if (A4GLSQLCV_check_requirement("OMIT_INDEX_FILLFACTOR")) {
                                strcpy($<str>$,"");
                        } else {
                                SPRINTF1($<str>$,"FILLFACTOR %s",$<str>2); add_feature("INDEX_FILLFACTOR");
                        }
        }
        | USING_BTREE {
                        if (A4GLSQLCV_check_requirement("OMIT_INDEX_USING")) {
                                strcpy($<str>$,"");
                        } else {
                                strcpy($<str>$,"USING BTREE"); add_feature("INDEX_BTREE");
                        }
        }
        | USING_RTREE {
                        if (A4GLSQLCV_check_requirement("OMIT_INDEX_USING")) {
                                strcpy($<str>$,"");
                        } else {
                                strcpy($<str>$,"USING RTREE"); add_feature("INDEX_RTREE");
                        }
        }
;

cr_table_name: table_name_not_for_column_prefix { strcpy(last_tmp_name,$<str>1); } ;


create_c_1  : 
	CREATE_U_IDX idx_name KW_ON cr_table_name OPEN_BRACKET idx_column_list CLOSE_BRACKET op_cr_index_extra {SPRINTF7($<str>$,"CREATE UNIQUE INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
		add_feature("CREATE_INDEX");
		add_feature("CREATE_INDEX_UNIQUE");
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("CREATE_INDEX_QUALIFIED_PATH");
		if (strchr($<str>6,',')) { add_feature("CREATE_INDEX_COMPOSITE"); }
	
} 
	| CREATE_UC_IDX idx_name KW_ON cr_table_name OPEN_BRACKET idx_column_list CLOSE_BRACKET op_cr_index_extra {
		add_feature("CREATE_INDEX");
		add_feature("CREATE_INDEX_UNIQUE");
		add_feature("CLUSTER_INDEX");
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("CREATE_INDEX_QUALIFIED_PATH");
		if (strchr($<str>6,',')) { add_feature("CREATE_INDEX_COMPOSITE"); }
		if (A4GLSQLCV_check_requirement("OMIT_INDEX_CLUSTER")) {
		SPRINTF7($<str>$,"CREATE UNIQUE INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
		} else {
		SPRINTF7($<str>$,"CREATE UNIQUE CLUSTER INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
		}
	} 
	| CREATE_C_IDX idx_name KW_ON cr_table_name OPEN_BRACKET idx_column_list CLOSE_BRACKET op_cr_index_extra {
		add_feature("CREATE_INDEX");
		add_feature("CLUSTER_INDEX");
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("CREATE_INDEX_QUALIFIED_PATH");
		if (strchr($<str>6,',')) { add_feature("CREATE_INDEX_COMPOSITE"); }
		if (A4GLSQLCV_check_requirement("OMIT_INDEX_CLUSTER")) {
			SPRINTF7($<str>$,"CREATE INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
		} else {
			SPRINTF7($<str>$,"CREATE CLUSTER INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
		}
	} 
	| CREATE_IDX idx_name KW_ON cr_table_name OPEN_BRACKET idx_column_list CLOSE_BRACKET op_cr_index_extra {
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("CREATE_INDEX_QUALIFIED_PATH");
		if (strchr($<str>6,',')) { add_feature("CREATE_INDEX_COMPOSITE"); }
			add_feature("CREATE_INDEX");
			SPRINTF7($<str>$," CREATE INDEX %s %s %s %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7,$<str>8);
	} 
	| CREATE_DATABASE var_ident_vl {
		add_feature("CREATE_DATABASE");
		a4gl_yyerror("You cannot create a database from within Aubit4gl - if the target database allows - prepare and execute it manually");
	}
	| DROP_DATABASE var_ident_vl {
		add_feature("DROP_DATABASE");
		a4gl_yyerror("You cannot drop a database from within Aubit4gl - if the target database allows - prepare and execute it manually");
	}
	| CREATE_SYNONYM table_name_not_for_column_prefix KW_FOR table_name_not_for_column_prefix { 
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("CREATE_SYNONYM_QUALIFIED_PATH");
			add_feature("CREATE_SYNONYM");
			SPRINTF3($<str>$,"%s %s FOR %s",$<str>1,$<str>2,$<str>4); 
	}
	| CREATE_AUDIT_FOR table_name_not_for_column_prefix KW_IN CHAR_VALUE { 
		add_feature("CREATE_AUDIT");
		SPRINTF2($<str>$,"CREATE AUDIT FOR %s IN '%s'",$<str>2,A4GL_strip_quotes($<str>4)); 
	}
	| DROP_AUDIT_FOR table_name_not_for_column_prefix  { 
		add_feature("DROP_AUDIT");
		SPRINTF1($<str>$,"DROP AUDIT FOR %s",$<str>2); }
	| DROP_SYNONYM table_name_not_for_column_prefix { 
		if (strchr($<str>2,'@') || strchr($<str>2,':')) add_feature("DROP_SYNONYM_QUALIFIED_PATH");
		add_feature("DROP_SYNONYM");
		SPRINTF2($<str>$,"%s %s",$<str>1,$<str>2); }
	| RECOVER_TABLE table_name_not_for_column_prefix { 
		add_feature("RECOVER_TABLE");
		SPRINTF1($<str>$,"RECOVER TABLE %s",$<str>2); }
	| ROLLFORWARD_DATABASE identifier { 
		add_feature("ROLLFORWARD_DATABASE");
		SPRINTF1($<str>$,"ROLLFORWARD DATABASE %s",$<str>2); }
;



op_no_log : {strcpy($<str>$,"");} 
	| WITH_NO_LOG {
		add_feature("SELECT_INTO_TEMP_WITH_NO_LOG");
		if (A4GLSQLCV_check_requirement("OMIT_NO_LOG")) {
			strcpy($<str>$,"");
		} else {
			SPRINTF1($<str>$," %s ",$<str>1);
		}
	}
;

op_no_log_i : {$<integer_val>$=0;}
	| WITH_NO_LOG { $<integer_val>$=1;}
;

idx_column_list : 
		idx_column 
		| idx_column_list KW_COMMA idx_column {SPRINTF2($<str>$,"%s,%s",$<str>1,$<str>3);}
;

idx_column : 
 identifier ASC {
		add_feature("CREATE_INDEX_ASC");
		strcpy($<str>$,A4GL_confirm_colname(last_tmp_name,$<str>1));
		if (A4GLSQLCV_check_requirement("OMIT_INDEX_ORDER")) {
			SPRINTF1($<str>$,"%s",$<str>1);
		} else {
			SPRINTF1($<str>$,"%s ASC",$<str>1);
		}
}
| identifier DESC {
		add_feature("CREATE_INDEX_DESC");
		strcpy($<str>$,A4GL_confirm_colname(last_tmp_name,$<str>1));
		if (A4GLSQLCV_check_requirement("OMIT_INDEX_ORDER")) {
			SPRINTF1($<str>$,"%s",$<str>1);
		} else {
			SPRINTF1($<str>$,"%s DESC",$<str>1);
		}
}
| identifier {
		strcpy($<str>$,A4GL_confirm_colname(last_tmp_name,$<str>1));
}
;


table_element_list_ss:
  	table_element_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| table_element_list_ss KW_COMMA table_element_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_comma,strdup("\n"),$<sql_string>3,NULL);
	}
;
	
table_element_ss:
	  ct_column_definiton_ss {
		$<sql_string>$=make_sql_string_and_free(strdup("   "),$<sql_string>1,NULL);
	}
	| table_constraint_definition_ss {
		$<sql_string>$=make_sql_string_and_free(strdup("   "),$<sql_string>1,NULL);
	}
	;
	






alter_statement_ss : ALTER_TABLE identifier alter_clauses_ss {
		add_feature("ALTER_TABLE");
	$<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),kw_space,$<sql_string>3,NULL);
	}
	| ALTER_INDEX idx_name TO_CLUSTER {
		add_feature("CLUSTER_INDEX");
		add_feature("ALTER_INDEX_CLUSTER");
		$<sql_string>$=make_sql_string_and_free(acl_strdup("ALTER INDEX "),acl_strdup($<str>2),acl_strdup(" TO CLUSTER"),NULL);
		}
	| ALTER_INDEX idx_name TO_NOT_CLUSTER {
		add_feature("ALTER_INDEX_NOT_CLUSTER");
		$<sql_string>$=make_sql_string_and_free(acl_strdup("ALTER INDEX "),acl_strdup($<str>2),acl_strdup(" TO NOT CLUSTER"),NULL);
		}
;

alter_clauses_ss:
	alter_clause_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| alter_clauses_ss KW_COMMA alter_clause_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_comma,$<sql_string>3,NULL);
	}


;


alter_clause_ss:
	alter_add_clause_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| alter_drop_clause {
	add_feature("ALTER_TABLE_DROP");
		$<sql_string>$=acl_strdup($<str>1);
	}
	| alter_modify_clause_ss {
	add_feature("ALTER_TABLE_MODIFY");
		$<sql_string>$=$<sql_string>1;
	}
	| alter_add_constraint_clause {
		add_feature("ALTER_TABLE_ADD_CONSTRAINT");
		$<sql_string>$=acl_strdup($<str>1);
	}
	| alter_drop_constraint_clause {
		add_feature("ALTER_TABLE_DROP_CONSTRAINT");
		$<sql_string>$=acl_strdup($<str>1);
	}
	| alter_modify_next {
		add_feature("ALTER_TABLE_MODIFY_NEXT");
		$<sql_string>$=acl_strdup($<str>1);
	}
	| alter_lock_mode {
		add_feature("ALTER_TABLE_LOCK_MODE");
		$<sql_string>$=acl_strdup($<str>1);
	}
;


alter_add_clause_ss:
	ADD add_column_clause_ss  {
		add_feature("ALTER_TABLE_ADD");
		$<sql_string>$=make_sql_string_and_free(acl_strdup("ADD "),$<sql_string>2,NULL);
	}
	| ADD OPEN_BRACKET add_column_clauses_ss CLOSE_BRACKET {
		add_feature("ALTER_TABLE_ADD");
		$<sql_string>$=make_sql_string_and_free(acl_strdup("ADD "),kw_ob,$<sql_string>3,kw_cb,NULL);
	}
;


add_column_clause_ss:
	table_element_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| table_element_ss BEFORE identifier {
		add_feature("ALTER_TABLE_ADD_BEFORE");
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,acl_strdup(" BEFORE "),acl_strdup($<str>3),NULL);
	}
;

add_column_clauses_ss:
	add_column_clause_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| add_column_clauses_ss KW_COMMA add_column_clause_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_comma,$<sql_string>3,NULL);
	}
;


alter_drop_clause:
	DROP drop_column {
		SPRINTF1($<str>$,"DROP %s",$<str>2);
	}
	| DROP OPEN_BRACKET drop_column_list CLOSE_BRACKET {
		SPRINTF1($<str>$,"DROP (%s)",$<str>3);
	}
;


drop_column_list:
	drop_column 
	| drop_column_list KW_COMMA drop_column {
		SPRINTF2($<str>$,"%s,%s",$<str>1,$<str>3);
	}
;

drop_column : identifier
;

alter_modify_clause_ss :
	MODIFY modify_column_clause_ss {
		$<sql_string>$=make_sql_string_and_free(acl_strdup("MODIFY "),$<sql_string>2,NULL);
	}
	| MODIFY OPEN_BRACKET modify_column_clauses_ss CLOSE_BRACKET {
		$<sql_string>$=make_sql_string_and_free(acl_strdup("MODIFY "),kw_ob,$<sql_string>3,kw_cb,NULL);
	}
;

modify_column_clauses_ss :
	modify_column_clause_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| modify_column_clauses_ss KW_COMMA modify_column_clause_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_comma,$<sql_string>3,NULL);
	}
;

modify_column_clause_ss :
	table_element_ss {
		$<sql_string>$=$<sql_string>1;
	}
;


alter_lock_mode :
	LOCK_MODE_PAGE {strcpy($<str>$,"LOCK MODE (PAGE)");}
	| LOCK_MODE_ROW {strcpy($<str>$,"LOCK MODE (ROW)");}
;

alter_modify_next :
	MODIFY_NEXT_SIZE INT_VALUE {
		add_feature("DDL_NEXT_SIZE");
		SPRINTF1($<str>$,"MODIFY NEXT SIZE %d",atoi($<str>2));
	}
;

alter_add_constraint_clause: ADD_CONSTRAINT table_constraint_definition_ss opt_constraint_name {
		add_feature("DDL_CONSTRAINT");
		SPRINTF2($<str>$,"ADD CONSTRAINT %s%s",$<sql_string>2,$<str>3);
	}
	| ADD_CONSTRAINT OPEN_BRACKET table_constraint_definition_list_ss CLOSE_BRACKET {
		add_feature("ADD_CONSTRAINT");
		SPRINTF1($<str>$,"ADD CONSTRAINT (%s)",$<sql_string>3);
	}
;


table_constraint_definition_list_ss: table_constraint_definition_ss opt_constraint_name {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,acl_strdup($<str>2),NULL);
} | table_constraint_definition_list_ss KW_COMMA table_constraint_definition_ss opt_constraint_name {
	$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_comma,$<sql_string>3,acl_strdup($<str>4), NULL);
}
;

opt_constraint_name : {strcpy($<str>$,"");  } 
		| CONSTRAINT identifier {SPRINTF2($<str>$," %s %s",$<str>1,$<str>2); add_feature("DDL_CONSTRAINT");  }
;

alter_drop_constraint_clause:
	DROP_CONSTRAINT constraint_names
		{ SPRINTF1($<str>$,"DROP CONSTRAINT %s",$<str>2); add_feature("DROP_CONSTRAINT"); }
	| DROP_CONSTRAINT OPEN_BRACKET constraint_names CLOSE_BRACKET {add_feature("DROP_CONSTRAINT");
		SPRINTF1($<str>$,"DROP CONSTRAINT (%s)",$<str>3);
	}
;

constraint_names :
	constraint_name {strcpy($<str>$,$<str>1);}
	| constraint_names KW_COMMA constraint_name {SPRINTF2($<str>$,"%s,%s",$<str>1,$<str>3);}
;

constraint_name: identifier
;


/*
=====================================================================
                        Source: sql1.rule
=====================================================================
*/

rollback_statement:
	ROLLBACK_W  {  add_feature("ROLLBACK_WORK"); }
;



insert_statement_c:
	INSERT_INTO { insql=1;} table_name_not_for_column_prefix  op_insert_column_list_sl  ins_2_ic {
		$<insert_cmd>$=$<insert_cmd>5;
		$<insert_cmd>$->connid=0;
		$<insert_cmd>$->table=acl_strdup($<str>3);
		A4GL_set_associated_mem($<insert_cmd>$, $<insert_cmd>$->table);
		$<insert_cmd>$->column_list=$<str_list>4;
	}
;

ins_2_ic : VALUES {insql=1;} OPEN_BRACKET insert_value_list_slil CLOSE_BRACKET { 
		$<insert_cmd>$=malloc(sizeof(struct_insert_cmd));
		$<insert_cmd>$->connid=0;
		$<insert_cmd>$->column_list=0;
		$<insert_cmd>$->table=0;
		$<insert_cmd>$->value_list=0;
		$<insert_cmd>$->subselect=0;
		$<insert_cmd>$->value_list= expand_slil($<s_select_list_item_list>4);
	}
	| query_specification_select {
				if ($<s_select>1->sf==0) {
				        $<s_select>1->sf=acl_malloc2(sizeof(struct s_select_finish));
					$<s_select>1->sf->order_by=0;
					$<s_select>1->sf->into_temp=0;
					$<s_select>1->sf->nolog=0;
					$<s_select>1->sf->insert_into=0;
					A4GL_set_associated_mem($<s_select>1, $<s_select>1->sf);
				}
				$<s_select>1->sf->insert_into=0;
		
        			map_select_stmt("SELECT",$<s_select>1);
				add_feature("INSERT_INTO_SELECT_FROM");
	        $<insert_cmd>$=malloc(sizeof(struct_insert_cmd));
                $<insert_cmd>$->connid=0;
                $<insert_cmd>$->column_list=0;
                $<insert_cmd>$->table=0;
                $<insert_cmd>$->value_list=0;
                $<insert_cmd>$->subselect=$<s_select>1;
	}
;




op_insert_column_list_sl: {
			$<str_list>$=0;
	}
	| OPEN_BRACKET insert_column_list_sl CLOSE_BRACKET {
			$<str_list>$=$<str_list>2;
			 add_feature("INSERT_COLUMNLIST_EQ_VALUELIST");
	}
;


insert_column_list_sl:
	ins_column_name {
                        $<str_list>$=new_str_list($<str>1);
	}
	| insert_column_list_sl KW_COMMA ins_column_name {
                        $<str_list>$=add_str_list($<str_list>1, $<str>3);
	}
;


ins_column_name : 
		identifier {	
			strcpy($<str>$,$<str>1);
	}
	| identifier KW_DOT identifier { 
			/* with a table prefix - on an insert ? We'll just silently drop it... */
			strcpy($<str>$,$<str>3);
			A4GL_warn("Dropped table prefix from INSERT column name");
	}
;

insert_value_list_slil:
	insert_value_sli { $<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);}
	| insert_value_list_slil  KW_COMMA insert_value_sli {
		$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}
;

insert_value_sli:
        value_expression_sli  {$<s_select_list_item>$=$<s_select_list_item>1;}
        | KW_NULL  {$<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_NULL); }

;




delete_statement_c:
	DELETE_FROM atline table_name_not_for_column_prefix where_del_p {

			if ($<ptr>4==0 && $<integer_val>2>=0) { 
				if (A4GL_isyes(acl_getenv("A4GL_ERR_DELNOWHERE"))) {
					yylineno=$<integer_val>2;
					a4gl_yyerror("DELETE with no WHERE clause"); 
				} else {
					A4GL_warn("DELETE with no WHERE clause"); 
				}
			}
			add_feature("ANSI_DELETE");

			$<delete_cmd>$=malloc(sizeof(struct struct_delete_cmd));
			$<delete_cmd>$->connid=NULL;
			$<delete_cmd>$->table=acl_strdup($<str>3);
			$<delete_cmd>$->where_clause=$<ptr>4;	
			A4GL_set_associated_mem($<delete_cmd>$, $<delete_cmd>$->table);
			
		}
;


begin_statement: BEGIN_WORK  { add_feature("BEGIN_WORK"); }
;

commit_statement:
	COMMIT_W  { add_feature("COMMIT_WORK"); }
;


op_db_exclusive :
		{$<e_boolean>$=EB_FALSE;}
	|	EXCLUSIVE {
		add_feature("DATABASE_EXCLUSIVE");
		{$<e_boolean>$=EB_TRUE;}
	}

;




misc_infx_stmt: misc_infx_stmt_str {
	char buff[256];
	$<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),NULL);
	SPRINTF1(buff,"Warning: Informix specific SQL @ line %d\n",yylineno);
	ansi_violation(buff,1);
	}
;

misc_infx_stmt_str: 
	START_DATABASE identifier WITH_LOG_IN CHAR_VALUE MODE_ANSI {
			add_feature("START_DATABASE_WITH_LOG_MODE_ANSI");
			sprintf($<str>$,"START DATABASE %s WITH LOG IN %s MODE ANSI", $<str>2,$<str>4);
	}
	| START_DATABASE identifier WITH_LOG_IN CHAR_VALUE {
			add_feature("START_DATABASE_WITH_LOG");
			sprintf($<str>$,"START DATABASE %s WITH LOG IN %s", $<str>2,$<str>4);
	}
	| SET_CONSTRAINTS_ALL_IMMEDIATE
	{
			add_feature("SET_CONSTRAINTS_ALL_IMMEDIATE");
			SPRINTF1($<str>$,"%s",$<str>1); 
	}
	| SET_BUFFERED_LOG {
		add_feature("SET_BUFFERED_LOG");
			SPRINTF1($<str>$,"%s",$<str>1); 
	}
	| SET_LOG {
		add_feature("SET_LOG");
			SPRINTF1($<str>$,"%s",$<str>1); 
	}
        | UPDATESTATS_T  identifier {
			SPRINTF2($<str>$,"%s %s",$<str>1,$<str>2); add_feature("UPDATE_STATISTICS_TABLE");
	}
        | UPDATESTATS 		{
		add_feature("UPDATE_STATISTICS");
			SPRINTF1($<str>$,"%s",$<str>1); 
	}
;

sql_transact_commands:
         commit_statement       { $<integer_val>$=1; 
#ifndef  SQLCOMPILER
				set_cmdlineno(token_read_on_line);
#endif

}
        | begin_statement       { $<integer_val>$=-1; 
#ifndef  SQLCOMPILER
set_cmdlineno(token_read_on_line);
#endif
}
        | rollback_statement    { $<integer_val>$=0; 
#ifndef  SQLCOMPILER
set_cmdlineno(token_read_on_line);
#endif
}
;

sql_commands :
        misc_infx_stmt          { $<sql_string>$=$<sql_string>1; }
        | schema_ss             { $<sql_string>$=$<sql_string>1; }
        | schema_element_ss     { $<sql_string>$=$<sql_string>1; }
        | misc_sql              { $<sql_string>$=$<sql_string>1; }
        | drops_statement       { $<sql_string>$=$<sql_string>1; }
        | create_statement_ss   { $<sql_string>$=$<sql_string>1; }
        | alter_statement_ss    { $<sql_string>$=$<sql_string>1; }
;





privilege_definition:
	GRANT privileges KW_ON table_name_not_for_column_prefix KW_TO grantee_list op_with_grant_option {SPRINTF7($<str>$,"%s %s %s %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4,$<str>5,$<str>6,$<str>7);  add_feature("GRANT"); }
	| REVOKE privileges KW_ON table_name_not_for_column_prefix FROM grantee_list  {SPRINTF6($<str>$,"%s %s %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4,$<str>5,$<str>6);  add_feature("REVOKE"); }
	| GRANT db_priv KW_TO grantee_list {SPRINTF4($<str>$,"%s %s %s %s ",$<str>1,$<str>2,$<str>3,$<str>4); add_feature("GRANT"); }
	| REVOKE db_priv FROM grantee_list {SPRINTF4($<str>$,"%s %s %s %s ",$<str>1,$<str>2,$<str>3,$<str>4);  add_feature("REVOKE"); }
;


db_priv:
	CONNECT
	| RESOURCE
	| DBA
;

op_with_grant_option: {strcpy($<str>$,"");}
	| WITH_GRANT_OPTION {SPRINTF1($<str>$," %s ",$<str>1);}
	| KW_AS authorization_identifier {SPRINTF2($<str>$," %s %s",$<str>1,$<str>2);}
;

privileges:
	ALL_PRIVILEGES {SPRINTF1($<str>$," %s ",$<str>1);}
	| ALL {SPRINTF1($<str>$," %s ",$<str>1);}
	| action_list
;

action_list:
	action
	| action_list KW_COMMA action
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

action: KW_SELECT op_grant_column_list {
		if (A4GLSQLCV_check_requirement("SIMPLE_GRANT_SELECT"))  {
			SPRINTF0($<str>$," SELECT");
		} else {
			SPRINTF2($<str>$," %s %s",$<str>1,$<str>2);
		}
	}
	| KW_INSERT
	| KW_DELETE
	| KW_UPDATE op_grant_column_list {
		if (A4GLSQLCV_check_requirement("SIMPLE_GRANT_UPDATE"))  {
			SPRINTF0($<str>$," UPDATE");
		} else {
			SPRINTF2($<str>$," %s %s",$<str>1,$<str>2);
		}
	}
	| ALTER
	| INDEX
;

op_grant_column_list: {strcpy($<str>$,"");}
	| OPEN_BRACKET grant_column_list CLOSE_BRACKET
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

grant_column_list:
	  column_name
	| grant_column_list KW_COMMA column_name
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

grantee_list:
	  grantee
	| grantee_list KW_COMMA grantee
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

grantee:
	PUBLIC
	| authorization_identifier
;


view_definition_ss:
	CREATE_VIEW table_name_not_for_column_prefix op_view_column_list KW_AS query_specification_ss_converted op_with_check_option {
		add_feature("CREATE_VIEW_AS_SELECT");
		$<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),kw_space,acl_strdup($<str>3),kw_space,acl_strdup($<str>4),kw_space,$<sql_string>5,kw_space,acl_strdup($<str>6),NULL);
	
}
;

op_view_column_list: {strcpy($<str>$,"");}
	| OPEN_BRACKET view_column_list CLOSE_BRACKET
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

view_column_list:
	column_name
	| view_column_list KW_COMMA column_name
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;

op_with_check_option: {strcpy($<str>$,"");}
	| WITH_CHECK_OPTION {
		add_feature("CREATE_VIEW_SELECT_WITH_CHECK");
	}
;


check_constraint_definition_ss:
	CHECK OPEN_BRACKET search_condition_sli_as_string CLOSE_BRACKET {
		$<sql_string>$=make_sql_string_and_free(strdup("CHECK ("),$<sql_string>3,kw_cb,NULL);
		add_feature("DDL_CHECK");
	}
;


referential_constraint_definition:
	FOREIGN_KEY OPEN_BRACKET references_columns CLOSE_BRACKET references_specification
{SPRINTF5($<str>$," %s %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4,$<str>5);
	add_feature("DDL_FOREIGN_KEY");
}
;

references_specification:
	REFERENCES referenced_table_and_columns
{SPRINTF2($<str>$," %s %s",$<str>1,$<str>2);
add_feature("DDL_REFERENCES");
}
;

references_columns:
	references_column_list
;

referenced_table_and_columns:
	  table_name_not_for_column_prefix
	| table_name_not_for_column_prefix OPEN_BRACKET references_column_list CLOSE_BRACKET
{SPRINTF4($<str>$," %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4);}
;

references_column_list:
	  column_name
	| references_column_list KW_COMMA column_name
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;


unique_constraint_definition:
	  UNIQUE OPEN_BRACKET unique_column_list CLOSE_BRACKET opt_constraint_name {
		SPRINTF4($<str>$," UNIQUE %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5);
add_feature("DDL_UNIQUE");
	}
	  | DISTINCT OPEN_BRACKET unique_column_list CLOSE_BRACKET opt_constraint_name {
		ansi_violation("Use UNIQUE not DISTINCT",0);
		SPRINTF4($<str>$," UNIQUE %s %s %s %s",$<str>2,$<str>3,$<str>4,$<str>5);
add_feature("DDL_DISTINCT");
	}
	| PRIMARY_KEY OPEN_BRACKET unique_column_list CLOSE_BRACKET opt_constraint_name
{SPRINTF5($<str>$," %s %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4,$<str>5);
add_feature("DDL_PRIMARY_KEY");
}
;

unique_column_list:
	  column_name
	| unique_column_list KW_COMMA column_name
{SPRINTF3($<str>$," %s %s %s",$<str>1,$<str>2,$<str>3);}
;
	

table_constraint_definition_ss:
	unique_constraint_definition {
		$<sql_string>$=acl_strdup($<str>1);
	}
	| referential_constraint_definition {
		$<sql_string>$=acl_strdup($<str>1);
	}
	| check_constraint_definition_ss  {
		$<sql_string>$=$<sql_string>1;
	}
;


default_clause:
	  KW_DEFAULT literal {SPRINTF2($<str>$," %s %s",$<str>1,$<str>2); add_feature("DDL_DEFAULT_VALUE"); }
	  | DEFAULT_USER {SPRINTF1($<str>$," DEFAULT %s", A4GLSQLCV_get_sqlconst("USER")); add_feature("DDL_DEFAULT_VALUE"); }
	  | DEFAULT_TODAY {SPRINTF1($<str>$," DEFAULT %s", A4GLSQLCV_get_sqlconst("TODAY")); add_feature("DDL_DEFAULT_VALUE"); }
	  | DEFAULT_NULL { SPRINTF1($<str>$," %s",$<str>1); add_feature("DDL_DEFAULT_VALUE"); }
;



ct_column_definiton_ss:
	identifier data_type op_default_clause op_column_constraint_list_ss {

#ifdef DEBUG
			A4GL_debug("Str1:%s",$<str>1);
			A4GL_debug("Str2:%s",$<str>2);
			A4GL_debug("Str3:%s",$<str>3);
			A4GL_debug("Str4:%s",$<sql_string>4);
#endif

                $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),NULL);
                if (strlen($<str>3)) {
                        $<sql_string>$=make_sql_string_and_free($<sql_string>$, kw_space,acl_strdup($<str>3),NULL);
                }
                if (strlen($<sql_string>4)) {
                        $<sql_string>$=make_sql_string_and_free($<sql_string>$, kw_space,acl_strdup($<sql_string>4),NULL);
                } else {
			free($<sql_string>4);
		}


	}
;

op_default_clause: {strcpy($<str>$,"");}
	|default_clause
;

op_column_constraint_list_ss: {
		$<sql_string>$=acl_strdup("");
	} | column_constraint_list_ss {
		$<sql_string>$=$<sql_string>1;
	}
;


column_constraint_list_ss :
	column_constraint_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| column_constraint_list_ss column_constraint_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_space,$<sql_string>2,NULL);
	}
;

column_constraint_ss : 
	column_constraint_ss_1 opt_constraint_name {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,acl_strdup($<str>2),NULL);
	}
;



column_constraint_ss_1:
	  NOT_NULL {
		SPRINTF1($<str>$," %s ",$<str>1);
		$<sql_string>$=acl_strdup($<str>$);
		add_feature("DDL_NOT_NULL");
	}
	| NOT_NULL_UNIQUE {
		SPRINTF0($<str>$," NOT NULL UNIQUE ");
		$<sql_string>$=acl_strdup($<str>$);
		add_feature("DDL_NOT_NULL");
		add_feature("DDL_UNIQUE");
	}
	| UNIQUE {
		SPRINTF0($<str>$," UNIQUE ");
		$<sql_string>$=acl_strdup($<str>$);
		add_feature("DDL_UNIQUE");
	}
	| DISTINCT {
		ansi_violation("Use UNIQUE not DISTINCT",0);
		SPRINTF0($<str>$," UNIQUE ");
		$<sql_string>$=acl_strdup($<str>$);
		add_feature("DDL_DISTINCT");
	}
	| references_specification {
		$<sql_string>$=acl_strdup($<str>1);
	}
	| CHECK OPEN_BRACKET search_condition_sli_as_string CLOSE_BRACKET {
		$<sql_string>$=make_sql_string_and_free(acl_strdup("CHECK ("),$<sql_string>3,kw_cb,NULL);
		add_feature("DDL_CHECK");
		
	}
	| PRIMARY_KEY {
		$<sql_string>$=make_sql_string_and_free(acl_strdup(" PRIMARY KEY "),NULL);
		add_feature("DDL_PRIMARY_KEY");
	}
;


schema_ss:
	CREATE_SCHEMA schema_authorization_clause schema_element_list_ss
{
		add_feature("CREATE_SCHEMA");

$<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1),kw_space,acl_strdup($<str>2),kw_space,acl_strdup($<str>3),NULL);
}
;

schema_authorization_clause:
	schema_authorization_identifier
{SPRINTF1($<str>$," %s",$<str>1);}
;

schema_authorization_identifier:
	authorization_identifier
;

schema_element_list_ss:
	  schema_element_ss
	| schema_element_list_ss schema_element_ss {
		$<sql_string>$=make_sql_string_and_free($<sql_string>1,kw_space,$<sql_string>2,NULL);
	}
;

schema_element_ss:
	view_definition_ss {
		$<sql_string>$=$<sql_string>1;
	}
	| privilege_definition {
		$<sql_string>$=acl_strdup($<str>1);
	}
;






having_clause_sli:
	HAVING search_condition_sli {
		 add_feature("HAVING"); 
		$<s_select_list_item>$=$<s_select_list_item>2;
	}
;



where_clause_sli:
	WHERE search_condition_sli {
		 $<s_select_list_item>$=$<s_select_list_item>2;
	}
;


from_clause_ts:
	FROM table_reference_list {
		$<u_table>$=$<u_table>2;
	}
;

table_reference_list:
	  tname {$<u_table>$=$<u_table>1;}
	| table_reference_list KW_COMMA tname {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>3,E_OUTER_NONE,NULL);
	}
	| table_reference_list KW_COMMA OUTER tname {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>4,E_OUTER_NORMAL,NULL);
		A4GL_warn("OUTER join *may* not be portable to non-informix database");
		add_feature("SELECT_OUTER");
	}
	| table_reference_list KW_COMMA OUTER OPEN_BRACKET table_reference_list CLOSE_BRACKET {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>5,E_OUTER_NORMAL,NULL);
		A4GL_warn("OUTER join *may* not be portable to non-informix database");
		add_feature("SELECT_OUTER");
	}
/*
	| table_reference_list LEFT_JOIN tname KW_ON OPEN_BRACKET search_condition_sli CLOSE_BRACKET  {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>3,E_OUTER_LEFT_OUTER, $<s_select_list_item>6);
		add_feature("SELECT_OUTER");
	}
*/
	| table_reference_list LEFT_JOIN op_bracket_table_reference_list KW_ON search_condition_sli   {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>3,E_OUTER_LEFT_OUTER, $<s_select_list_item>5);
		add_feature("SELECT_OUTER");
	}
	| table_reference_list INNER_JOIN op_bracket_table_reference_list KW_ON search_condition_sli   {
		$<u_table>$=A4GLSQLPARSE_append_tablename($<u_table>1,$<u_table>3,E_INNER, $<s_select_list_item>5);
		add_feature("SELECT_INNER");
	}

;

op_bracket_table_reference_list: table_reference_list
	| OPEN_BRACKET table_reference_list CLOSE_BRACKET {$<u_table>$=$<u_table>2;}
;


tname: table_name_not_for_column_prefix  { 
			//A4GL_add_crud("SELECT",$<str>1);
			$<u_table>$=A4GLSQLPARSE_new_tablename($<str>1,NULL);
	}
	| table_name_not_for_column_prefix correlation_name { 
			//A4GL_add_crud("SELECT",$<str>1);
			$<u_table>$=A4GLSQLPARSE_new_tablename($<str>1,$<str>2);
	}
	| table_name_not_for_column_prefix KW_AS correlation_name { 
			//A4GL_add_crud("SELECT",$<str>1);
			$<u_table>$=A4GLSQLPARSE_new_tablename($<str>1,$<str>3);
	}
;

table_expression_2_select: 
		{
			/* No from or where etc.. */
			/* eg.. select user ; */
			$<s_select>$=new_empty_select();
		}
		| from_clause_ts  op_where_clause_2_select {
		$<s_select>$=$<s_select>2;
		$<s_select>$->first=$<u_table>1;
			A4GL_set_associated_mem( $<s_select>$, $<s_select>$->first);
}
;

op_where_clause_2_select:
	op_group_by_clause_2_select {
		$<s_select>$=$<s_select>1;
	}
	| where_clause_sli op_group_by_clause_2_select {
		$<s_select>$=$<s_select>2;
		$<s_select>$->where_clause=$<s_select_list_item>1;
	}
;

op_group_by_clause_2_select: {
		$<s_select>$=new_empty_select();
	}
	| group_by_clause_slil  {
		$<s_select>$=new_empty_select();
		$<s_select>$->group_by=$<s_select_list_item_list>1;
		$<s_select>$->having=0;
	}
	| group_by_clause_slil having_clause_sli {
		$<s_select>$=new_empty_select();
		$<s_select>$->group_by=$<s_select_list_item_list>1;
		$<s_select>$->having=$<s_select_list_item>2;
	}
	| having_clause_sli {
		$<s_select>$=new_empty_select();
		$<s_select>$->group_by=0;
		$<s_select>$->having=$<s_select_list_item>1;

	}
;





search_condition_sli:
	boolean_term_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| search_condition_sli KW_OR boolean_term_sli {
		$<s_select_list_item>$=new_select_list_item_op_expr($<s_select_list_item>1,$<s_select_list_item>3," OR ");
	}
;

boolean_term_sli:
	boolean_factor_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| boolean_term_sli KW_AND boolean_factor_sli {
		$<s_select_list_item>$=new_select_list_item_op_expr($<s_select_list_item>1,$<s_select_list_item>3," AND ");
	}
;

boolean_factor_sli:
	boolean_primary_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| KW_NOT boolean_primary_sli {
		$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_NOT,$<s_select_list_item>2);
	}
;

boolean_primary_sli:
	  predicate_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| OPEN_BRACKET search_condition_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_BRACKET_EXPR,$<s_select_list_item>2);
	}
;


exists_predicate_sli:
	EXISTS subquery_sli 		{
		$<s_select_list_item>$=new_select_list_item_sq(E_SQE_EXISTS, $<s_select_list_item>2);
		add_feature("WHERE_EXISTS");
	}
	| NOT_EXISTS subquery_sli 	{
		$<s_select_list_item>$=new_select_list_item_sq(E_SQE_NOT_EXISTS, $<s_select_list_item>2);
		add_feature("WHERE_EXISTS");
	}
;






op_matches_escape: {strcpy($<str>$,"");} | KW_ESCAPE escape_character {SPRINTF1($<str>$," ESCAPE %s",$<str>2);add_feature("WHERE_MATCHES_ESCAPE");} ;
op_ilike_escape: {strcpy($<str>$,"");} 	 | KW_ESCAPE escape_character {SPRINTF1($<str>$," ESCAPE %s",$<str>2);add_feature("WHERE_ILIKE_ESCAPE");} ;
op_like_escape: {strcpy($<str>$,"");} 	 | KW_ESCAPE escape_character {SPRINTF1($<str>$," ESCAPE %s",$<str>2);add_feature("WHERE_LIKE_ESCAPE");} ;

pattern_sli:
	value_expression_initial_sli {
		 $<s_select_list_item>$=$<s_select_list_item>1;
	}
;

escape_character: literal
;



op_not: {strcpy($<str>$,"");}
	| KW_NOT {strcpy($<str>$," NOT ");}
;


comparison_predicate_sli:
	value_expression_sli op_not IS_NULL { 
		if (strlen($<str>2)==0) {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ISNULL,$<s_select_list_item>1);
		} else {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ISNOTNULL,$<s_select_list_item>1);
		}

		add_feature("WHERE_NULL");
	}
	| value_expression_sli op_not IS_NOT_NULL { 
		if (strlen($<str>2)==0) {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ISNOTNULL,$<s_select_list_item>1);
		} else {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ISNULL,$<s_select_list_item>1);
		}
		add_feature("WHERE_NULL");
	}
	| value_expression_sli comp_op value_expression_sli { 
			$<s_select_list_item>$=new_select_list_item_op_expr($<s_select_list_item>1,$<s_select_list_item>3,$<str>2);
	}
	| value_expression_sli EQUAL value_expression_sli { 
			$<s_select_list_item>$=new_select_list_item_op_expr($<s_select_list_item>1,$<s_select_list_item>3,"=");
	}
	| value_expression_sli EQUAL KW_NULL { 
			FPRINTF(stderr,"Warning: Corrected =NULL to IS NULL line %d\n",yylineno);
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ISNULL,$<s_select_list_item>1);
	}
	| value_expression_sli op_not BETWEEN value_expression_sli KW_AND value_expression_sli { 
		if (strlen($<str>2)) {
			$<s_select_list_item>$=new_select_list_item_op_between($<str>2,$<s_select_list_item>1,$<s_select_list_item>4,$<s_select_list_item>6,1);
		} else {
			$<s_select_list_item>$=new_select_list_item_op_between($<str>2,$<s_select_list_item>1,$<s_select_list_item>4,$<s_select_list_item>6,0);
		}
	}
	| value_expression_sli LIKE pattern_sli op_like_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_LIKE,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);
	}
	| value_expression_sli NOT_LIKE pattern_sli op_like_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_NOT_LIKE,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);

	}
	| value_expression_sli ILIKE pattern_sli op_ilike_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_ILIKE,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);
	}
	| value_expression_sli NOT_ILIKE pattern_sli op_ilike_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_NOT_ILIKE,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);
	}
	| value_expression_sli MATCHES pattern_sli op_matches_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_MATCHES,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);
	}
	| value_expression_sli NOT_MATCHES pattern_sli op_matches_escape { 
			$<s_select_list_item>$=new_select_list_item_regex(E_SLI_REGEX_NOT_MATCHES,$<s_select_list_item>1,$<s_select_list_item>3,$<str>4);
	}
;

comp_op:
	NOT_EQUAL {
			if (A4GLSQLCV_check_requirement("NOT_EQUAL_AS_LESS_GREATER_THAN"))  {
				strcpy($<str>$," <> ");
			} else {
				strcpy($<str>$," != ");
			}
	}
	| LESS_THAN {
			strcpy($<str>$," < ");
	}
	| GREATER_THAN  {
			strcpy($<str>$," > ");
	}
	| TILDE {
			strcpy($<str>$," ~ ");
	}
	| LESS_THAN_EQ {strcpy($<str>$," <= ");}
	| GREATER_THAN_EQ {strcpy($<str>$," >= ");}
;


predicate_sli:
	comparison_predicate_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| in_predicate_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| exists_predicate_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| value_expression_sli {
                 $<s_select_list_item>$=$<s_select_list_item>1;
        }

;


op_all: {strcpy($<str>$,"");}
	| ALL {strcpy($<str>$," ALL "); add_feature("AGG_ALL");}
	| DISTINCT {
		strcpy($<str>$," DISTINCT ");
		add_feature("AGG_DISTINCT");
	}
	| UNIQUE {
		ansi_violation("Use DISTINCT not UNIQUE",0);
		strcpy($<str>$," DISTINCT ");
		add_feature("AGG_DISTINCT");
	}
;

op_u_all: {strcpy($<str>$,"");}
	| ALL {strcpy($<str>$," ALL "); add_feature("UNION_ALL");}
	| DISTINCT {
		strcpy($<str>$," DISTINCT ");
		add_feature("UNION_DISTINCT");
	}
	| UNIQUE {
		ansi_violation("Use DISTINCT not UNIQUE",0);
		add_feature("UNION_DISTINCT");
		strcpy($<str>$," DISTINCT ");
	}
;







data_type :
	data_type_i {
		strcpy($<str>$,A4GLSQLCV_dtype_alias($<str>1));
	}
;


data_type_i:
	  char_string_type
	| exact_numeric_type
	| approx_numeric_type
;

char_string_type:
	  KW_CHAR
	| KW_CHAR OPEN_BRACKET length CLOSE_BRACKET
{SPRINTF4($<str>$," %s %s%s%s",$<str>1,$<str>2,$<str>3,$<str>4);}
;

exact_numeric_type:
	SERIAL  {strcpy($<str>$,"SERIAL"); add_feature("DDL_SERIAL"); }
	| SERIAL OPEN_BRACKET INT_VALUE CLOSE_BRACKET {
			add_feature("DDL_SERIAL");
			if (A4GLSQLCV_check_requirement("NO_SERIAL_START_VALUE"))  {
				SPRINTF0($<str>$,"SERIAL");
			} else {
				SPRINTF1($<str>$,"SERIAL(%s)",$<str>3);
			}
	}

	| SERIAL8  {strcpy($<str>$,"SERIAL8"); add_feature("DDL_SERIAL8"); }

	| SERIAL8 OPEN_BRACKET INT_VALUE CLOSE_BRACKET {
			add_feature("DDL_SERIAL8");
			if (A4GLSQLCV_check_requirement("NO_SERIAL_START_VALUE"))  {
				SPRINTF0($<str>$,"SERIAL8");
			} else {
				SPRINTF1($<str>$,"SERIAL8(%s)",$<str>3);
			}
	}

	| KW_DECIMAL  {
 			add_feature("DDL_DECIMAL");
	}
	| KW_DECIMAL OPEN_BRACKET precision op_scale CLOSE_BRACKET {
 			add_feature("DDL_DECIMAL");
		if (strlen($<str>4)) {
			SPRINTF2($<str>$,"DECIMAL(%s%s)",$<str>3,$<str>4);
		} else {
			SPRINTF1($<str>$,"DECIMAL(%s)",$<str>3);
		}
	}
	| MONEY OPEN_BRACKET precision op_scale CLOSE_BRACKET {
 			add_feature("DDL_MONEY");
		if (A4GLSQLCV_check_requirement("MONEY_AS_DECIMAL")) {
			SPRINTF2($<str>$," DECIMAL(%s%s)",$<str>3,$<str>4);
		} else {
			SPRINTF2($<str>$," MONEY(%s%s)",$<str>3,$<str>4);
		}
	}


	| MONEY  {
 			add_feature("DDL_MONEY");
		if (A4GLSQLCV_check_requirement ("MONEY_AS_DECIMAL")) {
			strcpy($<str>$,"DECIMAL");
		} else {
			strcpy($<str>$,"MONEY");
		}
	}
        | KW_DATE {strcpy($<str>$,"DATE");
 			add_feature("DDL_DATE"); }
	| INTEGER {strcpy($<str>$,"INTEGER");}
	| INTEGER8 {strcpy($<str>$,"INTEGER8");}
	| SMALLINT {strcpy($<str>$,"SMALLINT");}
	| NCHAR {strcpy($<str>$,"NCHAR"); add_feature("DDL_NCHAR");}
	| NCHAR OPEN_BRACKET length CLOSE_BRACKET {SPRINTF1($<str>$,"NCHAR(%s)",$<str>3); add_feature("DDL_NCHAR");}
	| NVARCHAR {add_feature("DDL_NVARCHAR");}
	| NVARCHAR OPEN_BRACKET INT_VALUE CLOSE_BRACKET {SPRINTF1($<str>$,"NVARCHAR(%s)",$<str>3); add_feature("DDL_NVARCHAR");}
	| NVARCHAR OPEN_BRACKET INT_VALUE KW_COMMA INT_VALUE CLOSE_BRACKET {
			add_feature("DDL_NVARCHAR");
			if (A4GLSQLCV_check_requirement("IGNORE_DTYPE_VARCHAR_MIN"))  {
				SPRINTF1($<str>$,"NVARCHAR(%s)",$<str>3);
			} else {
				SPRINTF2($<str>$,"NVARCHAR(%s,%s)",$<str>3,$<str>5);
			}
	}
	| LVARCHAR {add_feature("DDL_LVARCHAR");}
	| LVARCHAR OPEN_BRACKET INT_VALUE CLOSE_BRACKET {SPRINTF1($<str>$,"LVARCHAR(%s)",$<str>3); add_feature("DDL_LVARCHAR");}
	| LVARCHAR OPEN_BRACKET INT_VALUE KW_COMMA INT_VALUE CLOSE_BRACKET {
			add_feature("DDL_LVARCHAR");
			if (A4GLSQLCV_check_requirement("IGNORE_DTYPE_VARCHAR_MIN"))  {
				SPRINTF1($<str>$,"LVARCHAR(%s)",$<str>3);
			} else {
				SPRINTF2($<str>$,"LVARCHAR(%s,%s)",$<str>3,$<str>5);
			}
	}
	| DATETIME s_curr KW_TO e_curr {SPRINTF2($<str>$,"DATETIME %s TO %s",$<str>2,$<str>4); add_feature("DDL_DATETIME");}
	| DATETIME  {add_feature("DDL_DATETIME");}
	| INTERVAL s_curr KW_TO e_curr {SPRINTF2($<str>$,"INTERVAL %s TO %s",$<str>2,$<str>4); add_feature("DDL_INTERVAL");}
	| sql_time_dtypes {strcpy($<str>$,$<str>1);}
	| INTERVAL {add_feature("DDL_INTERVAL");}
	| INTERVAL s_curr OPEN_BRACKET INT_VALUE CLOSE_BRACKET KW_TO e_curr {SPRINTF3($<str>$,"INTERVAL %s(%s) TO %s",$<str>2,$<str>4,$<str>7); add_feature("DDL_INTERVAL");}
	| KW_TEXT {add_feature("DDL_TEXT");}
	| KW_BYTE {add_feature("DDL_BYTE");}
	| VARCHAR {add_feature("DDL_VARCHAR");}
	| VARCHAR OPEN_BRACKET INT_VALUE CLOSE_BRACKET {SPRINTF1($<str>$,"VARCHAR(%s)",$<str>3);add_feature("DDL_VARCHAR");}
	| VARCHAR OPEN_BRACKET INT_VALUE KW_COMMA INT_VALUE CLOSE_BRACKET {
			add_feature("DDL_VARCHAR");
			if (A4GLSQLCV_check_requirement("IGNORE_DTYPE_VARCHAR_MIN"))  {
				SPRINTF1($<str>$,"VARCHAR(%s)",$<str>3);
			} else {
				SPRINTF2($<str>$,"VARCHAR(%s,%s)",$<str>3,$<str>5);
			}
		}
;

op_scale: {strcpy($<str>$,"");}
	| KW_COMMA scale {
		SPRINTF1($<str>$,",%s",$<str>2);
}
;

approx_numeric_type:
	KW_FLOAT OPEN_BRACKET precision CLOSE_BRACKET
{SPRINTF4($<str>$," %s %s %s %s",$<str>1,$<str>2,$<str>3,$<str>4);}
	| REAL
	| SMALLFLOAT
	| KW_FLOAT
	| DOUBLE_PRECISION {add_feature("DDL_DOUBLE_PRECISION"); SPRINTF1($<str>$," %s",$<str>1);}
;

length:
	INT_VALUE
;

precision:
	INT_VALUE
;

scale:
	INT_VALUE
;




authorization_identifier:
	identifier
	| CHAR_VALUE
;



op_col_arr : {$<int_list.i0>$=0;}
	| OPEN_SQUARE INT_VALUE CLOSE_SQUARE {
		$<int_list.i0>$=1;
		$<int_list.i1>$=atoi($<str>2);
	}
	| OPEN_SQUARE INT_VALUE KW_COMMA INT_VALUE CLOSE_SQUARE {
		$<int_list.i0>$=2;
		$<int_list.i1>$=atoi($<str>2);
		$<int_list.i2>$=atoi($<str>4);
	}
;

column_name : 
	column_name_specific {
		strcpy($<str>$,$<str>1);
	}
	| ATSIGN column_name_specific {
		strcpy($<str>$,$<str>2);
	}
;


column_name_sli : 
	column_name_sli_specific {
		$<s_select_list_item>$= $<s_select_list_item>1;
	}
	| ATSIGN column_name_sli_specific {
		$<s_select_list_item>$= $<s_select_list_item>2;
	}
;






column_name_sli_specific: identifier op_col_arr { 
		$<s_select_list_item>$=new_select_list_item_col(0,$<str>1,&$<int_list>2);
	}
	| table_name KW_DOT identifier op_col_arr {
		$<s_select_list_item>$=new_select_list_item_col($<str>1,$<str>3,&$<int_list>4);
	}
	| table_name  KW_DOT KW_MULTIPLY {
		$<s_select_list_item>$=new_select_list_item_col($<str>1,"*",0);
	}
	| KW_ROWID {
		$<s_select_list_item>$=new_select_list_item_col(0,"rowid",0);
	}
;



column_name_specific: identifier op_col_arr { 
		struct ilist *i;
		i=&$<int_list>2;
		if (strcmp($<str>1,"rowid")==0) { strcpy($<str>1, A4GLSQLCV_get_sqlconst ("rowid")); add_feature("ROWID"); }
		ADDMAP("Use Column",$<str>1);
		strcpy($<str>$,A4GLSQLCV_make_substr(A4GLSQLCV_check_colname(0,$<str>1), i->i0,i->i1,i->i2));
	}
	| table_name KW_DOT identifier op_col_arr {
		struct ilist *i;
		if (strcmp($<str>3,"rowid")==0) { strcpy($<str>3, A4GLSQLCV_get_sqlconst ("rowid"));  add_feature("ROWID");}
		SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname($<str>1,$<str>3));
		ADDMAP("Use Column",$<str>$);
		i=&$<int_list>4;
		strcpy($<str>$,A4GLSQLCV_make_substr($<str>$,i->i0,i->i1,i->i2));
	}
	| identifier KW_DOT identifier KW_DOT identifier op_col_arr {
		struct ilist *i;
		if (strcmp($<str>3,"rowid")==0) { strcpy($<str>3, A4GLSQLCV_get_sqlconst ("rowid")); add_feature("ROWID"); }
		// First identifier is the owner...
		SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname(A4GLSQLCV_ownerize_tablename($<str>1,$<str>3),$<str>5));
		ADDMAP("Use Column",$<str>$);
		i=&$<int_list>4;
		strcpy($<str>$,A4GLSQLCV_make_substr($<str>$,i->i0,i->i1,i->i2));
	}
	| table_name  KW_DOT KW_MULTIPLY {
		SPRINTF1($<str>$,"%s",A4GLSQLCV_check_colname($<str>1,"*"));
		ADDMAP("Use Column",$<str>$);
	}
;

correlation_name:
	identifier
;


literal: CHAR_VALUE { strcpy($<str>$,$<str>1); 
#ifdef DEBUG
A4GL_debug("Set $<str>$ to %s\n",$<str>$); 
#endif
}
	| real_number
	| INT_VALUE
        | curr_clause 
		
;


cur_part: { strcpy($<str>$,A4GLSQLCV_generate_current(0,0)); }
	| s_curr KW_TO e_curr {
		strcpy($<str>$,A4GLSQLCV_generate_current($<str>1,$<str>3));
	}
;





s_curr: YEAR | MONTH | DAY | HOUR | MINUTE | SECOND | FRACTION;
e_curr: YEAR | MONTH | DAY | HOUR | MINUTE | SECOND | FRACTION | FRACTION OPEN_BRACKET INT_VALUE CLOSE_BRACKET {SPRINTF1($<str>$,"FRACTION(%s)",$<str>3);}
;




simple_column_name : identifier {
	strcpy($<str>$,$<str>1);
     // SPRINTF1($<str>$,"\"%s\"",$<str>1);
}
;



execute_procedure_cmd :
	opt_use2_p EXECUTE_PROCEDURE spl_proc_name OPEN_BRACKET CLOSE_BRACKET {
		insql=0;
		add_sql_function($<str>3);
		$<cmd>$=new_execute_procedure_cmd($<ptr>1,$<str>3,NULL);

		/*
		if (A4GLSQLCV_check_requirement("EXECUTE_PROCEDURE_AS_EXEC")) {
			SPRINTF1($<str>$,"EXEC %s",$<str>2);
		} else {
			SPRINTF1($<str>$,"EXECUTE PROCEDURE %s ()",$<str>2);
		}
		*/
	}
	| opt_use2_p EXECUTE_PROCEDURE spl_proc_name OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		insql=0;
		add_sql_function($<str>4);
		$<cmd>$=new_execute_procedure_cmd($<ptr>1,$<str>3,$<s_select_list_item_list>5);

		/*
		if (A4GLSQLCV_check_requirement("EXECUTE_PROCEDURE_AS_EXEC")) {
			SPRINTF2($<str>$,"EXEC %s %s",$<str>2, get_select_list_item_list(0, $<s_select_list_item_list>4));
		} else {
			SPRINTF2($<str>$,"EXECUTE PROCEDURE %s (%s)",$<str>2, get_select_list_item_list(0, $<s_select_list_item_list>4));
		}
		*/
	}
;


misc_sql :
	lock_stmt 		{ $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1), NULL);}
	| unlock_stmt  		{ $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1), NULL);}
	| rename_stmt  		{ $<sql_string>$=make_sql_string_and_free(acl_strdup($<str>1), NULL);}

;

rename_stmt :
	RENTAB rentabname KW_TO rentabname { add_feature("RENAME_TABLE"); strcpy($<str>$,A4GLSQLCV_rentab($<str>2,$<str>4)); }
	| RENCOL table_name KW_DOT rencolname KW_TO rencolname { add_feature("RENAME_COLUMN"); strcpy($<str>$,A4GLSQLCV_rencol($<str>2,$<str>4,$<str>6) ); }
;

rentabname : identifier;
rencolname : identifier;

unlock_stmt:

	UNLOCK_TABLE table_name_not_for_column_prefix {
		add_feature("UNLOCK_TABLE");
		SPRINTF2($<str>$,"%s %s",$<str>1,$<str>2);
	}
;

lock_stmt :
	LOCK_TABLE table_name_not_for_column_prefix share_or_exclusive  {
		add_feature("LOCK_TABLE");
		SPRINTF3($<str>$,"%s %s %s",
					$<str>1,
					$<str>2,
					$<str>3
					);
		}
;

share_or_exclusive :
	INSHARE { add_feature("LOCK_TABLE_SHARED");}
	| INEXCLUSIVE {add_feature("LOCK_TABLE_EXCLUSIVE");}
;










datetime_value_qualified :
	datetime_value {strcpy($<str>$,A4GLSQLCV_datetime_value($<str>1));}
	| datetime_value s_curr KW_TO e_curr {strcpy($<str>$,A4GLSQLCV_make_dtime_extend($<str>1,$<str>2,$<str>4,0));}
;

datetime_value:
	DATETIME_VALUE  {strcpy($<str>$,$<str>1);}
;

interval_value_qualified :
	interval_value {strcpy($<str>$,A4GLSQLCV_interval_value($<str>1));}
	| interval_value s_curr OPEN_BRACKET INT_VALUE CLOSE_BRACKET KW_TO e_curr {
			strcpy($<str>$,A4GLSQLCV_make_ival_extend($<str>1,$<str>2,$<str>4,$<str>7,0));
		}
	| interval_value s_curr KW_TO e_curr {
		strcpy($<str>$,A4GLSQLCV_make_ival_extend($<str>1,$<str>2,(char *)0, $<str>4,0));
	}
;

interval_value:
	INTERVAL_VALUE  {SPRINTF1($<str>$,"%s",$<str>1);}
;


curr_clause : KW_CURRENT  cur_part {
	strcpy($<str>$,$<str>2);
}
;


















order_by_clause_slil:
	ORDER KW_BY sort_specification_list_slil {
		$<s_select_list_item_list>$=$<s_select_list_item_list>3;
		add_feature("ORDER_BY");
	}
;




sort_specification_list_slil:
	sort_specification_sli {
			$<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
	| sort_specification_list_slil KW_COMMA sort_specification_sli {
			$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}

;

sort_specification_sli : sort_spec_sli op_asc_desc {
		if (strcmp($<str>2,"DESC")!=0) {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_ASC,$<s_select_list_item>1);
		} else {
			$<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_DESC,$<s_select_list_item>1);
		}
	}
;

sort_spec_sli: INT_VALUE  { 
		add_feature("ORDER_BY_NUMBER");
		$<s_select_list_item>$=new_select_list_item_literal($<str>1);
	}
	| column_name_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
		$<s_select_list_item>$->data.type=E_SLI_COLUMN_ORDERBY;
	}
	
;

op_asc_desc: {strcpy($<str>$,"");}
	| ASC 
		{add_feature("ORDER_BY_ASC"); strcpy($<str>$,"ASC");}
	| DESC
		{add_feature("ORDER_BY_DESC"); strcpy($<str>$,"DESC");}
;

group_by_clause_slil:
	GROUP_BY gr_column_specification_list_slil {
		$<s_select_list_item_list>$=$<s_select_list_item_list>2;
	}
;

gr_column_specification_list_slil:
	  gr_column_specification_sli {
			$<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
	| gr_column_specification_list_slil KW_COMMA gr_column_specification_sli {
			$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}
;


gr_column_specification_sli: column_name_sli { $<s_select_list_item>$=$<s_select_list_item>1; } 
	|  INT_VALUE  { $<s_select_list_item>$=new_select_list_item_literal($<str>1); }
;





search_condition_sli_as_string: search_condition_sli {
	$<sql_string>$=get_select_list_item(0,$<s_select_list_item>1);
}
;









query_specification_ss_converted:  query_specification_select {
		A4GL_set_sql_lineno(yylineno);
		$<sql_string>$=make_select_stmt_v2(current_upd_table, $<s_select>1,"");
		map_select_stmt("SELECT",$<s_select>1);
		A4GL_free_select_stmt($<s_select>1);
}
;


sql_time_dtypes: 
 TIME     { 
	if (A4GLSQLCV_check_requirement("ALLOW_TIME_DATATYPE")) {
       		strcpy($<str>$,"TIME"); break;
	} else {
       		strcpy($<str>$,"DATETIME HOUR TO FRACTION(2)"); break;
	}
 }
 | TIME OPEN_BRACKET INT_VALUE CLOSE_BRACKET   {
	int n;
       	n=atoi($<str>3);
	if (A4GLSQLCV_check_requirement("ALLOW_TIME_DATATYPE")){ 
		sprintf($<str>$,"TIME(%d)",n);
	} else {
        	switch (n) {
                	case 0: strcpy($<str>$,"DATETIME HOUR TO SECOND"); break; 
                	case 1: strcpy($<str>$,"DATETIME HOUR TO FRACTION(1)"); break;
                	case 2: strcpy($<str>$,"DATETIME HOUR TO FRACTION(2)"); break;
                	case 3: strcpy($<str>$,"DATETIME HOUR TO FRACTION(3)"); break;
                	case 4: strcpy($<str>$,"DATETIME HOUR TO FRACTION(4)"); break;
                	case 5: strcpy($<str>$,"DATETIME HOUR TO FRACTION(5)"); break;
                	default: a4gl_yyerror("Invalid time"); YYERROR;
        	}
	}
    }
 | TIMESTAMP {
	if (A4GLSQLCV_check_requirement("ALLOW_TIMESTAMP_DATATYPE")) {
		strcpy($<str>$,"TIMESTAMP");
	} else {
                strcpy($<str>$,"DATETIME YEAR TO FRACTION(2)"); 
	}
 }
 | TIMESTAMP OPEN_BRACKET INT_VALUE CLOSE_BRACKET {
        int n;
       	n=atoi($<str>3);
	if (A4GLSQLCV_check_requirement("ALLOW_TIMESTAMP_DATATYPE")) {
		sprintf($<str>$,"TIMESTAMP(%d)",n);
	} else {
        	switch (n) {
                	case 0: strcpy($<str>$,"DATETIME YEAR TO SECOND"); break; 
                	case 1: strcpy($<str>$,"DATETIME YEAR TO FRACTION(1)"); break;
                	case 2: strcpy($<str>$,"DATETIME YEAR TO FRACTION(2)"); break;
                	case 3: strcpy($<str>$,"DATETIME YEAR TO FRACTION(3)"); break;
                	case 4: strcpy($<str>$,"DATETIME YEAR TO FRACTION(4)"); break;
                	case 5: strcpy($<str>$,"DATETIME YEAR TO FRACTION(5)"); break;
                	default: a4gl_yyerror("Invalid time"); YYERROR;
        	}
	}
 }
;

/* ========================= sql1.rule ================================ */




select_statement_ss_select : 
	KW_SELECT op_first op_ad { 
		//start_bind('i',0);
		 set_ignore_indicators();} select_list_slil  { clr_ignore_indicators();}
        opt_into_sel 
	table_expression_2_select sel_p2_select sel_finish_sf {


		$<s_select>$=$<s_select>8;
		if ($<integer_val>2!=-1) {
			$<s_select>$->limit.start=1;
			$<s_select>$->limit.end=$<integer_val>2;
		}
		$<s_select>$->modifier=acl_strdup($<str>3);
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->modifier);
		$<s_select>$->into=$<ptr_list>7;
		$<s_select>$->select_list=$<s_select_list_item_list>5;
		$<s_select>$->next=$<s_select>9;
		$<s_select>$->sf=$<s_select_finish>10;
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->sf);
}
;


union_select_statement2_ss: 
	KW_SELECT op_first op_ad select_list_slil
	table_expression_2_select sel_p2_select  {
	        $<s_select>$=$<s_select>5;
                $<s_select>$->modifier=acl_strdup($<str>3);
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->modifier);
		if ($<integer_val>2!=-1) {
			$<s_select>$->limit.start=1;
			$<s_select>$->limit.end=$<integer_val>2;
		}
                $<s_select>$->into=0;
                $<s_select>$->select_list=$<s_select_list_item_list>4;
		$<s_select>$->next=$<s_select>6;
	}
;


uu_select_statement21_select:
	KW_SELECT op_first op_ad select_list_slil table_expression_2_select sel_p2_select sel_ordby_unload_slil {
		struct s_select_finish *sf;
               struct s_select *s1;
               s1=$<s_select>5;
               s1->modifier=acl_strdup($<str>3);
		A4GL_set_associated_mem(s1, s1->modifier);
               s1->into=0; 
               s1->select_list=$<s_select_list_item_list>4;
               s1->next=$<s_select>6;
		if ($<integer_val>2!=-1) {
			s1->limit.start=1;
			s1->limit.end=$<integer_val>2;
		}
		sf=acl_malloc2(sizeof(struct s_select_finish));
		sf->into_temp=0;
		sf->nolog=0;
		sf->insert_into=0;
		sf->order_by=$<s_select_list_item_list>7;
		s1->sf=sf;
		A4GL_set_associated_mem(s1,s1->sf);
		A4GL_set_sql_lineno(yylineno);
		$<ptr>$=A4GL_new_select_list_item_expr(new_select_list_query(s1));
		map_select_stmt("SELECT",$<s_select>$);
}
;


sel_p2_select : { $<s_select>$=0;}
	| UNION op_u_all union_select_statement2_ss { 
		$<s_select>$=$<s_select>3;
		$<s_select>$->union_op=acl_strdup($<str>2);
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->union_op);
		add_feature("SELECT_UNION"); 
	}
;


sel_ordby_unload_slil: {$<s_select_list_item_list>$=0;}
	| order_by_clause_slil {  $<s_select_list_item_list>$=$<s_select_list_item_list>1;}
;


sel_finish_sf: {
		$<s_select_finish>$=0;
	}
	| order_by_clause_slil  {  
		$<s_select_finish>$=acl_malloc2(sizeof(struct s_select_finish));
		$<s_select_finish>$->order_by=$<s_select_list_item_list>1;
		$<s_select_finish>$->insert_into=0;
		$<s_select_finish>$->into_temp=0;
		$<s_select_finish>$->nolog=0;
	}
	| order_by_clause_slil INTO_TEMP tmp_tabname op_no_log_i { 
		$<s_select_finish>$=acl_malloc2(sizeof(struct s_select_finish));
		add_feature("SELECT_INTO_TEMP_ORDER_BY");
		$<s_select_finish>$->order_by=$<s_select_list_item_list>1;
		$<s_select_finish>$->insert_into=0;
		$<s_select_finish>$->into_temp=strdup($<str>3);
		A4GL_set_associated_mem($<s_select_finish>$, $<s_select_finish>$->into_temp);
		$<s_select_finish>$->nolog=$<integer_val>4;

	}
	| INTO_TEMP tmp_tabname op_no_log_i { 
		$<s_select_finish>$=acl_malloc2(sizeof(struct s_select_finish));
		add_feature("SELECT_INTO_TEMP");
		$<s_select_finish>$->order_by=0;
		$<s_select_finish>$->into_temp=strdup($<str>2);
		A4GL_set_associated_mem($<s_select_finish>$, $<s_select_finish>$->into_temp);
		$<s_select_finish>$->insert_into=0;
		$<s_select_finish>$->nolog=$<integer_val>3;
} 
;


tmp_tabname: identifier;




query_specification_select:
	KW_SELECT op_first op_ad select_list_slil table_expression_2_select {
		$<s_select>$=$<s_select>5;
		if ($<integer_val>2!=-1) {
			$<s_select>$->limit.start=1;
			$<s_select>$->limit.end=$<integer_val>2;
		}
		$<s_select>$->modifier=acl_strdup($<str>3);
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->modifier);
		$<s_select>$->select_list=$<s_select_list_item_list>4;
	}
;

subquery_sli:
	OPEN_BRACKET_SELECT op_first op_ad select_list_slil table_expression_2_select CLOSE_BRACKET {
		$<s_select>$=$<s_select>5;
		if ($<integer_val>2!=-1) {
			$<s_select>$->limit.start=1;
			$<s_select>$->limit.end=$<integer_val>2;
		}
		$<s_select>$->modifier=acl_strdup($<str>3);
		A4GL_set_associated_mem($<s_select>$, $<s_select>$->modifier);
		$<s_select>$->select_list=$<s_select_list_item_list>4;
		$<s_select_list_item>$=new_select_list_subquery($<s_select>$);
	}
;


op_first : 
	{$<integer_val>$=-1;}
	|
	 KW_FIRST INT_VALUE {
		$<integer_val>$=atol($<str>2);
	} 
	
;

op_ad: {strcpy($<str>$,"");}
	| ALL {strcpy($<str>$,"ALL"); add_feature("SELECT_ALL");}
	| DISTINCT {strcpy($<str>$,"DISTINCT"); add_feature("SELECT_DISTINCT");}
	| UNIQUE {strcpy($<str>$,"DISTINCT");
		add_feature("SELECT_UNIQUE");
		ansi_violation("Use DISTINCT not UNIQUE",0);
		strcpy($<str>$,"DISTINCT");
	}

;


select_list_slil: 
	unexpanded_select_list_slil {
			$<s_select_list_item_list>$=rationalize_select_list_item_list($<s_select_list_item_list>1);
		}
;


unexpanded_select_list_slil:
	value_expression_pls_sli  { 
		 $<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
	| select_list_slil KW_COMMA value_expression_pls_sli { 
		$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}	
;

value_expression_pls_sli : 
	value_expression_sli {
		$<s_select_list_item>$=$<s_select_list_item>1;
	}
	| value_expression_sli  identifier {
		$<s_select_list_item>$=$<s_select_list_item>1;
		$<s_select_list_item>$->alias=acl_strdup($<str>2);
		A4GL_set_associated_mem($<s_select_list_item>$, $<s_select_list_item>$->alias);
	}
	| value_expression_sli KW_AS identifier {
		$<s_select_list_item>$=$<s_select_list_item>1;
		$<s_select_list_item>$->alias=acl_strdup($<str>3);
		A4GL_set_associated_mem($<s_select_list_item>$, $<s_select_list_item>$->alias);
	}
;


value_expression_sli:
	value_expression_initial_sli {
		$<s_select_list_item>$=$<s_select_list_item>1; /* A4GLSQLCV_check_expr($<sql_string>1) */
	}
	| KW_MINUS value_expression_initial_sli {
		$<s_select_list_item>$=$<s_select_list_item>2;
		$<s_select_list_item>$->sign='-';
	}
	| KW_PLUS value_expression_initial_sli {
		$<s_select_list_item>$=$<s_select_list_item>2;
	}
;


value_expression_complex_sli :
	value_expression_initial_sli KW_DIVIDE value_expression_sli {
			$<s_select_list_item>$=new_select_list_item_op_expr ($<s_select_list_item>1, $<s_select_list_item>3, "/");
	}
	| value_expression_initial_sli units_qual_i {
			$<s_select_list_item>$=new_select_list_item_simple_expr((enum e_sli)$<integer_val>2, $<s_select_list_item>1);
	}
	| value_expression_initial_sli KW_MULTIPLY value_expression_sli {
			$<s_select_list_item>$=new_select_list_item_op_expr ($<s_select_list_item>1, $<s_select_list_item>3, "*");
	}
	| value_expression_initial_sli KW_PLUS value_expression_sli {
			$<s_select_list_item>$=new_select_list_item_op_expr ($<s_select_list_item>1, $<s_select_list_item>3, "+");
	}
	| value_expression_initial_sli KW_MINUS value_expression_sli {
			$<s_select_list_item>$=new_select_list_item_op_expr ($<s_select_list_item>1, $<s_select_list_item>3, "-");
	}
	| value_expression_initial_sli CONCAT_PIPES value_expression_sli {
			$<s_select_list_item>$=new_select_list_item_op_expr ($<s_select_list_item>1, $<s_select_list_item>3, "||");
	}
	| literal 		{ $<s_select_list_item>$=new_select_list_item_literal($<str>1); }
	| KW_TRUE 		{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_TRUE); }
	| KW_FALSE 		{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_FALSE); }
	| USER 			{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_USER); }
	| KW_TODAY 		{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_TODAY); }
 	| KW_ROWID              { $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_ROWID); }
	| TIME 			{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_TIME); }
	| KW_MULTIPLY 		{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_STAR); }
	| COUNT_MULTIPLY 	{ $<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_BUILTIN_CONST_COUNT_STAR); }

 	| AVG OPEN_BRACKET op_all value_expression_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_agg1(E_SLI_BUILTIN_AGG_AVG,$<str>3,$<s_select_list_item>4);
		add_feature("SELECT_AVG");
	}
	| XMAX OPEN_BRACKET op_all value_expression_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_agg1(E_SLI_BUILTIN_AGG_MAX,$<str>3,$<s_select_list_item>4);
		add_feature("SELECT_MAX");
	}
	| XMIN OPEN_BRACKET op_all value_expression_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_agg1(E_SLI_BUILTIN_AGG_MIN,$<str>3,$<s_select_list_item>4);
		add_feature("SELECT_MIN");
	}
	| KW_SUM OPEN_BRACKET op_all value_expression_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_agg1(E_SLI_BUILTIN_AGG_SUM,$<str>3,$<s_select_list_item>4);
		add_feature("SELECT_SUM");
	}
	| COUNT OPEN_BRACKET op_all value_expression_sli CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_agg1(E_SLI_BUILTIN_AGG_COUNT,$<str>3,$<s_select_list_item>4);
		add_feature("SELECT_COUNT");
	}
	| NAMED OPEN_BRACKET CLOSE_BRACKET {
		add_sql_function($<str>1);
		$<s_select_list_item>$=new_select_list_item_fcall($<str>1,0);
	}
	| NAMED OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		add_sql_function($<str>1);
		$<s_select_list_item>$=new_select_list_item_fcall($<str>1,$<s_select_list_item_list>3);
	}
	| YEAR OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_YEAR,$<s_select_list_item_list>3);
	}
	| MONTH OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_MONTH,$<s_select_list_item_list>3);
	}
	| DAY OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_DAY,$<s_select_list_item_list>3);
	}
	| MDY OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_MDY,$<s_select_list_item_list>3);
	}
	| WEEKDAY OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_WEEKDAY,$<s_select_list_item_list>3);
	}
	| KW_DOW OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_DOW,$<s_select_list_item_list>3);
	}
	| KW_DATE OPEN_BRACKET value_expr_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_builtin_fcall(E_SLI_BUILTIN_FUNC_DATE,$<s_select_list_item_list>3);
	}
	| OPEN_BRACKET value_expression_sli CLOSE_BRACKET {
		  $<s_select_list_item>$=new_select_list_item_simple_expr(E_SLI_BRACKET_EXPR,$<s_select_list_item>2);
	}
	| EXTEND OPEN_BRACKET extend_qual_sli CLOSE_BRACKET { 
		add_feature("EXTEND"); 
		$<s_select_list_item>$=$<s_select_list_item>3;
	}
	| datetime_value_qualified { 
		$<s_select_list_item>$=new_select_list_item_datetime($<str>1);
		add_feature("FUNC_DATETIME");
	}
	| interval_value_qualified {
		$<s_select_list_item>$=new_select_list_item_interval($<str>1);
		add_feature("FUNC_INTERVAL");
	}
	| CASE sql_case_stmt END {
		$<s_select_list_item>$=$<s_select_list_item>2;
	}
	| CASE search_condition_sli sql_case_stmt END {
		$<s_select_list_item>3->data.s_select_list_item_data_u.sqlcase.master_condition=$<s_select_list_item>2;
		$<s_select_list_item>$=$<s_select_list_item>3;
	}
;



sql_case_stmt :
	sql_case_stmt_element {
		$<s_select_list_item>$=new_select_list_item_case($<s_select_list_item>1);
	}
	| sql_case_stmt sql_case_stmt_element {
		$<s_select_list_item>$=append_select_list_item_case(
							$<s_select_list_item>1,
							$<s_select_list_item>2);
	}
;


sql_case_stmt_element: 
	WHEN search_condition_sli KW_THEN value_expression_sli {
		$<s_select_list_item>$=new_select_list_item_case_element(
				$<s_select_list_item>2,
				$<s_select_list_item>4);

	}
	| ELSE value_expression_sli {
		$<s_select_list_item>$=new_select_list_item_case_element( 0, $<s_select_list_item>2);
	}
;


value_expr_list_slil : 
	value_expression_sli {
		$<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
	| value_expr_list_slil KW_COMMA value_expression_sli {
			$<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}
	
;


















op_extend_from_to: 
 	{$<str_list>$=NULL;}
	| KW_COMMA s_curr KW_TO e_curr  { $<str_list>$=new_str_list($<str>2);  add_str_list($<str_list>$,$<str>4);}
	| s_curr KW_TO e_curr  { $<str_list>$=new_str_list($<str>1);  add_str_list($<str_list>$,$<str>3);} 
;

extend_qual_sli:
        | var_ident_ibind_sli op_extend_from_to {
			$<s_select_list_item>$=new_select_list_item_extend($<s_select_list_item>1,$<str_list>2);
	}
	| value_expression_sli op_extend_from_to {
			$<s_select_list_item>$=new_select_list_item_extend($<s_select_list_item>1,$<str_list>2);
	}
;

units_qual_i :
        UNITS_YEAR 	{$<integer_val>$=E_SLI_UNITS_YEAR;}
        | UNITS_MONTH 	{$<integer_val>$=E_SLI_UNITS_MONTH;}
        | UNITS_DAY 	{$<integer_val>$=E_SLI_UNITS_DAY;}
        | UNITS_HOUR 	{$<integer_val>$=E_SLI_UNITS_HOUR;}
        | UNITS_MINUTE 	{$<integer_val>$=E_SLI_UNITS_MINUTE;}
        | UNITS_SECOND 	{$<integer_val>$=E_SLI_UNITS_SECOND;}
;


in_predicate_sli:
        value_expression_sli KW_IN OPEN_BRACKET in_value_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_op_slil($<s_select_list_item>1,$<s_select_list_item_list>4,E_SLI_IN_VALUES);
                add_feature("WHERE_IN");
        }
        | value_expression_sli KW_IN subquery_sli {
		$<s_select_list_item>$=new_select_list_item_op_sli($<s_select_list_item>1,$<s_select_list_item>3,E_SLI_IN_SELECT);
                add_feature("WHERE_IN_SELECT");
        }
        | value_expression_sli NOT_IN OPEN_BRACKET in_value_list_slil CLOSE_BRACKET {
		$<s_select_list_item>$=new_select_list_item_op_slil($<s_select_list_item>1,$<s_select_list_item_list>4,E_SLI_NOT_IN_VALUES);
                add_feature("WHERE_IN");
        }
        | value_expression_sli NOT_IN subquery_sli {
		$<s_select_list_item>$=new_select_list_item_op_sli($<s_select_list_item>1,$<s_select_list_item>3,E_SLI_NOT_IN_SELECT);
                add_feature("WHERE_IN_SELECT");
        }
;

in_value_list_slil:
	in_value_specification_sli {
		$<s_select_list_item_list>$=local_new_select_list_item_list($<s_select_list_item>1);
	}
        | in_value_list_slil KW_COMMA in_value_specification_sli {
                $<s_select_list_item_list>$=local_add_select_list_item_list($<s_select_list_item_list>1,$<s_select_list_item>3);
	}
;

in_value_specification_sli : var_ident_ibind_sli { $<s_select_list_item>$=$<s_select_list_item>1;}
         | literal { $<s_select_list_item>$=new_select_list_item_literal($<str>1); }
	 | KW_MINUS INT_VALUE { 
		char buff[256]; SPRINTF1(buff," -%s",$<str>2); $<s_select_list_item>$=new_select_list_item_literal(buff); }
	 | KW_MINUS  real_number { char buff[256]; SPRINTF1(buff," -%s",$<str>2); $<s_select_list_item>$=new_select_list_item_literal(buff); }
;



/* ========================= select.rule ================================ */
table_name: table_name_i  {
                if (strstr($<str>1,"systables")!=0) { add_feature("IFX_SYSTABLES"); }
                if (strstr($<str>1,"syscolumns")!=0) { add_feature("IFX_SYSCOLUMNS"); }
                if (strstr($<str>1,"sysindexes")!=0) { add_feature("IFX_SYSINDEXES"); }
                strcpy($<str>$,A4GLSQLCV_check_tablename($<str>1));
                }
;


table_name_i:
/*
        CHAR_VALUE {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename(NULL, A4GL_strip_quotes($<str>1)));
             ADDMAP("Use Table",$<str>$);
        } */
        CHAR_VALUE KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename($<str>1, $<str>3));
	     ADDMAP("Use Table",$<str>$);
        }
        | identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename(NULL, $<str>1));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier COLON identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, NULL, A4GLSQLCV_ownerize_tablename(NULL, $<str>3)));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier COLON CHAR_VALUE KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, NULL, A4GLSQLCV_ownerize_tablename($<str>3,$<str>5)));
	     ADDMAP("Use Table",$<str>$);
        }
        | identifier ATSIGN identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename(NULL,$<str>1, A4GLSQLCV_ownerize_tablename(NULL, $<str>3)));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier ATSIGN identifier COLON identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, $<str>3, A4GLSQLCV_ownerize_tablename(NULL, $<str>5)));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier ATSIGN identifier COLON CHAR_VALUE KW_DOT identifier{
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, $<str>3, A4GLSQLCV_ownerize_tablename($<str>5, $<str>7)));
	     ADDMAP("Use Table",$<str>$);
        }
;



table_name_not_for_column_prefix: table_name_not_for_column_prefix_i  {
                if (strstr($<str>1,"systables")!=0) { add_feature("IFX_SYSTABLES"); }
                if (strstr($<str>1,"syscolumns")!=0) { add_feature("IFX_SYSCOLUMNS"); }
                if (strstr($<str>1,"sysindexes")!=0) { add_feature("IFX_SYSINDEXES"); }
                strcpy($<str>$,A4GLSQLCV_check_tablename($<str>1));
                }
;


table_name_not_for_column_prefix_i:
         CHAR_VALUE KW_DOT identifier {

	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename($<str>1, $<str>3));
	     ADDMAP("Use Table",$<str>$);
        }
        | identifier KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename($<str>1, $<str>3));
	     ADDMAP("Use Table",$<str>$);
        }
        | CHAR_VALUE {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename(NULL, A4GL_strip_quotes($<str>1)));
	     ADDMAP("Use Table",$<str>$);
        }
        | identifier {
             SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename(NULL, $<str>1));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier COLON identifier {
             SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1,NULL, A4GLSQLCV_ownerize_tablename(NULL, $<str>3)));
	     ADDMAP("Use Table",$<str>$);
	}
        | identifier COLON CHAR_VALUE KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, NULL,A4GLSQLCV_ownerize_tablename($<str>3, $<str>5)));
	     ADDMAP("Use Table",$<str>$);
        }

	| identifier ATSIGN identifier {
             SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename(NULL, $<str>1, A4GLSQLCV_ownerize_tablename(NULL, $<str>3)));
	     ADDMAP("Use Table",$<str>$);
	}
	| identifier ATSIGN identifier COLON identifier {
            SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename( $<str>1, $<str>3, A4GLSQLCV_ownerize_tablename(NULL, $<str>5)));
	    ADDMAP("Use Table",$<str>$);
	}
	| identifier ATSIGN identifier COLON CHAR_VALUE KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_db_tablename($<str>1, $<str>3, A4GLSQLCV_ownerize_tablename($<str>5, $<str>7)));
	     ADDMAP("Use Table",$<str>$);
        }

;

idx_name:
         CHAR_VALUE KW_DOT identifier {
	     SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename($<str>1, $<str>3));
        }
        | CHAR_VALUE {
	        SPRINTF1($<str>$,"%s", A4GLSQLCV_ownerize_tablename(NULL, $<str>1));
                ADDMAP("Use Index",$<str>$);
        }

        | identifier {strcpy($<str>$,$<str>1); ADDMAP("Use Index",$<str>1); }
        | identifier COLON identifier { SPRINTF3($<str>$,"%s%s%s",$<str>1,$<str>2,$<str>3); ADDMAP("Use Index",$<str>$); }
        | identifier COLON CHAR_VALUE KW_DOT identifier {
	     SPRINTF2($<str>$,"%s:%s", $<str>1, A4GLSQLCV_ownerize_tablename($<str>3, $<str>5));
             ADDMAP("Use Index",$<str>$);
        }

        | identifier ATSIGN identifier {strcpy($<str>$,$<str>1); ADDMAP("Use Index",$<str>1); }
        | identifier ATSIGN identifier COLON identifier { SPRINTF4($<str>$,"%s@%s%s%s",$<str>1,$<str>3,$<str>4,$<str>5); ADDMAP("Use Index",$<str>$); }
        | identifier ATSIGN identifier COLON CHAR_VALUE KW_DOT identifier {
	     SPRINTF3($<str>$,"%s@%s:%s", $<str>1, $<str>3, A4GLSQLCV_ownerize_tablename($<str>5, $<str>7));
             ADDMAP("Use Index",$<str>$);
        }


;

identifier: NAMED 
;

fetch_cursor_name_p: NAMED {
                      $<ptr>$=A4GL_new_expr_simple_string(A4GL_get_clobbered_from($<str>$), ET_EXPR_IDENTIFIER);
	}
;

real_number : NUMBER_VALUE 
	| KW_DOT INT_VALUE { sprintf($<str>$,".%s",$<str>2); }
;


var_ident_qchar : NAMED
	| CHAR_VALUE {strcpy($<str>$, A4GL_strip_quotes ($<str>1));}

;


opt_into_sel: {$<ptr_list>$=0;}
;


char_or_var : CHAR_VALUE 
	| variable { if ((scan_variable($<str>1)&15)!=0) {a4gl_yyerror("Variable must be of type charr..");YYERROR;} }
;

opt_use : {strcpy($<str>$,"");} 
	| USE_SESSION conn_id KW_FOR { print_use_session($<str>3); strcpy($<str>$,A4GL_get_undo_use()); }
;

conn_id : var_ident
;


variable : NOT_USED_1
;

obind_var_list: NOT_USED_2
;

fgl_sql_statement: NOT_USED_3
;

var_ident: identifier
;



ident_or_var: identifier
	| QUESTION_MARK {
			if (A4GL_isyes(acl_getenv("DOING_CM"))) {
				strcpy($<str>$,"?@@PARAM@@?");
			} else {
				strcpy($<str>$,"?");
			}
	}
;


sql_statement :
	individual_sql_statement
	| sql_statement SEMICOLON individual_sql_statement
;


sql_bound_commands : insert_statement_c  {
			int converted;
			$<sql_string>$=get_insert_cmd($<insert_cmd>1,&converted);
			A4GL_free_associated_mem($<insert_cmd>1);
			acl_free($<insert_cmd>1);

		}
                | update_statement_c {
			int converted;
			$<sql_string>$=get_update_cmd($<update_cmd>1,&converted);
			A4GL_free_associated_mem($<update_cmd>1);
			acl_free($<update_cmd>1);
		}
                | delete_statement_c {
			int converted;
			$<sql_string>$=get_delete_cmd($<delete_cmd>1,&converted);
			A4GL_free_associated_mem($<delete_cmd>1);
			acl_free($<delete_cmd>1);
		}
;



individual_sql_statement : 
		/* Empty statement */
	| set_database_cmd 
	/* | unload_cmd  */
	/* | load_cmd   */
	| sql_commands  		{ print_exec_select($<sql_string>1);  }
	| select_statement_ss_str_cfu 	{ print_exec_select($<sql_string>1);  }
	| set_cmd  			
	| sql_bound_commands 		{ print_exec_select($<sql_string>1);  }

	| sql_transact_commands {
			print_sql_commit ($<integer_val>1);
	}
	| error				{print_unable_to_parse();}
;

select_statement_ss_str_cfu:
	select_statement_ss_str_converted curs_forupdate { $<sql_string>$=make_sql_string_and_free($<sql_string>1,acl_strdup($<str>2),0);
}

;

var_ident_vl : var_ident
;

select_statement_ss_str_converted:
		select_statement_ss_select {
			$<sql_string>$=make_select_stmt_v2("", $<s_select>1,"");
			A4GL_free_select_stmt($<s_select>1);
		}
;

curs_forupdate : {strcpy($<str>$,"");}
                | FOR_UPDATE {
			strcpy($<str>$,A4GLSQLCV_get_forupdate(NULL));
		}
                | FOR_UPDATE_OF cur_update_list {
			strcpy($<str>$,A4GLSQLCV_get_forupdate($<str>2));
		}
;

cur_update_list : colident { strcpy($<str>$,$<str>1); } 
		| cur_update_list KW_COMMA colident { sprintf($<str>$,"%s,%s",$<str>1,$<str>3); }
;

colident: identifier
| identifier KW_DOT identifier {sprintf($<str>$,"%s.%s",A4GLSQLCV_ownerize_tablename(NULL, $<str>1),$<str>3);}
| CHAR_VALUE KW_DOT identifier KW_DOT identifier {
        sprintf($<str>$,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1, $<str>3), $<str>5);
}
                                                                                                                   
;





set_cmd : SQLSEOFF 		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSEON 		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSLMW op_fgl_expr    { sprintf($<str>$,"%s %s",$<str>1,$<str>2); print_exec_sql(acl_strdup($<str>$)); }
	| SQLSLMNW		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSIDR		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSIRR		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSICS		 { print_exec_sql(acl_strdup($<str>1)); }
	| SQLSICR		 { print_exec_sql(acl_strdup($<str>1)); }
;


var_ident_ibind_sli :  column_name_x { 
	char *s;
	s=acl_strdup($<str>1);
	$<s_select_list_item>$=new_select_list_item_column_from_transform(s);
	acl_free(s);
	}
	 | QUESTION_MARK {  
		$<s_select_list_item>$=new_select_list_item_builtin_const(E_SLI_QUERY_PLACEHOLDER);}
	| replace_with_variable {
		$<s_select_list_item>$=new_select_list_item_replace_var($<sql_string>1);
	}
;

var_ident_ibind_ss :  column_name_x { $<sql_string>$=acl_strdup($<str>1);}
	 | QUESTION_MARK {  
			if (A4GL_isyes(acl_getenv("DOING_CM"))) {
				$<sql_string>$=acl_strdup("?@@PARAM@@?");
			} else {
				$<sql_string>$=acl_strdup("?");
			}
	}
	| replace_with_variable {
		$<sql_string>$=$<sql_string>1;
	}
;

set_database_cmd :
       DATABASE var_ident_qchar op_db_exclusive {
        add_feature("DATABASE_USED");
       conn_db($<str>2);
}

;


replace_with_variable : MARK_VAR CHAR_VALUE END_MARK_VAR {
		$<sql_string>$=acl_strdup($<str>2);
}
;


arr_expr :
	OPEN_BRACKET arr_expr CLOSE_BRACKET  {sprintf($<str>$,"(%s)",$<str>2);}
	| arr_expr arr_next_math arr_expr { sprintf($<str>$,"%s%s%s",$<str>1,$<str>2,$<str>3);}
	| INT_VALUE {sprintf($<str>$,"%d",atoi($<str>1));}
	| arr_int_sign INT_VALUE {sprintf($<str>$,"(%s%s)",$<str>1,$<str>2);}
	;


arr_next_math:
        KW_PLUS {strcpy($<str>$,"+");}
|       KW_MINUS {strcpy($<str>$,"-");}
|       KW_MULTIPLY {strcpy($<str>$,"*");}
|       KW_DIVIDE {strcpy($<str>$,"/");}
|       KW_MOD {strcpy($<str>$,"%");}
;



arr_int_sign    : KW_PLUS {strcpy($<str>$,"+");}
                | KW_MINUS {strcpy($<str>$,"-");}
;




op_substr : {strcpy($<str>$,"");}
	| OPEN_SQUARE arr_expr CLOSE_SQUARE {
		sprintf($<str>$,"[%s]", $<str>2);
	}
	| OPEN_SQUARE arr_expr KW_COMMA arr_expr CLOSE_SQUARE {
		sprintf($<str>$,"[%s,%s]", $<str>2,$<str>4);
	}
;

column_name_x:
	identifier {sprintf($<str>$,"%s", A4GLSQLCV_check_tablename($<str>1));}
	| identifier KW_DOT KW_MULTIPLY {sprintf($<str>$,"%s.*", A4GLSQLCV_ownerize_tablename(NULL,$<str>1));}
	| identifier KW_DOT KW_ROWID {sprintf($<str>$,"%s.%s", $<str>1,A4GLSQLCV_get_sqlconst ("rowid"));}
	| identifier KW_DOT identifier {sprintf($<str>$,"%s.%s", A4GLSQLCV_ownerize_tablename(NULL,$<str>1),$<str>3);}
	| identifier KW_DOT identifier KW_DOT identifier {sprintf($<str>$,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3),$<str>5);}
	| CHAR_VALUE KW_DOT identifier KW_DOT identifier {sprintf($<str>$,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3),$<str>5);}
	| identifier OPEN_SQUARE arr_expr CLOSE_SQUARE 						{sprintf($<str>$,"%s", $<str>1); strcpy($<str>$, A4GLSQLCV_make_substr_s($<str>1, 1,$<str>3,0));}
	| identifier KW_DOT identifier  OPEN_SQUARE arr_expr CLOSE_SQUARE 			{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename(NULL,$<str>1),$<str>3); strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,1,$<str>5,0));}
	| identifier KW_DOT identifier KW_DOT identifier OPEN_SQUARE arr_expr CLOSE_SQUARE 	{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3), $<str>5); strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,1,$<str>7,0));  }
	| CHAR_VALUE KW_DOT identifier KW_DOT identifier  OPEN_SQUARE arr_expr CLOSE_SQUARE 	{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3), $<str>5);  strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,1,$<str>7,0)); }
	
	| identifier OPEN_SQUARE arr_expr KW_COMMA arr_expr CLOSE_SQUARE 			{sprintf($<str>$,"%s", $<str>1); strcpy($<str>$, A4GLSQLCV_make_substr_s($<str>1, 2,$<str>3,$<str>5));}
	| identifier KW_DOT identifier  OPEN_SQUARE arr_expr  KW_COMMA arr_expr CLOSE_SQUARE 			{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename(NULL,$<str>1),$<str>3); strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,2,$<str>5,$<str>7));}
	| identifier KW_DOT identifier KW_DOT identifier OPEN_SQUARE arr_expr  KW_COMMA arr_expr CLOSE_SQUARE 	{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3), $<str>5); strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,2,$<str>7,$<str>9));  }
	| CHAR_VALUE KW_DOT identifier KW_DOT identifier  OPEN_SQUARE arr_expr  KW_COMMA arr_expr CLOSE_SQUARE 	{char buff[256]; sprintf(buff,"%s.%s", A4GLSQLCV_ownerize_tablename($<str>1,$<str>3), $<str>5);  strcpy($<str>$, A4GLSQLCV_make_substr_s(buff,2,$<str>7,$<str>9)); }
;


value_expression_initial_sli:
        value_expression_initial_sli_nocast  {
                $<s_select_list_item>$=$<s_select_list_item>1;
        }
        | value_expression_initial_sli_nocast  DOUBLE_COLON data_type {
                $<s_select_list_item>$=new_select_list_item_cast($<s_select_list_item>1, $<str>3);
        }

;



value_expression_initial_sli_nocast :
        value_expression_complex_sli { $<s_select_list_item>1=$<s_select_list_item>1; }
        | var_ident_ibind_sli    {$<s_select_list_item>1=$<s_select_list_item>1;}
        | subquery_sli {  $<s_select_list_item>$=new_select_list_item_sq(E_SQE_DONT_CARE,$<s_select_list_item>1); }
        | ALL subquery_sli   { $<s_select_list_item>$=new_select_list_item_sq(E_SQE_ALL,$<s_select_list_item>2); }
        | ANY subquery_sli   { $<s_select_list_item>$=new_select_list_item_sq(E_SQE_ANY,$<s_select_list_item>2); }
        | SOME subquery_sli  { $<s_select_list_item>$=new_select_list_item_sq(E_SQE_SOME,$<s_select_list_item>2); }
;


op_fgl_expr :  {strcpy($<str>$,"");}
	| INT_VALUE {strcpy($<str>$,$<str>1);}
;


opt_use2_p:
;


spl_proc_name:
        identifier {strcpy($<str>$,$<str>1);}
        | identifier COLON identifier {sprintf($<str>$,"%s:%s",$<str>1,$<str>3);}
;


atline : {
	$<integer_val>$=-1;
}
%%

#if LEX_YY_PREGEN
#include "../../tools/no_yacc/cygwin/compilers/sql/lex.sqlparse_yy.c"
#else
#include "lex.yy.c"
#endif
#include "util.c"
#include "cmds.c"
