/*
 * lib=RPC env=A4GL_RPCTYPE lib_prefix=A4GLRPC_ api_prefix=
 * @file
 * File definition
 *
 * This file was created from .spec file of same name, using dlmagic script
 * - if you need to edit it, edit .spec file instad, and use [make filename.c]
 * to re-create it.
 *
 * @todo Add Doxygen comments to file
 * @todo Take the prototypes here declared. See if the functions are static
 * or to be externally seen
 * @todo Doxygen comments to add to functions
 */

/*******************************************************************
* (c) 1997-2005 Aubit Computing Ltd.
*
*
********************************************************************/


#include "a4gl_libaubit4gl_int.h"

#ifdef DEBUG
#ifndef DEBUG_SPEC
#define DEBUG_SPEC
#endif
#endif
static void *libptr=0;
static void clrcachedptrs(void);
void A4GLRPC_clrlibptr (void);
int dlclose (void *__handle);

typedef int(*x_func_1)(char *  ,int ,char *  ,int ,int );
static x_func_1 func_1=0;
typedef int(*x_func_2)(char *  ,void *  );
static x_func_2 func_2=0;
typedef int(*x_func_3)(char *  );
static x_func_3 func_3=0;
typedef int(*x_func_4)(long );
static x_func_4 func_4=0;
/**
 * Library init function.
 *
 * @todo : explain ussage and parameters.
 * @return .
 */

static char currentLib[512]="";
void A4GLRPC_clrlibptr (void) {
    if (libptr) {dlclose(libptr);}
    libptr=0;
    strcpy(currentLib,"");
    clrcachedptrs();
}

int A4GLRPC_initlib (void) {
typedef int (*x_func)(void);
static x_func func=0;
   char *newlib;
   newlib=acl_getenv("A4GL_RPCTYPE");
   if (strcmp(newlib,currentLib)!=0) {A4GLRPC_clrlibptr ();}
   libptr=(void *)A4GL_dl_openlibrary("RPC",newlib);
   if (libptr==0) {
      A4GL_exitwith("Unable to open RPC library...");
      return 0;
   }
   strcpy(currentLib, newlib);
   func=(x_func)A4GL_find_func_allow_missing(libptr,"A4GLRPC_RPC_initlib");

   if (func)
      return func();
   else
      return 1;
}


/* int A4GL_remote_func_call (char *host, int async, char *funcname, int port, int np) */
/* int A4GL_register_func(char *s,void *ptr)  */
/* int A4GL_unregister_func(char *s,void *ptr)  */
/* int A4GL_server_run(long service)  */
int A4GL_remote_func_call(char* host,int async,char* funcname,int port,int np) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int A4GL_remote_func_call((%s)),%d,(%s)),%d,%d)\n",A4GL_null_as_null(host),async,A4GL_null_as_null(funcname),port,np);
#endif
   if (libptr==0) A4GLRPC_initlib();
   if (func_1==0 || A4GL_never_dlmagic_cache("A4GLRPC_A4GL_remote_func_call")) {
        func_1=(x_func_1)A4GL_find_func(libptr,"A4GLRPC_A4GL_remote_func_call");
   }
   rval=(int)func_1 (host,async,funcname,port,np);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int A4GL_register_func(char* s,void* ptr) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int A4GL_register_func((%s)),%p)\n",A4GL_null_as_null(s),ptr);
#endif
   if (libptr==0) A4GLRPC_initlib();
   if (func_2==0 || A4GL_never_dlmagic_cache("A4GLRPC_A4GL_register_func")) {
        func_2=(x_func_2)A4GL_find_func(libptr,"A4GLRPC_A4GL_register_func");
   }
   rval=(int)func_2 (s,ptr);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int A4GL_unregister_func(char* s) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int A4GL_unregister_func((%s)))\n",A4GL_null_as_null(s));
#endif
   if (libptr==0) A4GLRPC_initlib();
   if (func_3==0 || A4GL_never_dlmagic_cache("A4GLRPC_A4GL_unregister_func")) {
        func_3=(x_func_3)A4GL_find_func(libptr,"A4GLRPC_A4GL_unregister_func");
   }
   rval=(int)func_3 (s);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

int A4GL_server_run(long service) {
int rval;
#ifdef DEBUG_SPEC
A4GL_debug("Call to int A4GL_server_run(%p)\n",service);
#endif
   if (libptr==0) A4GLRPC_initlib();
   if (func_4==0 || A4GL_never_dlmagic_cache("A4GLRPC_A4GL_server_run")) {
        func_4=(x_func_4)A4GL_find_func(libptr,"A4GLRPC_A4GL_server_run");
   }
   rval=(int)func_4 (service);
#ifdef DEBUG_SPEC
A4GL_debug("Returning '%d'",rval);
#endif
return rval;
}

static void clrcachedptrs(void) {
   func_1=NULL;
   func_2=NULL;
   func_3=NULL;
   func_4=NULL;
}
