/*
# +----------------------------------------------------------------------+
# | Aubit 4gl Language Compiler Version $.0                              |
# +----------------------------------------------------------------------+
# | Copyright (c) 2000-2005 Aubit Development Team (See Credits file)    |
# +----------------------------------------------------------------------+
# | This program is free software; you can redistribute it and/or modify |
# | it under the terms of one of the following licenses:                 |
# |                                                                      |
# |  A) the GNU General Public License as published by the Free Software |
# |     Foundation; either version 2 of the License, or (at your option) |
# |     any later version.                                               |
# |                                                                      |
# |  B) the Aubit License as published by the Aubit Development Team and |
# |     included in the distribution in the file: LICENSE                |
# |                                                                      |
# | This program is distributed in the hope that it will be useful,      |
# | but WITHOUT ANY WARRANTY; without even the implied warranty of       |
# | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        |
# | GNU General Public License for more details.                         |
# |                                                                      |
# | You should have received a copy of both licenses referred to here.   |
# | If you did not, or have any questions about Aubit licensing, please  |
# | contact licensing@aubit.com                                           |
# +----------------------------------------------------------------------+
#
# $Id: newpanels.c,v 1.195 2016-06-17 15:24:43 mikeaubury Exp $
#*/
#ifndef lint
	static char const module_id[] =
		"$Id: newpanels.c,v 1.195 2016-06-17 15:24:43 mikeaubury Exp $";
#endif

/**
 * @file
 * Pannels implementation, like windows, prompts lines, etc
 *
 * @todo Add Doxygen comments to file
 * @todo Take the prototypes here declared. See if the functions are static
 * or to be externally seen
 * @todo Doxygen comments to add to functions
 */


/*
=====================================================================
		                    Includes
=====================================================================
*/

#include "a4gl_lib_ui_tui_int.h"
#include <ctype.h>

/*
=====================================================================
                Platform specific definitions
=====================================================================
*/


#ifdef __CYGWIN__
dll_import struct s_form_attr std_dbscr;
dll_import sqlca_struct sqlca;

#endif


static int find_window_number_for_window_name(char *win_name) ;
void A4GL_monitor_key_pressed(int a) ;
int monitoring=-1;
WINDOW * A4GL_window_on_top_ign_menu (void);
void A4GL_make_window_with_this_form_current(void *form);
/*
=====================================================================
                    Constants definitions
=====================================================================
*/

#define MAXWIN 200
#define MAXPOINTERS 2000


#define USE_HALF_DELAY



/*
=====================================================================
                    Variables definitions
=====================================================================
*/
extern int have_default_colors;
WINDOW *currwin;
int scr_width = -1;
int scr_height = -1;
int currwinno = -1;
int currattr = 0;
int
A4GL_decode_line_scr (int l);
void A4GL_monitor_screen(void) ;


/*
   struct ptrs
   {
   char ptr_type;
   char name[20];
   void *ptr;
   }
   pointers[MAXPOINTERS];
 */

struct s_windows
{
  int x, y, w, h;
  PANEL *pan;
  WINDOW *win;

  WINDOW *dswin; // Drop shadow window
  PANEL *dspan;  // drop shadow panel
  char name[100];
  struct s_form_dets *form;
  struct s_form_attr winattr;
  int form_created_with_window;
};


struct s_windows windows[MAXWIN];




static WINDOW *
A4GL_create_window (char *name, int x, int y, int w, int h,
               int iswindow,
               int form_line,
               int error_line,
               int prompt_line,
               int menu_line,
               int border, int comment_line, int message_line, int attrib,int with_form,char *style);
static WINDOW *A4GL_display_form (struct s_form_dets *f,int attr);
static WINDOW *A4GL_display_form_new_win (char *name, struct s_form_dets *f, int x,
                              int y,int attr,char *style);
/*
=====================================================================
                    Functions prototypes
=====================================================================
*/
/** @todo Take this prototypes of from here */

/*
=====================================================================
                    Functions definitions
=====================================================================
*/


void setBorder(WINDOW *w) {
//wborder_set(stdscr,l,r,t,b,tl,tr,bl,br)
             	if (A4GL_isyes(acl_getenv("SIMPLE_GRAPHICS")))  {
                      	wborder (w, '|', '|', '-', '-', '+','+', '+', '+');
              	} else {
                      	wborder (w, 0, 0, 0, 0,0, 0, 0, 0);
                      	//wborder (w, WACS_BTTB, WACS_BTTB, WACS_D_HLINE, WACS_D_HLINE,WACS_D_ULCORNER, WACS_D_URCORNER, WACS_D_LLCORNER, WACS_D_LRCORNER);
              	}
}

/**
 * Find the description of the pointer type
 *
 * @todo Understand and fix the duplicate definition of CODE(s) in pointers.h
 * and dbforms.h.
 *
 * @param c The pointer type in integer (described by some defines 
 * from pointers.h and dbforms.h)
 * @return a string that identifies the pointer type
 */
char *
A4GL_pointer_code (int c)
{
  switch (c)
    {

    case PANCODE:
      return "'panel'";
    case WINCODE:
      return "'window'";
    //case CURCODE:
      //return "'cursor'";
    //case PRECODE:
      //return "'prepare statement'";
    case FORMCODE:
      return "'form'";
    case S_WINDOWSCODE:
      return "'windows information'";
    case S_FORMDETSCODE:
      return "'form details'";
    case SESSCODE:
      return "'session'";
    case RPC_FUNC:
      return "'RPC Function'";
    }
  return "Unknown";
}

/**
 *
 * @todo Describe function
 */
LIBUSEONLY int
A4GL_init_windows (void)
{
  int a;
  for (a = 0; a < MAXWIN; a++)
    {
      windows[a].name[0] = 0;
    }
  A4GL_create_blank_window ("screen", 1, 1, 79, 23, 0);
  UILIB_A4GL_current_window ("screen");
  /*error_box("Currwin=screen"); */
  A4GL_init_stddbscr ();
  return 0;

}

/**
 *
 * @todo Describe function
 */
LIBUSEONLY void *
A4GL_create_blank_window (char *name, int x, int y, int w, int h, int border)
{
  A4GL_chkwin();
  return A4GL_create_window (name, x, y, w, h, 1, 
		0xff, 0xff, 0xff, 0xff, border, 0xff, 0xff,
			0xffff,0,0);
}

/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_create_window (char *name, int x, int y, int w, int h,
	       int iswindow,
	       int form_line,
	       int error_line,
	       int prompt_line,
	       int menu_line,
	       int border, int comment_line, int message_line, int attrib,int with_form,char *style)
{
  WINDOW *win = 0;
  WINDOW *dswin=NULL;
  PANEL *pan;
  PANEL *dspan=NULL;
  int a;
  int reverse_attr;
  A4GL_chkwin ();
 
#ifdef DEBUG
  A4GL_debug ("Creating window %s (%d %d %d %d) border=%d attrib=0x%x - error line=%d", name, x, y,
	 w, h, border, attrib,error_line);
#endif


if (A4GL_isyes(acl_getenv("ODDOPTIONS"))) {
 if (attrib!=0xffff) { // Strangely - informix resets the 'options' when you open a new window
		A4GL_set_option_value('d',0);
 }
}

  if (attrib == 0xffff)
    {
      char *s;
      int a;
      int n;
      s = acl_getenv ("BACKGROUND");
      if (strlen (s))
	{
	  n = sscanf (s, "%x", &a);
	  if (n)
	    {
	      attrib = a;
	    }
	}
      else
	{
	  attrib = 0x0;
	}

    }


  if ((attrib & 0xff) == 0 || (attrib & 0xff) == 0xff)
    {
      attrib = attrib + ' ';
#ifdef DEBUG
      A4GL_debug ("Set pad char to space");
#endif
    }

  reverse_attr=A4GL_decode_aubit_attr(attrib,'w');
  if (reverse_attr & A_REVERSE) {
	reverse_attr-=A_REVERSE;
   } else {
	reverse_attr+=A_REVERSE;
  }

  if (border && style && A4GL_aubit_strcasecmp(style,"zoom")==0) {
	int a;
  	WINDOW *winx = 0;
	int lw=-1;
	int lh=-1;
        for (a=0;a<100;a++) {
                int iw;
                int ih;
                iw=(a*w)/100;
                ih=(a*h)/100;
		if (iw ==0 || ih==0) continue;
		if (lw!=iw || lh!=ih) {
			lw=iw;
			lh=ih;
                	winx = newwin (ih + 2, iw + 2, y - 2, x - 2);
			setBorder(winx);
/*
                	if (A4GL_isyes(acl_getenv("SIMPLE_GRAPHICS")))  {
                        	wborder (winx, '|', '|', '-', '-', '+','+', '+', '+');
                	} else {
                        	wborder (winx, 0, 0, 0, 0, 0, 0, 0, 0);
                	}*/
                	A4GL_mja_wrefresh (winx);
			UILIB_A4GL_zrefresh();
                	delwin (winx);
		}
		a4gl_usleep(500);
        }
	border=1; // Zoom forces border...
  }


  if (style && A4GL_aubit_strcasecmp(style,"ds/")==0) { // drop shadow to lower right - ie. style "1"
	reverse_attr=reverse_attr>>8;
	reverse_attr=reverse_attr<<8;
	reverse_attr+='/';
	style="ds1";
  }

  if (style && A4GL_aubit_strcasecmp(style,"ds.")==0) { // drop shadow to lower right - ie. style "1"
	reverse_attr=reverse_attr>>8;
	reverse_attr=reverse_attr<<8;
	reverse_attr+='.';
	style="ds1";
  }
  if (style && A4GL_aubit_strcasecmp(style,"ds#")==0) { // drop shadow to lower right - ie. style "1"
	reverse_attr=reverse_attr>>8;
	reverse_attr=reverse_attr<<8;
	reverse_attr+='#';
	style="ds1";
  }

  if (style && A4GL_aubit_strcasecmp(style,"ds1")==0) { // drop shadow to lower right - ie. style "1"
	if (border) {
	  dswin = newwin (h + 2, w + 2, y -1, x - 1);
	  A4GL_add_pointer (name, WINCODE, win);
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	} else {
	  dswin = newwin (h,w , y, x );
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	}
  }

  if (style && A4GL_aubit_strcasecmp(style,"ds3")==0) { // drop shadow to lower right - ie. style "1" - but with 2 characters across
	if (border) {
	  dswin = newwin (h + 2, w + 2, y -1, x );
	  A4GL_add_pointer (name, WINCODE, win);
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	} else {
	  dswin = newwin (h,w , y, x+1 );
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	}
  }

  if (style && A4GL_aubit_strcasecmp(style,"ds2")==0) { // drop shadow all around... ie style "2"
	if (border) {
	  dswin = newwin (h+4 , w + 4, y -3, x - 3);
	  A4GL_add_pointer (name, WINCODE, win);
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	} else {
	  dswin = newwin (h+2,w+2 , y-2, x-2 );
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
	  wbkgd (dswin, reverse_attr);
	  A4GL_mja_wrefresh (dswin);
	}

  }

  if (strcmp (name, "screen") == 0)
    {
	if (A4GL_screen_width ()>255) {
		if (resizeterm( A4GL_screen_height (), 255)!=OK) {
			A4GL_exitwith("Screen too wide - maximum 255 characters");
			A4GL_chk_err(0,"");
			return 0;
		}
	}

      h = A4GL_screen_height () - 1;
      w = A4GL_screen_width () - 1;
#ifdef DEBUG
      A4GL_debug ("Creating window : h=%d w=%d y=%d x=%d", h, w, y - 1, x - 1);
      A4GL_debug ("win = newwin (%d,%d,0,0)", A4GL_screen_height (), A4GL_screen_width ());
#endif

      win = newwin (0, 0, 0, 0);
#ifdef DEBUG
      A4GL_debug ("Calling screen height");
      A4GL_debug ("h=%d", h);
      A4GL_debug ("Calling screen width");
      A4GL_debug ("w=%d", w);
#endif
      A4GL_add_pointer (name, WINCODE, win);
    }
  else
    {

      if (border == 1)
	{
	  win = newwin (h + 2, w + 2, y - 2, x - 2);
	  if (a4gl_toupper (name[0]) != name[0]) {
	  	A4GL_add_pointer (name, WINCODE, win);
	  }
	}

      if (border == 3)
	{
	  dswin = newwin (h + 4, w + 4, y - 1, x - 1);
	  win = newwin (h, w, y - 2, x - 2);
	  A4GL_add_pointer (name, WINCODE, win);
	  //A4GL_add_pointer (name, DROPSHADOW, dswin);
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wbkgdset (dswin, COLOR_RED | A_REVERSE | '+');
	  A4GL_mja_wrefresh (win);
	  A4GL_mja_wrefresh (dswin);
		sleep(3);
	}

      if (border == 0)
	{
	  win = newwin (h, w, y - 1, x - 1);
	  if (a4gl_toupper (name[0]) != name[0])
	  A4GL_add_pointer (name, WINCODE, win);
#ifdef DEBUG
	  A4GL_debug ("Window = %p name=%s", win,name);
#endif
	}

    }

#ifdef DEBUG
  A4GL_debug ("Window created");
#endif

  if (win == 0)
    {
#ifdef DEBUG
      A4GL_debug ("Couldn't create window h=%d w=%d y=%d x=%d", h, w, y, x);
#endif
      A4GL_exitwith ("Couldn't create window");
      return 0;
    }

  A4GL_mja_wrefresh (win);



#ifdef DEBUG
  A4GL_debug ("Setting attribute for window to 0x%x for %s\n", attrib, name);
#endif



  A4GL_set_bkg (win, attrib);


  A4GL_add_pointer (name, ATTRIBUTE, (void *) ((long)attrib));
  if (border)
    {
#ifdef DEBUG
      A4GL_debug ("Adding border %x", attrib);
#endif

      A4GL_set_bkg (win, attrib);
      setBorder(win);

/*
   if (A4GL_isyes(acl_getenv("SIMPLE_GRAPHICS")))  {
      wborder (win, '|', '|', '-', '-', '+','+', '+', '+');
   } else {
      wborder (win, 0, 0, 0, 0, 0, 0, 0, 0);
   }
*/
      A4GL_mja_wrefresh (win);
    }
#ifdef DEBUG
  A4GL_debug("new_panel %p",win);
#endif
  if (dswin) {
	dspan=new_panel(dswin);
  }
  pan = new_panel (win);

#ifdef DEBUG
  A4GL_debug("New panel %p for window %p name '%s'  ",pan,win,name);
#endif
  set_panel_userptr (pan, strdup (name));
  A4GL_add_pointer (name, PANCODE, pan);

#ifdef DEBUG
  {
    A4GL_debug ("Panel created at %p for window %p", pan, win);
  }
#endif

  if (pan == 0)
    {
      A4GL_error_box ("Couldn't create panel",0);
    }


  for (a = 0; a < MAXWIN; a++)
    {
      if (windows[a].name[0] == 0)
	{
#ifdef DEBUG
	  {
	    A4GL_debug ("Adding window at %d panel id = %p", a, pan);
	  }
#endif
	  strcpy (windows[a].name, name);
	  A4GL_add_pointer (name, S_WINDOWSCODE, &windows[a]);
	  windows[a].pan = pan;
	  windows[a].dspan = dspan;
	  windows[a].dswin = dswin;
	  windows[a].form = 0;
	  windows[a].winattr.comment_line = comment_line;
	  windows[a].winattr.menu_line = menu_line;
#ifdef DEBUG
	  A4GL_debug ("Setting prompt line to %d", prompt_line);
#endif
	  windows[a].winattr.prompt_line = prompt_line;
	  windows[a].winattr.form_line = form_line;
	  windows[a].winattr.message_line = message_line;
	  windows[a].winattr.error_line = error_line;
	  windows[a].winattr.border = border;
	  windows[a].winattr.colour = attrib;
	  windows[a].x = x;
	  windows[a].y = y;
	  windows[a].w = w;
	  windows[a].h = h;
	  windows[a].win = win;
	  windows[a].form_created_with_window=with_form;
	  /* A4GL_change_currwin (win); */
	  break;
	}
    }
  if (!(A4GL_has_pointer (name, S_WINDOWSCODE)))
    {
      A4GL_exitwith ("No spare windows left...");
      return 0;
    }

  keypad (win, TRUE);

#ifdef DEBUG
  A4GL_debug ("Deciding what to do... %s\n", name);
#endif
  if (a4gl_toupper (name[0]) != name[0] || 1)
    {
#ifdef DEBUG
      {
 A4GL_debug ("Making proper window....for %s", name);
      }
#endif
      A4GL_change_currwin (win, "Marker 1");
      A4GL_change_currwinno (a, "Marker 2");
      top_panel (pan);

      if (UILIB_A4GL_screen_mode (-1))
	{
	  update_panels ();
	  doupdate ();
	}
#ifdef DEBUG
      {
 A4GL_debug ("Adding new pointer to window...");
      }
      {
 A4GL_debug ("Done...");
      }
#endif
    }
  else
    {

	A4GL_assertion(1, "Fake window - thought I'd got rid of these");
    }
  return win;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_clr_window (char *win_name)
{
  int a;
  WINDOW *w;
  struct s_windows *win;
  A4GL_chkwin ();
  if (!(A4GL_has_pointer (win_name, WINCODE)))
    {
      A4GL_set_error ("Window not found %s", win_name);
      A4GL_exitwith ("Window not found");
      A4GL_set_errm (win_name);
      return;
    }
#ifdef DEBUG
  {
    A4GL_debug ("Clr window .... %s", win_name);
  }
#endif
  w = A4GL_find_pointer (win_name, WINCODE);
  win = A4GL_find_pointer (win_name, S_WINDOWSCODE);
  werase (w);

  if (win->winattr.border)
    {
#ifdef DEBUG
      A4GL_debug ("Clr screen - redraw border");
#endif
      setBorder(w);
/*
   if (A4GL_isyes(acl_getenv("SIMPLE_GRAPHICS")))  {
      wborder (w, '|', '|', '-', '-', '+','+', '+', '+');
   } else {
      wborder (w, 0, 0, 0, 0, 0, 0, 0, 0);
   }
*/
    }
  UILIB_A4GL_zrefresh ();
  return;

  for (a = 0; a < MAXWIN; a++)
    {
      if (strcmp (windows[a].name, win_name) == 0)
	{
	  werase (panel_window (windows[a].pan));
	  break;
	}
    }
  UILIB_A4GL_zrefresh ();
}



static int find_window_number_for_window_name(char *win_name) {
int a;
  for (a = 0; a < MAXWIN; a++)
    {
      if (strcmp (windows[a].name, win_name) == 0)
	{
	return a;
	  break;
	}
    }
return -1;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_remove_window (char *win_name)
{
  int a;
  int form_created_with_window=0;
  WINDOW *win = 0;
char buff[256]="";
  PANEL *panel = 0;
  struct s_form_dets *f;
#ifdef DEBUG
  A4GL_debug("before remove window - currwinno=%d",currwinno);
#endif
  A4GL_chkwin ();


  f=A4GL_find_pointer (win_name, S_FORMDETSCODE);
#ifdef DEBUG
  {
    A4GL_debug ("Remove Window : %s", win_name);
  }
#endif

  if (!(A4GL_has_pointer (win_name, WINCODE)))
    {
      A4GL_set_error ("Window not found %s", win_name);
      A4GL_exitwith ("Window not found");
      A4GL_set_errm (win_name);
      return;
    }

  for (a = 0; a < MAXWIN; a++)
    {
      if (strcmp (windows[a].name, win_name) == 0)
	{
	  win = panel_window (windows[a].pan);
	  panel = windows[a].pan;
#ifdef DEBUG
	  {
	    A4GL_debug ("Deleting window and panel at %d", a);
	  }
	  {
	    A4GL_debug ("Window found ... deleting... %p", win);
	  }
	  {
	    A4GL_debug ("Deleted window.. deleting panel %p", panel);
	  }
#endif

	if (windows[a].dspan) {
		del_panel(windows[a].dspan);
	}

	if (windows[a].dswin) {
		delwin(windows[a].dswin);
	}

	free((void *)panel_userptr(panel));

	  del_panel (panel);
#ifdef DEBUG
	  {
	    A4GL_debug ("Deleted panel ... removing window");
	  }
#endif
	  delwin (win);



#ifdef DEBUG
	 A4GL_debug("delwin : %p",win);
	  {
	    A4GL_debug ("Here...");
	  }
#endif
	  windows[a].name[0] = 0;
	  windows[a].pan = 0;	
	  form_created_with_window=windows[a].form_created_with_window;
	  break;
	}
    }
#ifdef DEBUG
  {
    A4GL_debug ("Finding top window number");
  }
#endif
  A4GL_top_win (0);
  update_panels ();
  doupdate ();
  refresh ();
  UILIB_A4GL_zrefresh ();
#ifdef DEBUG
  {
    A4GL_debug ("Deleting pointer %s", win_name);
  }
#endif
  A4GL_del_pointer (win_name, WINCODE);
#ifdef DEBUG
  {
    A4GL_debug ("Deleted pointer");
  }
#endif

	if (f) {
		FORM *curses_form;
#ifdef DEBUG
  {
    A4GL_debug ("have a form");
  }
#endif
  		SPRINTF1(buff,"%p",f);
  		A4GL_del_pointer (buff, ATTRIBUTE);

		if (form_created_with_window) {
#ifdef DEBUG
  {
    A4GL_debug ("have a form");
  }
#endif
			//
			// This only gets called if its an open window with form...
			// 
			curses_form=(FORM *)f->form;
			if (curses_form) {
#ifdef DEBUG
  {
    A4GL_debug ("have a curses form");
  }
#endif
#ifdef __WIN32__
#ifdef DEBUG
	A4GL_debug("Skipping unpost on windows - causes a fault for some reason..");
#endif
#else
	unpost_form(curses_form);
#endif
#ifdef DEBUG
    A4GL_debug ("unposted form");
#endif
			
				for (a=0;a<f->fileform->metrics.metrics_len;a++) {
					FIELD *fld;
#ifdef DEBUG
    A4GL_debug ("loop a=%d",a);
#endif
					fld=(FIELD *)f->fileform->metrics.metrics_val[a].field;
					// Do I need to free the buffer ???
					//free(fld->buf);
#ifdef DEBUG
    A4GL_debug ("Here1..");
#endif
					
					if (free_field(fld)!=E_OK) {	
#ifdef DEBUG
A4GL_debug("Couldn't free field"); 
#endif
}

					fld=(FIELD *)f->fileform->metrics.metrics_val[a].dlm1;
#ifdef DEBUG
    A4GL_debug ("Here2..");
#endif
					if (free_field(fld)!=E_OK) {	
#ifdef DEBUG
A4GL_debug("Couldn't free field"); 
#endif
}
					fld=(FIELD *)f->fileform->metrics.metrics_val[a].dlm2;
					if (free_field(fld)!=E_OK) {	
#ifdef DEBUG
A4GL_debug("Couldn't free field"); 
#endif
}
#ifdef DEBUG
    A4GL_debug ("Here3..");
#endif
	
				}
				if (free_form(curses_form)!=E_OK) {
#ifdef DEBUG
					A4GL_debug("Couldn't free form");
#endif
				}
				f->form=0;

			}
			
#ifdef DEBUG
  {
    A4GL_debug ("Here..");
  }
#endif
		
		
			if (f->fileform) {
#ifdef DEBUG
    A4GL_debug ("Here5..");
#endif
//				A4GL_free_associated_mem(f->fileform);
				acl_free(f->fileform);
				f->fileform=NULL;
			}
#ifdef DEBUG
    A4GL_debug ("Here4..");
#endif
//			A4GL_free_associated_mem(f);
			acl_free(f);
		}
	}
#ifdef DEBUG
  {
    A4GL_debug ("more del_pointers");
  }
#endif

  A4GL_del_pointer (win_name, S_WINDOWSCODE);
  A4GL_del_pointer (win_name, S_FORMDETSCODE);
#ifdef DEBUG
  {
    A4GL_debug ("done del_pointers");
  }
#endif
  
#ifdef DEBUG
  A4GL_debug("after remove window - currwinno=%d",currwinno);
#endif

}


/**
 * 4GL CALL
 * @todo Describe function
 */
int
 UILIB_A4GL_current_window (char *win_name)
{
int a;
  PANEL *p;
  WINDOW *w;
#ifdef DEBUG
  A4GL_debug ("Current window....");
  A4GL_debug ("currwinno=%d currwin=%p", currwinno, currwin);
#endif
  A4GL_set_status(0,0);
  A4GL_chkwin ();
#ifdef DEBUG
  {
    A4GL_debug ("In current window %s", win_name);
  }
#endif
  p = A4GL_find_pointer (win_name, PANCODE);
  w = A4GL_find_pointer (win_name, WINCODE);
  if (!(p))
    {
      A4GL_set_error ("%s", win_name);
      A4GL_exitwith ("Window not found");
      A4GL_set_errm (win_name);
      return 0;
    }

	a=find_window_number_for_window_name(win_name);
	if (a>=0) {
		if (windows[a].dspan) {
			top_panel(windows[a].dspan);
		}
	}
  top_panel (p);
  A4GL_change_currwin (panel_window (p), "Marker 5");
  A4GL_change_currwinno (A4GL_find_win (p), "Marker 6");
#ifdef DEBUG
  {
    A4GL_debug ("Changed windows...");
  }
#endif
  if (UILIB_A4GL_screen_mode (-1))
    {
      update_panels ();
      doupdate ();
    }
#ifdef DEBUG
  {
    A4GL_debug ("Updated screen %p", currwin);
  }
#endif
  A4GL_mja_wrefresh (currwin);
#ifdef DEBUG
  {
    A4GL_debug ("wrefresh");
  }
#endif
  UILIB_A4GL_zrefresh ();
  A4GL_mja_refresh ();
#ifdef DEBUG
  {
    A4GL_debug ("Refreshed screen");
  }
#endif
  return 0;

}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_zrefresh (void)
{
	if (monitoring==-1) {
		monitoring=A4GL_isyes(acl_getenv("MONITOR4GL"));
	}

  if (UILIB_A4GL_screen_mode (-1))
    {
      A4GL_chkwin ();


      update_panels ();
      doupdate ();
	if (monitoring) {
      		A4GL_monitor_screen();
	}
    }
}

/**
 *
 * @todo Describe function
 */
void
A4GL_mja_gotoxy (int x, int y)
{
  int a;
  A4GL_chkwin ();

#ifdef DEBUG
  A4GL_debug ("In move - %d %d current window=%p", x, y, A4GL_window_on_top ());
  A4GL_debug ("In move - %d %d", x, y);
#endif
  if (windows[currwinno].winattr.border)
    {
#ifdef DEBUG
      A4GL_debug ("In move border - %d %d", x, y);
#endif
      a = wmove (currwin, y, x);
    }
  else
    {
#ifdef DEBUG
      A4GL_debug ("In move no border - %d %d", x, y);
#endif
      a = wmove (currwin, y - 1, x - 1);
    }
#ifdef DEBUG
  A4GL_debug ("In move - %d %d", x, y);
#endif
  if (a == OK)
    {
#ifdef DEBUG
      A4GL_debug ("Move to %d,%d - %d", x, y, a);
#endif
    }
  else
    {
#ifdef DEBUG
      A4GL_debug ("Move to %d %d fails", x, y);
#endif
    }

  if (A4GL_isyes(acl_getenv("REFRESH_AFTER_MOVE"))) {
  	A4GL_mja_refresh ();
  }
}

/**
 * Renamed from 'print' to 'tui_print'
 * @todo Describe function
 */
/*
void
A4GL_tui_print ( char *fmt, ...)
{
  va_list args;
  char buff[2560];
#ifdef DEBUG
  {
    A4GL_debug ("In tui_print");
  }
#endif
  A4GL_chkwin ();
  va_start (args, fmt);
  vsprintf (buff, fmt, args);
A4GL_debug("addsr : %s",buff);
  waddstr (currwin, buff);

  A4GL_mja_wrefresh (currwin);
}
*/

void
A4GL_tui_printr (int refreshwin, char *fmt, ...)
{
  va_list args;
  char buff[2560];
  int *n = 0;
  int l;
#ifdef DEBUG
  {
    A4GL_debug ("In tui_print");
  }
#endif
  A4GL_chkwin ();
  va_start (args, fmt);
  vsprintf (buff, fmt, args);
#ifdef DEBUG
  A4GL_debug ("addsr : %s", buff);
#endif

  if (A4GL_isyes (acl_getenv ("ENABLEACSMAPPING")) || 1)
    {
      int uses_mappings = 0;
      int a;
      l = strlen (buff);
      n = malloc (sizeof (int) * l);

      for (a = 0; a < l; a++)
	{
	  n[a] = A4GL_has_acs_mapping ((unsigned char) buff[a]);
	  if (n[a])
	    uses_mappings++;
	}

      if (uses_mappings)
	{
	  for (a = 0; a < l; a++)
	    {
	      if (n[a])
		{
		  waddch (currwin, n[a] | A_ALTCHARSET);
		}
	      else
		{
		  waddch (currwin, buff[a]);
		}
	    }

	}
      else
	{
	  waddstr (currwin, buff);
	}
      if (n)
	free (n);
    }
  else
    {
      waddstr (currwin, buff);
    }
  if (refreshwin)
    A4GL_mja_wrefresh (currwin);
}

/**
 * Not used
 * @todo Describe function
 */
/*
static void
erase_form (FORM * f)
{
  WINDOW *w = form_win (f);
  WINDOW *s = form_sub (f);
  A4GL_chkwin ();
  unpost_form (f);
  werase (w);
  A4GL_mja_wrefresh (w);
#ifdef DEBUG
  {    A4GL_debug ("Removing Window %p", s);  }
  {    A4GL_debug ("Removing Window %w", s);  }
#endif
  delwin (s);
  delwin (w);
#ifdef DEBUG
A4GL_debug("delwin %p %p",s,w);
#endif
}
*/

/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_display_form (struct s_form_dets *f,int attrib)
{
  int rows, cols;
  char buff[80];
  int a;

  WINDOW *w;
  WINDOW *drwin;
  /*  FIELD **p; */

  int fl;
  A4GL_chkwin ();
#ifdef DEBUG
  A4GL_debug ("In display_form");
#endif
  w = currwin;

  SPRINTF1(buff,"%p",f);
  A4GL_add_pointer (buff, ATTRIBUTE, (void *) ((long)attrib));

  if (w == 0)
    {
      A4GL_error_box ("NO WINDOW",0);
    }
#ifdef DEBUG
  A4GL_debug ("scale form %p", f->form);
#endif

  fl = A4GL_getform_line ();
  for (a=fl;a<=UILIB_A4GL_get_curr_height();a++) {
	A4GL_mja_gotoxy(1,a);
	wclrtoeol(currwin);
	//attrib=1;
	//UILIB_A4GL_display_internal (1, a, " ", attrib, 1);
  }
  scale_form (f->form, &rows, &cols);
  rows = f->fileform->maxline - 1;
  cols = f->fileform->maxcol;

#ifdef DEBUG
  A4GL_debug ("Form line=%d", fl);
  A4GL_debug ("Scale form returns %d %d", rows, cols);
  A4GL_debug ("Current window[%d] %d %d", currwinno, windows[currwinno].h, windows[currwinno].w);

#endif

  if (windows[currwinno].winattr.border)
    {
      rows++;
    }
  else
    {
    }

  if (rows - windows[currwinno].winattr.border > windows[currwinno].h + 1)
    {
#ifdef DEBUG
	A4GL_debug("%d - %d > %d + 1",rows,windows[currwinno].winattr.border , windows[currwinno].h );
#endif
      A4GL_exitwith ("Window is too small to display this form (too high)");
      return 0;
    }
  if (cols - windows[currwinno].winattr.border > windows[currwinno].w + 1)
    {
      A4GL_exitwith ("Window is too small to display this form (too wide)");
      return 0;
    }


  /* fix - not sure whats going on here bit form_details.border is set to 1 for the screen! */



// I can't seem to replicate this!
  //if (informix_behaviour)
    //{
	//if (currwin!= A4GL_find_pointer ("screen", WINCODE)) {
      		//rows = windows[currwinno].h - fl;
      		//cols = windows[currwinno].w;
	//}
    //}

  f->form_details.border = windows[currwinno].winattr.border;

#ifdef DEBUG
  if (f->form_details.border)
    {
      A4GL_debug ("Form details returns it has border");
    }
  else
    {
      A4GL_debug ("Form details returns it has *NO* border");
    }

  if (windows[currwinno].winattr.border)
    {
      A4GL_debug ("Window details returns it has border");
    }
  else
    {
      A4GL_debug ("Window details returns it has *NO* border ");
    }
  A4GL_debug ("derwin - %d rows %d cols form line=%d", rows, cols, fl);
#endif

  if (windows[currwinno].winattr.border)
    {
#ifdef DEBUG
      A4GL_debug ("MJAPASS1");
#endif
      drwin = derwin (w, rows, cols, fl , 1);
    }
  else
    {
#ifdef DEBUG
      A4GL_debug ("MJAPASS2 rows=%d cols=%d fl=%d", rows, cols, fl);
#endif
      drwin = derwin (w, rows, cols, fl - 1, 0);

    }

#ifdef DEBUG
  {
    A4GL_debug ("drwin=%p", drwin);
  }
#endif

  if (drwin == 0)
    {
      A4GL_exitwith ("Window is too small to display this form");
      return 0;
    }



  werase (drwin);

  a = set_form_win (f->form, w);

  if (a == E_POSTED)
    {
      unpost_form (f->form);
      a = set_form_win (f->form, w);
    }

  a = set_form_sub (f->form, drwin);

#ifdef DEBUG
  A4GL_debug ("setup windows");
#endif
  keypad (w, TRUE);
  SPRINTF1 (buff, "Currwinno=%d", currwinno);
  /*error_box(buff); */
  windows[currwinno].form = f;

  if (f->form == 0)
    {
      A4GL_exitwith ("Unable to create form");
      return 0;
    }

#ifdef DEBUG
  A4GL_debug ("post the form s_form_dets=%p form=%p", f, f->form);
#endif
  a = post_form (f->form);

  if (a == E_POSTED)
    {
#ifdef DEBUG
      A4GL_debug ("Form posted already - dumping and re-doing");
#endif
      unpost_form (f->form);
      a = post_form (f->form);
    }

  if (f->form_details.border)
    {
#ifdef DEBUG
      A4GL_debug ("Form has border");
#endif
      setBorder(w);
/*
   if (A4GL_isyes(acl_getenv("SIMPLE_GRAPHICS")))  {
      wborder (w, '|', '|', '-', '-', '+','+', '+', '+');
   } else {
      wborder (w, 0, 0, 0, 0, 0, 0, 0, 0);
   }
*/
    }

  
#ifdef DEBUG
  A4GL_debug ("start the form");
#endif
  A4GL_start_form (f);

  if ((attrib & 0xff) == 0 || (attrib & 0xff) == 0xff)
    {
      attrib = attrib + ' ';
#ifdef DEBUG
      A4GL_debug ("Set pad char to space");
#endif
    }
#ifdef DEBUG
  A4GL_debug ("Setting attribute for form to 0x%x \n", attrib);
#endif


  A4GL_set_bkg (drwin, attrib);



  A4GL_mja_wrefresh (w);
  A4GL_clr_form(0);
  UILIB_A4GL_zrefresh();
#ifdef DEBUG
  A4GL_debug ("And return");
#endif
  return w;
}


/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_display_form_new_win (char *name, struct s_form_dets * f, int x, int y,int attr,char *style)
{
  WINDOW *w;
  int nlines;
  int rows, cols;
  char buff[80];
  A4GL_chkwin ();
  A4GL_set_status(0,0);
#ifdef DEBUG
  A4GL_debug ("display_form_new_win - name=%s got errorline as %d\n", name,f->form_details.error_line);
#endif
  A4GL_chkwin();
  scale_form (f->form, &rows, &cols);
  if (f->form_details.border)
    {
      rows = f->fileform->maxline - 1;
    }
  else
    {
      rows = f->fileform->maxline;
    }
  cols = f->fileform->maxcol;
#ifdef DEBUG
  A4GL_debug ("display_form_new_win : %d rows %d cols at %d,%d x,y", rows, cols, x,
	 y);
#endif

#ifdef DEBUG
  A4GL_debug ("display_form_new_win - border=%d", f->form_details.border);
#endif
  SPRINTF2 (buff, "%d %d", cols, rows);
#ifdef DEBUG
  {				/*debug("Rows=%d formline=%d f2 = %d",rows,getform_line(),f->form_details.form_line); */
  }
#endif
  if (f->form_details.form_line!=0xff) {
  	nlines = rows + f->form_details.form_line - 1;
  } else {
  	nlines = rows + A4GL_get_dbscr_formline() - 1;
  }
  if (f->form_details.border)
    {
      nlines++;
    }


  w = A4GL_create_window (name, x, y, cols, nlines,
		     1,
		     f->form_details.form_line,
		     f->form_details.error_line,
		     f->form_details.prompt_line,
		     f->form_details.menu_line,
		     f->form_details.border,
		     f->form_details.comment_line,
		     f->form_details.message_line, f->form_details.colour,1,style);
  if (w==0) {
	return 0;
  }

  if (A4GL_display_form (f,attr))
    return w;
  else
    return 0;
  
}

/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_display_form_win (WINDOW * w, char *name, struct s_form_dets * f)
{
  A4GL_chkwin ();
#ifdef DEBUG
  {
    A4GL_debug ("setting form window for %p to %p", f->form, w);
  }
#endif

  set_form_win (f->form, w);
  set_form_sub (f->form, derwin (w, 8, 58, 1, 1));
  keypad (w, TRUE);
  post_form (f->form);
  A4GL_start_form (f->form);
  return w;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_get_curr_win (void)
{
  return currwinno;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void *
 UILIB_A4GL_get_curr_form (int warn_if_no_form)
{
  char buff[80];
  A4GL_chkwin();

  SPRINTF1 (buff, "currwinno=%d", currwinno);

#ifdef DEBUG
  {
    A4GL_debug ("currwinno=%d", currwinno);
  }
#endif

  /*error_box(buff); */
  if (windows[currwinno].form == 0)
    {
	if (warn_if_no_form)  {
      		A4GL_exitwith ("No current form");
	}
      return 0;
    }
  return windows[currwinno].form;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_get_curr_left (void)
{
  return windows[currwinno].x;
/* + windows[currwinno].winattr.border; */
}

/**
 *
 * @todo Describe function
 */
int
 UILIB_A4GL_get_curr_height (void)
{
#ifdef DEBUG
	A4GL_debug("get_curr_height : %d = %d",currwinno,windows[currwinno].h);
#endif
  return windows[currwinno].h;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_get_curr_print_top (void)
{
#ifdef DEBUG
  {
    A4GL_debug ("In curr_print_top %d %d", windows[currwinno].winattr.border,
	   windows[currwinno].y);
  }
#endif

  return windows[currwinno].y + windows[currwinno].winattr.border;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_get_curr_top (void)
{
  return windows[currwinno].y;
}

/**
 *
 * @todo Describe function
 */
int
 UILIB_A4GL_get_curr_width (void)
{
  A4GL_chkwin ();
#ifdef DEBUG
  A4GL_debug ("get curr width, currwinno=%d windows name =%s %d", currwinno,
	 windows[currwinno].name, windows[currwinno].w);
#endif
  return windows[currwinno].w;
}

/**
 *
 * @todo Describe function
 */
char *
 UILIB_A4GL_get_currwin_name (void)
{
  return windows[currwinno].name;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_get_curr_border (void)
{
#ifdef DEBUG
  A4GL_debug ("get curr border, currwinno=%d windows name =%s %d", currwinno,
	 windows[currwinno].name, windows[currwinno].winattr.border);
#endif
  return windows[currwinno].winattr.border;
}


#ifdef OLD
/**
 *
 * @todo Describe function
 */
void
A4GL_mja_setcolor (int typ)
{
#ifdef DEBUG
  A4GL_debug ("Set color.");
#endif
  if (has_colors ())
    {
#ifdef DEBUG
      A4GL_debug ("Has color\n");
#endif
      switch (typ)
	{
	case ERROR_COL:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  currwin->_attrs = A4GL_colour_code (COLOR_RED) | A_REVERSE;
	  break;
	case MESSAGE:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  currwin->_attrs = A4GL_colour_code (COLOR_CYAN) | A_REVERSE;
	  break;
	case NORMAL_MENU:
	  standend ();
	  /* currwin->_attrs = A4GL_colour_code (COLOR_WHITE); */
	  break;
	case INVERT_MENU:
	  standout ();
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  /* currwin->_attrs = A4GL_colour_code (COLOR_WHITE) | A_REVERSE; */
	  break;
	case TITLE_COL:
	  currwin->_attrs = A4GL_colour_code (COLOR_WHITE);
	  break;
	case EDIT_FIELD:
	  currwin->_attrs = A4GL_colour_code (COLOR_WHITE);
	  break;
	case NORMAL_TEXT:
	  /* currwin->_attrs = A4GL_colour_code (COLOR_WHITE); */
	  standend ();
	  break;
	}
      currattr = typ;
    }
  else
    {
      switch (typ)
	{
	case ERROR_COL:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  currwin->_attrs = A_REVERSE;
	  break;
	case MESSAGE:
	  standend ();
	  break;
	case NORMAL_MENU:
	  standend ();
	  break;
	case INVERT_MENU:
	  standout ();
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  /* currwin->_attrs = A_REVERSE; */
	  break;
	case TITLE_COL:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  currwin->_attrs = A_REVERSE;
	  break;
	case EDIT_FIELD:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  currwin->_attrs = A_REVERSE;
	  break;
	case NORMAL_TEXT:
	  standend ();
	  break;
	}
    }
#ifdef DEBUG
  A4GL_debug ("Done..");
#endif
}
#endif

/**
 *
 * @todo Describe function
 */
int
A4GL_getch_win (void)
{
int a;
#ifdef DEBUG
  A4GL_debug ("getch_win called...");
#endif
  a=A4GL_getch_swin (A4GL_window_on_top ());
  if (a) A4GL_clr_error_nobox("A4GL_getch_win");
#ifdef DEBUG
  A4GL_debug("a=%d",a);
#endif
  return a;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_getch_swin (WINDOW * window_ptr)
{
  int a;
  static int no_delay=-1;
#ifdef DEBUG
  A4GL_debug ("Reading from keyboard on window %p", window_ptr);
#endif
  A4GL_set_abort (0);
  a=A4GL_readkey();
  if (a!=0) {
#ifdef DEBUG
		A4GL_debug("Read %d from keyfile",a);
#endif
		return a;
	}

  while (1)
    {
#ifdef USE_HALF_DELAY
	   if (no_delay==-1) {
		    	no_delay=(A4GL_isno(acl_getenv("HALFDELAY")));
	   }

#ifdef DEBUG
	A4GL_debug("HALF DELAY\n");
#endif

	if(!no_delay) {
      		halfdelay (5); 
	}
#endif
#ifdef DEBUG
      A4GL_debug("Waiting for key press");
#endif
#ifdef __WIN32__
#ifdef DEBUG
	A4GL_debug("WINDOW KEYPRESS");
#endif
	keypad(stdscr,TRUE);
      a = wgetch (stdscr); // GETCH - getch_swin
#else
      //a = wgetch (stdscr); // GETCH - getch_swin
      a = getch (); // GETCH - getch_swin
#endif
#ifdef DEBUG
      A4GL_debug("key press : %d",a);
#endif



      if (a==-1 ) {
	if (abort_pressed) {
			//A4GL_debug("logkey %d", A4GL_key_val("INTERRUPT"));
			A4GL_logkey(A4GLKEY_INTERRUPT);
	}
#ifdef USE_HALF_DELAY
	if(!no_delay) {
	      	nocbreak();
	}
#endif
	      	cbreak();

	
	      	return 0;
      }


      if (a == KEY_MOUSE)
	{
#ifdef DEBUG
	  A4GL_debug ("Mouse event...");
#endif
	}

      if (abort_pressed)
	{
#ifdef DEBUG
	  A4GL_debug ("MJAC Aborted!");
#endif
	  a = KEY_CANCEL;
	  break;
	}

      if (a == 18)
        {
          clearok(curscr,1);
          A4GL_mja_refresh ();
        }


      if (a != -1 )
	{
#ifdef DEBUG
	  A4GL_debug ("MJAC Key Pressed %d", a);
#endif
	  break;
	}
		A4GL_monitor_key_pressed(a);

    }
  cbreak ();
  a=A4GL_curses_to_aubit (a); // Convert it to an aubit key...
  A4GL_chk_for_screen_print(a);
  A4GL_logkey(a);
#ifdef DEBUG
  A4GL_debug ("Got char from keyboard : %d F2=%d LEFT=%d 4GL for f5 = %d", a,KEY_F(2),KEY_LEFT,A4GLKEY_F (5));
#endif

  return a;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_real_getch_swin (WINDOW * window_ptr)
{
  int a;
  static int no_delay=-1;
  static int erredReturns=0;
  static time_t lastSuccess=-1;

#ifdef DEBUG
  A4GL_debug ("Reading from keyboard on window %p", window_ptr);
#endif
  A4GL_set_abort (0);
  a=A4GL_readkey();

  if (a!=0) {
#ifdef DEBUG
                A4GL_debug("Read %d from keyfile",a);
#endif
                return a;
        }

#ifdef USE_HALF_DELAY
	   if (no_delay==-1) {
		    	no_delay=(A4GL_isno(acl_getenv("HALFDELAY")));
	   }
#ifdef DEBUG
	A4GL_debug("HALF DELAY\n");
#endif
	if(!no_delay) {
      	halfdelay (5);
	}
#ifdef DEBUG
	A4GL_debug("SET HALF DELAY\n");
#endif
#endif

  while (1)
    {
      if (window_ptr) {
#ifdef DEBUG
		A4GL_debug("KEYPAD\n");
#endif
  		keypad (window_ptr, TRUE);
#ifdef DEBUG
		A4GL_debug("WGETCH\n");
#endif

		a = wgetch (window_ptr);

		// Did we get an error reading ? 
		if (a!=-1) {
			// Nope - its fine..
			erredReturns=0;
			lastSuccess=-1;
		} else {
			// Yes - there are 2 possiblities
			//  1) It was a timeout
			//  2) it was an error because the standard input was closed
			if (lastSuccess==-1) {
				lastSuccess=time(0);
				erredReturns=0;
			} else {
				time_t this_fail;
				this_fail=time(0);
				if ((this_fail-lastSuccess>=2) && (this_fail-lastSuccess)<=3) {
					// At least 2 seconds has passed- at most we could have 200 
					// interations...
					if (erredReturns>300) {
						A4GL_debug("Unable to read from input %d>300 in %d seconds", erredReturns, this_fail-lastSuccess);
						fprintf(stderr,"Unable to read from input");
						exit(2);
					} else {
						// reset and try again..
						lastSuccess=-1;
						erredReturns=0;
					}
				}
			}
			erredReturns++;
		}

#ifdef DEBUG
		A4GL_debug("WGETCH : %d",a);
#endif
	}

      else {
#ifdef DEBUG
		A4GL_debug("GETCH");
#endif
		a = getch (); // GETCH1 - A4GL_real_getch_swin
	}

#ifdef DEBUG
	A4GL_debug("getch returns %d",a);
#endif

      if (a == KEY_MOUSE)
        {
#ifdef DEBUG
          A4GL_debug ("Mouse event...");
#endif
        }

      if (abort_pressed)
        {
#ifdef DEBUG
          A4GL_debug ("MJAC Aborted!");
#endif
          a = KEY_CANCEL;
          break;
        }
		A4GL_monitor_key_pressed(a);

      if (a != -1)
        {
#ifdef DEBUG
          A4GL_debug ("MJAC Key Pressed %d", a);
#endif
          break;
        }

      if (a==-1) {a=0; 
#ifdef USE_HALF_DELAY
	if(!no_delay) {
	      nocbreak();
	}
#endif
	      	cbreak();
		return a;

      	}
    }
#ifdef USE_HALF_DELAY
	if(!no_delay) {
	      nocbreak();
	}
#endif
  cbreak ();
#ifdef DEBUG
  A4GL_debug ("Got char from keyboard : %d LEFT=%d", a,KEY_LEFT);
#endif
  a=A4GL_curses_to_aubit (a);
  A4GL_chk_for_screen_print(a);
  A4GL_logkey(a);
#ifdef DEBUG
  A4GL_debug (" = %d", a);
#endif
  return a;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_decode_line_scr (int l)
{
#ifdef DEBUG
	A4GL_debug("decode_line_scr - l=%d",l);
#endif
  if (l > 0)
    {
		while (l>A4GL_screen_height()) l--;
	  return l;
    }  
	if (l<0)
	{
#ifdef DEBUG
	A4GL_debug("l=%d",l);
#endif
	  l=A4GL_screen_height () + l +1;
#ifdef DEBUG
	A4GL_debug("l=%d",l);	
#endif
	return l;
	}
  return 0;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_decode_line (int l)
{
  if (l > 0)
    {
      if (A4GL_get_curr_border ())
	{
#ifdef DEBUG
	  A4GL_debug ("Decoded (1) line %d to %d (because of border)", l, l - 1);
#endif
		l--;
	  while (l>UILIB_A4GL_get_curr_height()) l--;
	  return l;
	}
      else
	{
#ifdef DEBUG
	  A4GL_debug ("Decoded (2) line %d to %d", l, l);
#endif
	  while (l>UILIB_A4GL_get_curr_height()) l--;
	  return l;
	}
    }


/* -1 = last */
/* -2 = last -1 */


  if (A4GL_get_curr_border ())
    {
#ifdef DEBUG
	  A4GL_debug ("Decoded (3) line %d to %d (because of border)", l, UILIB_A4GL_get_curr_height ());
#endif
	  l=0-l;
	  l--;
	  return UILIB_A4GL_get_curr_height () - l;
    }
  else
    {
	  l=0-l;
	  l--;
#ifdef DEBUG
	  A4GL_debug ("Decoded (4) line %d to %d ", l, UILIB_A4GL_get_curr_height ());
#endif
	  return UILIB_A4GL_get_curr_height () - l +1;
    }


  return 0;
}



int
A4GL_decode_line_ib (int l)
{
int ch;

ch=windows[currwinno].h;
if (currwinno==0) ch++;
  if (l==0) return 0;


  if (l > 0)
    {
      if (A4GL_get_curr_border ())
	{
#ifdef DEBUG
	  A4GL_debug ("Decoded (1) line %d to %d (because of border)", l, l - 1);
#endif
	  while (l>ch) l--;
	  return l ;
	}
      else
	{
	  while (l>ch) l--;
#ifdef DEBUG
	  A4GL_debug ("Decoded (2) line %d to %d", l, l);
#endif
	  return l;
	}
    }


/* -1 = last */
/* -2 = last -1 */


  if (A4GL_get_curr_border ())
    {
#ifdef DEBUG
	  A4GL_debug ("Decoded (3) line %d to %d (because of border)", l, UILIB_A4GL_get_curr_height ());
#endif
	  l=0-l;
	  l--;
	  return ch - l;
    }
  else
    {
	  l=0-l;
	  l--;
#ifdef DEBUG
	  A4GL_debug ("Decoded (4) line %d to %d ", l, UILIB_A4GL_get_curr_height ());
#endif
	  return ch - l ;
    }


  return 0;
}


/**
 *
 * @todo Describe function
 */
char *
A4GL_glob_window (int x, int y, int w, int h, int border)
{
  static char winname[20];
  int f;
#ifdef DEBUG
  {
    A4GL_debug ("In glob_window");
  }
#endif
  A4GL_chkwin ();
  memset (winname, 'A', 19);
  f = 1;
  winname[19] = 0;

#ifdef DEBUG
  {
    A4GL_debug ("Finding free window ... starting with %s", winname);
  }
#endif

  while (A4GL_has_pointer (winname, WINCODE))
    {
      A4GL_inc_winname (winname);
    }
  A4GL_create_blank_window (winname, x, y + 1, w, h, border);
#ifdef DEBUG
  {				/*debug("Adding window @ %d %s",a,winname); */
  }
#endif
  /*A4GL_add_pointer (winname, WINCODE, win); */
  return winname;
}

/**
 *
 * @todo Describe function
 */
void
A4GL_inc_winname (char *b)
{
  int a;
  for (a = 0; a < 10; a++)
    {
      b[a]++;
      if (b[a] > 'Z')
	b[a] = 'A';
      else
	break;
    }
}


/**
 *
 * @todo Describe function
 */
int
A4GL_getmenu_line (void)
{
int a;

  if (windows[currwinno].winattr.menu_line!=0xff) {
	a=A4GL_decode_line_ib (windows[currwinno].winattr.menu_line);
	if (a<=0) return 1;
	while (a>=UILIB_A4GL_get_curr_height()) a--;
	return a;
  }
  a=A4GL_decode_line_ib (A4GL_get_dbscr_menuline());
  if (a<=0) return 1;
  while (a>=UILIB_A4GL_get_curr_height()) a--;
  return a;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_display_internal (int x, int y, char *s, int attr, int clr_line)
{
int nattr;
int lastpos;
WINDOW *wot;
char *ptr=0;
#ifdef DEBUG
A4GL_debug("display_internal : %d %d %s %d %d",x,y,s,attr,clr_line);
A4GL_debug("determine_attribute seems to be returning %x\n",attr);
#endif
  ptr=strdup(s);
  if (x == -1 && y == -1)
    {
#ifdef DEBUG
      A4GL_debug ("Line mode display");
#endif
      if (A4GL_isscrmode ())
	{
	  A4GL_mja_endwin ();
	}
      PRINTF ("%s\n", s);
      fflush (stdout);
	free(ptr);
    }
  else
    {
      int b;
	int w;
	int h;
	w=UILIB_A4GL_get_curr_width();
	h=UILIB_A4GL_get_curr_height();
#ifdef DEBUG
		A4GL_debug("h=%d\n",h);
#endif
	if (currwinno==0) {
		w=A4GL_screen_width();
		h=A4GL_screen_height();
#ifdef DEBUG
		A4GL_debug("h=%d\n",h);
#endif
	}

      /* WINDOW *win; */
#ifdef DEBUG
        A4GL_debug("DISPLAY @ %d %d %d %d - '%s' %d",x,y,w,h,s,currwinno);
#endif

	if (y<1|| y>h) {
		A4GL_exitwith("The row or column number in DISPLAY AT exceeds the limits of your terminal");
		return;
	}
	if (x<1|| x>w) {
		A4GL_exitwith("The row or column number in DISPLAY AT exceeds the limits of your terminal");
		return;
	}


/*
	if (strlen(s)==0&&clr_line) {
		
			A4GL_debug("Just got a '' on its own ?");
			return;
	}
*/

#ifdef DEBUG
	A4GL_debug("Check we have CURSES env");
#endif
      A4GL_chkwin ();
#ifdef DEBUG
	A4GL_debug("Done");
#endif
	nattr=A4GL_determine_attribute(FGL_CMD_DISPLAY_CMD, attr, 0,0,-1);
	attr=nattr;
      b = A4GL_xwattr_get (currwin);
      wot=A4GL_window_on_top_ign_menu ();
      if (wot==0) { 
		A4GL_exitwith("Internal error - window on top =0");
		return ;
      }

      a4glattr_wattrset (wot, attr);
      A4GL_mja_gotoxy (x, y);
	if (w-x+1<strlen(ptr)) {
		ptr[w-x+1]=0;
	}
#ifdef DEBUG
      A4GL_debug("X=%d Y=%d",x,y);
#endif
      A4GL_tui_printr (0,"%s", ptr);
	free(ptr);

      if (clr_line)
	{
	int sl;
	char buff[1024];
	memset(buff,' ',1024);
	sl=strlen(s);
	sl=w-sl-x+1;
	if (sl>=0) buff[sl]=0;
	buff[1023]=0;
#ifdef DEBUG
	A4GL_debug("currwin=%p",currwin);
	A4GL_debug("Spacer..");
	A4GL_debug("Buff='%s'",buff);
#endif
  	waddstr (currwin, buff);
#ifdef DEBUG
	  A4GL_debug ("Clearing line...");
#endif
		lastpos=x+strlen(s)-1;
		if (x>=0) {
			A4GL_mja_gotoxy(lastpos,y);
		}
	}

#ifdef DEBUG
      A4GL_debug (">> printed %s", s);
#endif

      /* b was got via curses - so we can use the curses version */
      wattrset (wot, b);
      A4GL_mja_wrefresh (wot);
    }
}


/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_display_error (int a, int wait)
{
  char *s;
  char *beepchr;
#ifdef DEBUG
  A4GL_debug ("Cr string");
#endif
  s = A4GL_char_pop ();
  A4GL_chkwin();
#ifdef DEBUG
  A4GL_debug ("ZZ2 going to print an error : %s", s);
#endif
  A4GL_trim (s);

  while (1)  {
          beepchr=strchr(s,'\007');
	          if (!beepchr) break;
		          *beepchr=' ';
			          A4GL_dobeep();
				    }

#ifdef DEBUG
  A4GL_debug ("trimmed -> %s", s);
#endif
      if (wait) {
 		A4GL_error_box (s,a);
	} else {
 		A4GL_error_nobox (s,a);
	}
#ifdef DEBUG
  A4GL_debug ("error_box done");
#endif
  acl_free (s);
  a4gl_status = 0;
}


/**
 *
 * @todo Describe function
 */
void
A4GL_mja_endwin (void)
{
  if (A4GL_isscrmode ())
    {
      A4GL_set_scrmode ('L');
      PRINTF ("\n");
      fflush (stdout);
      endwin ();
    }
}

/**
 *
 * @todo Describe function
 */
int
A4GL_chkwin (void)
{
#ifdef DEBUG
 A4GL_debug("chkwin");
#endif
  if (A4GL_env_option_set ("NOCURSES"))
    {				/* FIXME: this is now A4GL_UI=CONSOLE */
      A4GL_exitwith ("NOCURSES Mode has been specified - operation not permitted");
      exit (0);
      return 0;
    }

  if (A4GL_islinemode ())
    {

#ifdef DEBUG
	A4GL_debug(" API_ui Was linemode..");
#endif
      	A4GL_init_curses_stuff ();


      	A4GL_set_scrmode ('S');

	if (A4GL_isyes(acl_getenv("INIT_COL_REFRESH"))) {
#ifdef DEBUG
		A4GL_debug("INIT_COL_REFRESH2_0 TRIGGERED...");
#endif
		if (has_colors()) {
#ifdef DEBUG
			A4GL_debug("init_col_refresh2_0 - init_colour_pairs");
#endif
			A4GL_init_colour_pairs ();
			UILIB_A4GL_zrefresh();
			if (!A4GL_isyes(acl_getenv("NO_INIT_COL_CLR"))) {
				clearok(curscr,1);
			}
			A4GL_init_colour_pairs ();
		}
	}


	UILIB_A4GL_zrefresh();
      	A4GL_mja_refresh ();


    } else {
#ifdef DEBUG
	A4GL_debug("API_ui Was screen mode..");
#endif
	}
  return 1;
}


/**
 * 4GL CALL
 * @todo Describe function
 */
void *
 UILIB_A4GL_cr_window (char *s,
	   int iswindow,
	   int form_line,
	   int error_line,
	   int prompt_line,
	   int menu_line,
	   int border, int comment_line, int message_line, int attrib, char *style, char *text)
{
  WINDOW *win;
  int x, y, w, h;
  A4GL_set_status(0,0);
  w = A4GL_pop_int ();
  h = A4GL_pop_int ();
  x = A4GL_pop_int ();
  y = A4GL_pop_int ();
  A4GL_chkwin();
  if (A4GL_has_pointer (s, WINCODE))
    {
#ifdef DEBUG
      {
 A4GL_debug ("Window already exists");
      }
#endif
      A4GL_set_errm (s);
      A4GL_exitwith ("Window already exists (%s)");
      return 0;
    }
  win = A4GL_create_window (s, x, y, w, h,
		       iswindow,
		       form_line,
		       error_line,
		       prompt_line,
		       menu_line, border, comment_line, message_line, attrib,0,style);

  return win;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
int
 UILIB_A4GL_cr_window_form (char *namet,
		int iswindow,
		int form_line,
		int error_line,
		int prompt_line,
		int menu_line,
		int border, int comment_line, int message_line, int attrib, char *style, char *text)
{
  int x, y, w, h;
  char *s;
  char buff[1320];
  char name[256];
  struct s_form_dets *form;
  WINDOW *win;
  A4GL_set_status(0,0);
  strcpy(name,namet);
  A4GL_trim(name);
#ifdef DEBUG
  A4GL_debug ("cr_window_form(%s,%d,%d,%d,%d,%d,%d,%d,%d,%d)\n",
	 name, iswindow, form_line, error_line, prompt_line, menu_line,
	 border, comment_line, message_line, attrib);
#endif
  A4GL_chkwin();

  s = A4GL_char_pop ();
  x = A4GL_pop_int ();
  y = A4GL_pop_int ();
  strcpy (buff, s);
  A4GL_trim (buff);
  if (A4GL_has_pointer (name, WINCODE))
    {
#ifdef DEBUG
      {
 A4GL_debug ("Window already exists");
      }
#endif
      A4GL_set_errm (name);
      A4GL_exitwith ("Window already exists (%s)");
      return 0;
    }

#ifdef DEBUG
  A4GL_debug ("reading file %s - name=%s", buff, name);
#endif
  a4gl_status = 0;
  form = A4GL_read_form (buff, name);
  if (a4gl_status != 0)
    return 0;

  if (form == 0)
    {
      A4GL_exitwith ("Unable to create form");
      return 0;
    }
  else
    {
#ifdef DEBUG
      A4GL_debug ("Created form %p", form);
#endif
    }

  scale_form (form->form, &w, &h);

  w = form->fileform->maxcol;
  h = form->fileform->maxline;
#ifdef DEBUG
  A4GL_debug ("Scaling on %s gives %d %d border = %d", buff, w, h, border);
#endif

 if (w+x>255) { 
	if (w>255) {
 		A4GL_exitwith ("Form is too wide");
	} else {
 		A4GL_exitwith ("Form is too wide to be opened at this position");
	}
	return 0;
 }

  /* ignore error line for now */

  form->form_details.comment_line = comment_line;
  form->form_details.menu_line = menu_line;
#ifdef DEBUG
  A4GL_debug ("Setting prompt line to ", prompt_line);
#endif
  form->form_details.prompt_line = prompt_line;
  form->form_details.form_line = form_line;
  form->form_details.error_line = error_line;
  form->form_details.message_line = message_line;
#ifdef DEBUG
  A4GL_debug ("border=%d\n", border);
#endif
  form->form_details.border = border;
  form->form_details.colour = attrib;

  A4GL_add_pointer (name, S_FORMDETSCODE, form);

  win = A4GL_display_form_new_win (name, form, x, y,attrib,style);
  if (win)
    {
      A4GL_add_pointer (name, WINCODE, win);
	
      A4GL_mja_wrefresh (currwin);
    }
  else
    {
      A4GL_exitwith ("Error displaying form in window");
    }
  acl_free (s);
  return 0;
}






/**
 * 4GL CALL
 * @todo Describe function
 */
int
 UILIB_A4GL_open_form (char *name)
{
  int w, h;
  char *s;
  char buff[256];
  struct s_form_dets *form;

  A4GL_set_status(0,0);

  A4GL_chkwin();
  s = A4GL_char_pop ();
  strncpy (buff, s, 256);
  buff[255] = 0;
  A4GL_trim (buff);
#ifdef DEBUG
  A4GL_debug ("reading file %s ?", buff);
#endif
  A4GL_set_status (0, 0);

  form = A4GL_read_form (buff, name);
#ifdef DEBUG
  A4GL_debug ("Read form returns %d status = %d\n", form,a4gl_status);
#endif
  if (a4gl_status != 0)
    {
#ifdef DEBUG
      A4GL_debug ("Some problem opening form...");
#endif
      acl_free (s);
      return -1;
    }
  A4GL_set_default_form (&form->form_details);
  scale_form (form->form, &h, &w);
  /*
     form->w=w; // MJA 2707
     form->h=h; // MJA 2707
   */
#ifdef DEBUG
  A4GL_debug ("adding pointer F to %s", name);
#endif
  A4GL_add_pointer (name, S_FORMDETSCODE, form);
#ifdef DEBUG
  A4GL_debug ("Freeing s");
#endif
  acl_free (s);
#ifdef DEBUG
  A4GL_debug ("Freed - form has been opened");
#endif
  return 0;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_close_form (char *formname)
{
  void *ptr;
int a;
  A4GL_chkwin();

  ptr=A4GL_find_pointer(formname,S_FORMDETSCODE);

  if (ptr==0) {
	A4GL_exitwith("Form not open");
	return;
  }


  A4GL_del_pointer (formname, S_FORMDETSCODE);

  for (a = 0; a < MAXWIN; a++) {
	if (windows[a].form==ptr) {
		windows[a].form=0;
	}
  }
  acl_free(ptr);
 
}


/**
 * 4GL CALL
 * @todo Describe function
 */
int
 UILIB_A4GL_disp_form (char *name, int attr)
{
  struct s_form_dets *f;
  WINDOW *w;
  char buff[80];
  A4GL_chkwin();
#ifdef DEBUG
  A4GL_debug ("attr=%d\n", attr);
#endif

#ifdef DEBUG
  A4GL_debug ("attr=%x\n", attr);
#endif

#ifdef DEBUG
  A4GL_debug ("Disp_form_tui");
#endif
  f = (struct s_form_dets *) A4GL_find_pointer_val (name, S_FORMDETSCODE);
#ifdef DEBUG
  A4GL_debug ("Got pointer to form as %p", f);
#endif
  if (f == 0)
    {
      A4GL_exitwith ("The form has not been opened");
      return 0;
    }
  w = A4GL_display_form (f,attr);
  if (w == 0)
    {
#ifdef DEBUG
/* {DEBUG} */
      {
#ifdef DEBUG
 A4GL_debug ("Error display window");
#endif
      }
#endif
      return 0;
    }

  windows[currwinno].form = f;
  SPRINTF2 (buff, "currwinno=%d f=%p", currwinno, f);
  /*error_box(buff); */
  A4GL_mja_wrefresh (currwin);
#ifdef DEBUG
  A4GL_debug ("Diplay form");
#endif
  A4GL_mja_refresh ();
  return 0;
}




/**
 *
 * @todo Describe function
 */
int
A4GL_set_window (int a)
{
  UILIB_A4GL_current_window (windows[a].name);
/*error_box(windows[a].name); */
  return 0;
}



/**
 *
 * @todo Describe function
 */
int
A4GL_subwin_gotoxy (WINDOW * win, int x, int y,int has_border)
{
  int a;
#ifdef DEBUG
	A4GL_debug("subwin_gotoxy - %d %d win=%p",y-1,x-1,win);
#endif
 if (y<1) y=1;
 if (x<1) x=1;
  a = wmove (win, y - 1, x - 1);
  if (a == ERR)
    {
#ifdef DEBUG
      A4GL_debug ("Failed to move cursor!");
#endif
    }
  return 0;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_subwin_print (WINDOW * win, char *fmt, ...)
{
  va_list args;
  A4GL_chkwin ();
  va_start (args, fmt);
#ifdef DEBUG
  A4GL_debug ("subwin_print '%s' on window %p", fmt, win);
#endif
  A4GL_mja_vwprintw (win, fmt, &args);	/*  MJAMJAMJA */
  A4GL_mja_wrefresh (win);
  return 0;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_subwin_printxy (WINDOW * win, int x, int y, char *fmt, ...)
{
  va_list args;
  A4GL_chkwin ();
  va_start (args, fmt);
  wmove (win, y - 1, x - 1);
#ifdef DEBUG
A4GL_debug("subwin_printxy %d %d %s",x,y,fmt);
#endif
  A4GL_mja_vwprintw (win, fmt, &args);
  A4GL_mja_wrefresh (win);
  return 0;
}



/**
 *
 * @todo Describe function
 */
int
A4GL_subwin_setcolor (WINDOW * win, int typ)
{
  WINDOW *currwin;
  long attr;
  currwin = win;
  attr = getbkgd (currwin);
#ifdef DEBUG
  A4GL_debug ("Window background = %x", attr);
#endif
  if (attr == 0 )
    {
      attr = A_NORMAL & ' ';
    }
#ifdef DEBUG
  A4GL_debug ("Subwin - setcolor");
#endif
  if (has_colors ())
    {
#ifdef DEBUG
      A4GL_debug ("XX4 REVERSE");
      A4GL_debug ("Color display - %d current attrib is reverse %d", typ,
	     attr & A_REVERSE);
#endif
      switch (typ)
	{
	case NORMAL_TEXT:
	case NORMAL_MENU:
	  wattrset (currwin, attr);

	  break;
	case INVERT_MENU:
#ifdef DEBUG
	  A4GL_debug ("Invert...");
#endif
	  if (attr & A_REVERSE)
	    {
#ifdef DEBUG
	      A4GL_debug ("XX4 REVERSE");
#endif
	      if (((attr) & (A4GL_colour_code (COLOR_WHITE))) ==
		  A4GL_colour_code (COLOR_WHITE))
		{
#ifdef DEBUG
		  A4GL_debug ("Use red %x", A4GL_colour_code (COLOR_RED));
		  A4GL_debug ("XX4 REVERSE");
#endif
		  wattrset (currwin, A_REVERSE | A4GL_colour_code (COLOR_RED));
		}
	      else
		{
#ifdef DEBUG
		  A4GL_debug ("Ops - try green instead of red...\n");
		  A4GL_debug ("XX4 REVERSE");
#endif
		  wattrset (currwin, A_REVERSE + A4GL_colour_code (COLOR_WHITE));
		}
	    }
	  else
	    {
#ifdef DEBUG
	      A4GL_debug ("Off for invert");
	      A4GL_debug ("XX4 REVERSE");
#endif
	      wattron (currwin, A_REVERSE);
	    }

	  break;
	case TITLE_COL:
	  wattrset (currwin, A4GL_colour_code (COLOR_WHITE));
	  break;
	case EDIT_FIELD:
	  wattrset (currwin, A4GL_colour_code (COLOR_WHITE));
	  break;
	}
      currattr = typ;
    }
  else
    {
      switch (typ)
	{
	case ERROR_COL:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wattron (currwin, A_REVERSE);
	  break;
	case MESSAGE:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wattroff (currwin, A_REVERSE);
	  break;
	case NORMAL_MENU:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wattroff (currwin, A_REVERSE);
	  break;
	case INVERT_MENU:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wattron (currwin, A_REVERSE);
	  break;
	case TITLE_COL:
#ifdef DEBUG
	  A4GL_debug ("XX4 REVERSE");
#endif
	  wattron (currwin, A_REVERSE);
	  break;
	case EDIT_FIELD:
	  wattron (currwin, A_REVERSE);
	  break;
	case NORMAL_TEXT:
	  wattroff (currwin, A_REVERSE);
	  break;
	}
    }
  return 0;
}




/**
 *
 * @todo Describe function
 */
int
A4GL_mja_vwprintw (WINDOW * win, char *fmt, va_list * args)
{
  char buff[10024];
  memset(buff,0,sizeof(buff));
  vsprintf (buff, fmt, *args);
	
  if (strlen(buff)>256) {
	char *ptr=0;
	FPRINTF(stderr, "OOps...\n");fflush(stdout);
	*ptr=0;
  }
#ifdef DEBUG
  A4GL_debug ("mja_vwprintw..> '%s' attribute %x", buff, A4GL_xwattr_get (win));
#endif
  if (A4GL_xwattr_get (win) == 0x20)
    {
      wattrset (win, 0);
    }
  else
    {
      int a;
      a = A4GL_xwattr_get (win);
      a = a - (a & 0xff);
      wattrset (win, a);
    }
#ifdef DEBUG
  A4GL_debug ("Attribute : %x on win %p - buff=%s\n", A4GL_xwattr_get (win), win,buff);
#endif
  wprintw (win, "%s", buff);
  return 0;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_init_colour_pairs (void)
{
int bkgcolor;
int colors[8];
int bkg_def;
int bkg;
int fg;
int fg_def;
int a;
colors[0]=atoi(acl_getenv("COLOR_TUI_BLACK"));
colors[1]=atoi(acl_getenv("COLOR_TUI_RED"));
colors[2]=atoi(acl_getenv("COLOR_TUI_GREEN"));
colors[3]=atoi(acl_getenv("COLOR_TUI_YELLOW"));
colors[4]=atoi(acl_getenv("COLOR_TUI_BLUE"));
colors[5]=atoi(acl_getenv("COLOR_TUI_MAGENTA"));
colors[6]=atoi(acl_getenv("COLOR_TUI_CYAN"));
colors[7]=atoi(acl_getenv("COLOR_TUI_WHITE"));

bkg_def=atoi(acl_getenv("COLOR_TUI_BKG_DEF"));
bkg=atoi(acl_getenv("COLOR_TUI_BKG"));

fg_def=atoi(acl_getenv("COLOR_TUI_FG_DEF"));
fg=atoi(acl_getenv("COLOR_TUI_FG"));

#ifdef DEBUG
for (a=0;a<=7;a++) {
	A4GL_debug("Colours : %d %d",a,colors[a]);
}
A4GL_debug("Background if we have defaults : %d",bkg_def);
A4GL_debug("Background if we dont have defaults : %d",bkg);
A4GL_debug("BLACK : %d %d",colors[0],COLOR_BLACK);
A4GL_debug("YELLOW : %d %d",colors[3],COLOR_YELLOW);
A4GL_debug("WHITE : %d %d",colors[7],COLOR_WHITE);

#endif

if (have_default_colors) {
	bkgcolor=bkg_def;
	fg=fg_def;
} else {
	bkgcolor=bkg;
}

#ifdef DEBUG
A4GL_debug("Colours - BKG=%d\n",bkgcolor);
#endif
  init_pair (1, colors[0], bkgcolor);
  init_pair (2, colors[1], bkgcolor);
  init_pair (3, colors[2], bkgcolor);
  init_pair (4, colors[3], bkgcolor);
  init_pair (5, colors[4], bkgcolor);
  init_pair (6, colors[5], bkgcolor);
  init_pair (7, colors[6], bkgcolor);
  init_pair (8, colors[7], bkgcolor);

if (use_invisible_as_color_9()) {
	int fg;
	int bg;
	fg=atoi(acl_getenv("COLOR_TUI_INVISIBLE_FG"));
	bg=atoi(acl_getenv("COLOR_TUI_INVISIBLE_BG"));
	
  	init_pair (9, fg,bg);
}

#ifdef DEBUG
A4GL_debug("Assume default colors : %d %d",bkgcolor,fg);
#endif
#ifndef PDCURSES
#ifdef NCURSES_VERSION
  assume_default_colors(fg,bkgcolor);
#endif
#endif

  return 0;
}

/**
 *
 * @todo Describe function
 */
void
A4GL_mja_wrefresh (WINDOW * w)
{
  if (UILIB_A4GL_screen_mode (-1) && w)
    {
      update_panels ();
      A4GL_refresh_error_window();
      wrefresh (w);

    }
}

/**
 *
 * @todo Describe function
 */
void
A4GL_mja_refresh (void)
{
  if (UILIB_A4GL_screen_mode (-1))
    {
      update_panels ();
      doupdate ();
      refresh ();
    }
}

/**
 *
 * @todo Describe function
 */
void
A4GL_change_currwin (WINDOW * a, char *s)
{
#ifdef DEBUG
  {
    A4GL_debug ("Changing currwin to %p (%s)", a, s);
  }
#endif
  currwin = a;

}

/**
 *
 * @todo Describe function
 */
void
A4GL_change_currwinno (int a, char *s)
{
#ifdef DEBUG
  {
    A4GL_debug ("Changing currwinno to %d (%s)", a, s);
  }
#endif
  currwinno = a;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_top_win (PANEL * p_xx)
{
  int a;
  PANEL *z;
  a = A4GL_find_win (0);		/* current window top window */

  if (a == -1)
    return 1;

  /* a is now the top window */

  z = windows[a].pan;
  A4GL_change_currwin (panel_window (z), "Marker 3");
  A4GL_change_currwinno (a, "Marker 4");
  return 0;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_find_win (PANEL * p)
{
  int a;
  if (p == 0) {
#ifdef DEBUG
	A4GL_debug("find_win for panel_below(0)");
#endif
	p=get_below_panel(0);
        return A4GL_find_win (p);
  }
#ifdef DEBUG
  {
    A4GL_debug ("Finding window %p", p);
  }
#endif

  for (a = 0; a < MAXWIN; a++)
    {
	if (windows[a].pan==0) continue;
#ifdef DEBUG
      {
 A4GL_debug ("Checking windows   : %p %p %p", panel_window (windows[a].pan),
	       windows[a].pan, p);
      }
#endif

      if ((PANEL *) panel_window (windows[a].pan) == p
	  || (PANEL *) windows[a].pan == p)
	{


	  if (a4gl_toupper (windows[a].name[0]) == windows[a].name[0])
	    {
#ifdef DEBUG
	      {
	 A4GL_debug ("window is a menu - finding parent of %s",
		       windows[a].name);
	      }
#endif

		A4GL_assertion(1,"Fake window - thought i'd got rid of these");
	    }
	  return a;
	}
    }
  A4GL_exitwith ("Panel not found....");
  return -1;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
LIBEXPORT void
 UILIB_A4GL_hide_window (char *winname)
{
  PANEL *p;
  int a;

  p = A4GL_find_pointer (winname, PANCODE);
#ifdef DEBUG
  {
    A4GL_debug ("hiding window %s %p", winname, p);
  }
#endif

  A4GL_top_win (0);


	a=find_window_number_for_window_name(winname);
	if (a>=0) {
		if (windows[a].dspan) {
			hide_panel(windows[a].dspan);
		}
	}

  if (p)
    {
      a = hide_panel (p);
#ifdef DEBUG
      {
 A4GL_debug ("a=%d", a);
      }
#endif
    }
  A4GL_do_update_panels ();

}

/**
 * 4GL CALL
 * @todo Describe function
 */
LIBEXPORT void
 UILIB_A4GL_show_window (char *winname)
{
  PANEL *p;
int a;
  p = A4GL_find_pointer (winname, PANCODE);
#ifdef DEBUG
  {
    A4GL_debug ("showing window %s %p", winname, p);
  }
#endif
  A4GL_top_win (0);

	a=find_window_number_for_window_name(winname);
	if (a>=0) {
		if (windows[a].dspan) {
			hide_panel(windows[a].dspan);
		}
	}

  if (p) {
    show_panel (p);
  }
  A4GL_do_update_panels ();
}

/**
 *
 * @todo Describe function
 */
void
A4GL_do_update_panels (void)
{
  if (UILIB_A4GL_screen_mode (-1))
    {
      update_panels ();
      doupdate ();
    }
}

/**
 *
 * @todo Describe function
 */
int
A4GL_getform_line (void)
{
int a;
#ifdef DEBUG
A4GL_debug("Get formline...%d",windows[currwinno].winattr.form_line);
#endif
  if (windows[currwinno].winattr.form_line!=0xff) {
	a=windows[currwinno].winattr.form_line;
  } else {
        a=A4GL_get_dbscr_formline();
  }

/* There seems to be some sort of bug in informix -
   if you have a window with a border - the form is shifted up 1 line...
   so a form line 3 would be displayed on line 2...

  if ( A4GL_get_curr_border ()) {
	a--;
  }
*/


#ifdef DEBUG
 A4GL_debug("FORMLINE = %d",a);
#endif
  return a;

}

/**
 *
 * @todo Describe function
 */
int
A4GL_getcomment_line (void)
{
int default_comment_line;


#ifdef DEBUG
A4GL_debug("Comment line for currwin=%d std_dbscr=%d",windows[currwinno].winattr.comment_line,A4GL_get_dbscr_commentline());
#endif

if (A4GL_get_dbscr_commentline()==0xff) {
	if (currwinno==0) {
		default_comment_line=-2; // Last for SCREEN
	} else {
		default_comment_line=-1; // Last-1 for all other windows...
	}
} else {
		default_comment_line=A4GL_get_dbscr_commentline();
}

  if (windows[currwinno].winattr.comment_line!=0xff) {
	return A4GL_decode_line_ib (windows[currwinno].winattr.comment_line);
  }


  return A4GL_decode_line_ib (default_comment_line);
}

/**
 *
 * @todo Describe function
 */
int
A4GL_geterror_line (void)
{

#ifdef DEBUG
  A4GL_debug ("geterror_line - %d (%d)", windows[currwinno].winattr.error_line,currwinno);
#endif
  if (windows[currwinno].winattr.error_line!=0xff) {
#ifdef DEBUG
	A4GL_debug("Window specific...");
#endif
        return A4GL_decode_line_scr (windows[currwinno].winattr.error_line);
  }
   
  return A4GL_decode_line_scr (A4GL_get_dbscr_errorline());
}


/**
 *
 * @todo Describe function
 */
int
A4GL_getmessage_line (void)
{
int a;
int b;
#ifdef DEBUG
  A4GL_debug ("getmessage_line - %d", windows[currwinno].winattr.message_line);
#endif



  if (windows[currwinno].winattr.message_line!=0xff) {
        a=windows[currwinno].winattr.message_line;
        b=1;
  } else {
        a=A4GL_get_dbscr_messageline(); // MJAMJA
        b=2;
  }


  if (a<0) {
#ifdef DEBUG
        A4GL_debug("a<0 - %d",a);
#endif
        a=0-a-1;
#ifdef DEBUG
        A4GL_debug("a now %d",a);
#endif
        if (currwinno==0) {
                a=A4GL_screen_height()-a;
#ifdef DEBUG
                A4GL_debug("a=%d from screen_height",a);
#endif
        } else {
                a=UILIB_A4GL_get_curr_height()-a;
#ifdef DEBUG
                A4GL_debug("a=%d from curr_height",a);
#endif
        }
#ifdef DEBUG
        A4GL_debug("a=%d",a);
#endif
  }

#ifdef DEBUG
  A4GL_debug("Thinking message_line should be %d - window height=%d",a,UILIB_A4GL_get_curr_height());
#endif

  if (currwinno==0) {
#ifdef DEBUG
        A4GL_debug("MSG SCR %d %d %d",a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
  } else {
#ifdef DEBUG
        A4GL_debug("MSG WIN %d %d %d",a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
  }

  if (currwinno==0) {
         while (a>A4GL_screen_height()) {
#ifdef DEBUG
                A4GL_debug("message_line line - Too far down screen - moving up %d>%d+%d", a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
                a--;
        }
  } else {
        if (a>(UILIB_A4GL_get_curr_height())) {
		if (!A4GL_isno(acl_getenv("MSGLINEFIXUP"))) {
			a=UILIB_A4GL_get_curr_height();
 		} else {
                	a=2;
			if (a>UILIB_A4GL_get_curr_height()-A4GL_iscurrborder()) a=1;
		}
        }
  }


  if (a<=0) a=1;

#ifdef DEBUG
  A4GL_debug("Msg line %d",a);
#endif
return a;

}


/**
 *
 * @todo Describe function
 */
int
A4GL_getprompt_line (void)
{
int a;
int b;
#ifdef DEBUG
  A4GL_debug ("getprompt_line - %d", windows[currwinno].winattr.prompt_line);
#endif



  if (windows[currwinno].winattr.prompt_line!=0xff) {
	a=windows[currwinno].winattr.prompt_line;
	b=1;
  } else {
  	a=A4GL_get_dbscr_promptline(); // MJAMJA 
	b=2;
  }


  if (a<0) {
#ifdef DEBUG
	A4GL_debug("a<0 - %d",a);
#endif
	a=0-a-1;
#ifdef DEBUG
	A4GL_debug("a now %d",a);
#endif
	if (currwinno==0) {
		a=A4GL_screen_height()-a;
#ifdef DEBUG
		A4GL_debug("a=%d from screen_height",a);
#endif
	} else {
		a=UILIB_A4GL_get_curr_height()-a;
#ifdef DEBUG
		A4GL_debug("a=%d from curr_height",a);
#endif
	}
#ifdef DEBUG
	A4GL_debug("a=%d",a);
#endif
  }

#ifdef DEBUG
  A4GL_debug("Thinking prompt should be %d - window height=%d",a,UILIB_A4GL_get_curr_height());
#endif

  if (currwinno==0) {
#ifdef DEBUG
	A4GL_debug("PROMPT SCR %d %d %d",a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
  } else {
#ifdef DEBUG
	A4GL_debug("PROMPT WIN %d %d %d",a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
  }

  if (currwinno==0) {
	 while (a>A4GL_screen_height()) {
#ifdef DEBUG
		A4GL_debug("prompt line - Too far down screen - moving up %d>%d+%d", a,UILIB_A4GL_get_curr_height(),A4GL_iscurrborder());
#endif
		a--;
  	} 
  } else {
  	if (a>(UILIB_A4GL_get_curr_height())) {
		a=1;
  	}
  }


  if (a<=0) a=1;
 
#ifdef DEBUG
  A4GL_debug("Prompt line %d",a);
#endif
return a;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
LIBEXPORT int
 UILIB_A4GL_movewin (char *winname, int absol)
{
  PANEL *p;
  int x, y;
  int r = 0;
  int nx, ny;
  struct s_windows *w;
  A4GL_chkwin();
  x = A4GL_pop_int ();
  y = A4GL_pop_int ();
#ifdef DEBUG
  {
    A4GL_debug ("x=%d y=%d winname=%s", x, y, winname);
  }
#endif
  w = A4GL_find_pointer (winname, S_WINDOWSCODE);
#ifdef DEBUG
  {
    A4GL_debug ("w=%p", w);
  }
#endif
  if (w)
    {
      p = w->pan;
      if (w->winattr.border)
	{
	  x--;
	  y--;
	}

      if (absol)
	{
#ifdef DEBUG
	  {
	    A4GL_debug ("Moving absolute to %d %d", y - 1, x - 1);
	  }
#endif
	  r = move_panel (p, y - 1, x - 1);
	  nx = x;
	  ny = y;
	}
      else
	{
#ifdef DEBUG
	  {
	    A4GL_debug ("Moving relative by %d %d", y, x);
	  }
#endif
	  r = move_panel (p, w->y + y - 1, w->x + x - 1);
	  nx = w->x + x + 1;
	  ny = w->y + y + 1;
	}
      A4GL_do_update_panels ();
    }
  else
    {
      A4GL_exitwith ("Window to move was not found");
      return 0;
    }
#ifdef DEBUG
  {
    A4GL_debug ("r=%d", r);
  }
#endif

  if (r != 0)
    {
      A4GL_exitwith ("Couldn't move window");
      return 0;
    }

#ifdef DEBUG
  {
    A4GL_debug ("Old %d %d  new %d %d", x, y, nx, ny);
  }
#endif

  w->x = nx;
  w->y = ny;
  return 0;
}


/**
 *
 * @todo Describe function
 */
int
A4GL_find_ptr_debug (void *ptr)
{
  return 0;
}


/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_get_currwin (void)
{
  return currwin;
}

/**
 *
 * @todo Describe function
 */
int
 UILIB_A4GL_iscurrborder (void)
{
#ifdef DEBUG
  A4GL_debug ("currwinno=%d", currwinno);
#endif
if (currwinno>=0) {
#ifdef DEBUG
  A4GL_debug ("Winattr=%p", windows[currwinno].winattr);
  A4GL_debug ("border=%p", windows[currwinno].winattr.border);
#endif
  return windows[currwinno].winattr.border;
} 
return 0;
}


/**
 *
 * @todo Describe function
 */
void
A4GL_set_attr_win (char s, int wattr)
{
  A4GL_set_bkg (currwin, wattr);
}


/**
 *
 * @todo Describe function
 */
void
print_panel_stack (void)
{
  PANEL *ptr;
#ifdef DEBUG
  A4GL_debug ("Printing panel stack");
#endif
  ptr = panel_below (0);
  while (ptr != 0)
    {
#ifdef DEBUG
      A4GL_debug ("Panel : %p (%s)", ptr, A4GL_null_as_null((char *)panel_userptr (ptr)));
#endif
      ptr = panel_below (ptr);
    }
}



/**
 *
 * @todo Describe function
 */
char *
A4GL_windowname_on_top (void)
{
  PANEL *ptr;
  char *s;
  ptr = panel_below (0);
  s = (char *) panel_userptr (ptr);	/* get name of panel */
  return s;
}


/**
 *
 * @todo Describe function
 */
WINDOW *
A4GL_window_on_top (void)
{
  PANEL *ptr;
  const char *s;
  void *winptr;
  ptr=0;
  while (1) {
  	ptr = panel_below (ptr);
  	s = (char *)panel_userptr (ptr);	/* get name of panel */
	if (strcmp(s,"error window")==0) continue;
	if (s) break;
	
  }
#ifdef DEBUG
  A4GL_debug("window_on_top - %s",s);
#endif
  winptr = A4GL_find_pointer (s, WINCODE);
  return winptr;
}


WINDOW *
A4GL_window_on_top_ign_menu (void)
{
  PANEL *ptr;
  char *s;
  void *winptr;
  int ok=0;
  ptr=0;

  while (1) {
  	ptr = panel_below (ptr);
#ifdef DEBUG
	A4GL_debug("panel below=%p",ptr);
#endif
  	s = (char *)panel_userptr (ptr);	/* get name of panel */
	if (strcmp(s,"error window")==0) continue;
#ifdef DEBUG
	A4GL_debug("userptr=%p",s);
#endif
	
	if (s) {
#ifdef DEBUG
		A4GL_debug("Got an s = '%s'",s);
#endif
		ok=1;
		break;
	}
	
  }

  if (ok==0) {
#ifdef DEBUG
	A4GL_debug("can't find window on top....");
#endif
  } else {
#ifdef DEBUG
  	A4GL_debug("window_on_top - %s",s);
#endif
  }
/*
  if (A4GL_has_pointer (s, MNPARCODE)) {
		// Damn - its a menu - whats our parent ?
#ifdef DEBUG
		A4GL_debug("Was menu window...");
#endif
		return A4GL_find_pointer (s, MNPARCODE);
  }
*/
  winptr = A4GL_find_pointer (s, WINCODE);
#ifdef DEBUG
	A4GL_debug("Winptr=%p",winptr);
#endif
  return winptr;
}



/**
 *
 * @todo Describe function
 */
int
A4GL_invert_color (int a)
{
  return 7 - a;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_xwattr_get (WINDOW * w)
{
  return getattrs (w);
}


/**
 *
 * @todo Describe function
 */
int
A4GL_screen_width (void)
{
  if (scr_width == -1)
    {

      getmaxyx (stdscr, scr_height, scr_width);
      if (atoi (acl_getenv ("COLUMNS")))
	{
	  scr_width = atoi (acl_getenv ("COLUMNS"));
	  scr_height = atoi (acl_getenv ("LINES"));
	}
    }
#ifdef DEBUG
  A4GL_debug ("screen_width returning %d", scr_width);
#endif
  return scr_width;
}

/**
 *
 * @todo Describe function
 */
int
A4GL_screen_height (void)
{
  if (scr_width == -1)
    {
      getmaxyx (stdscr, scr_height, scr_width);
      if (atoi (acl_getenv ("COLUMNS")))
	{
	  scr_width = atoi (acl_getenv ("COLUMNS"));
	  scr_height = atoi (acl_getenv ("LINES"));
	}

    }
#ifdef DEBUG
  A4GL_debug ("screen_height returning %d", scr_height);
#endif
  return scr_height;
}

/**
 * 4GL CALL
 * @todo Describe function
 */
void
 UILIB_A4GL_sleep_i (void)
{
  int a;
  a = A4GL_pop_int ();
  A4GL_set_status(0,0);
  sleep (a);
}


void A4GL_make_window_with_this_form_current(void *form) {
int a;
for (a=0;a<MAXWIN;a++) {
	if (windows[a].form==form) {
#ifdef DEBUG
		A4GL_debug("Found it... @ %d",a);
#endif
  		UILIB_A4GL_current_window (windows[a].name);
		return;
	}
}

}


void A4GL_monitor_screen(void) {
int x;
int y;
int attr;
char buff[256];
char buff2[512];
int sw;
int sh;
WINDOW *w;
w=curscr;
sw= A4GL_screen_width ();
sh=A4GL_screen_height ();
  SPRINTF2(buff,"SCR %d %d\n", sh, sw);
  A4GL_monitor_puts_int(buff);

  for (y = 0; y < sh; y++)
    {
      for (x = 0; x < sw; x++)
        {

          attr = mvwinch (w, y, x);

              if ((attr&0xff) == (ACS_VLINE&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '|';
                }
              if ((attr&0xff) == (ACS_HLINE&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '-';
                }
              if ((attr&0xff) == (ACS_LLCORNER&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr&0xff) == (ACS_LRCORNER&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr&0xff) == (ACS_URCORNER&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr&0xff) == (ACS_ULCORNER&0xff) && (attr&A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
		buff[x]=attr&0xff;
        }
	buff[x]=0;
	if (strlen(buff)>500) {A4GL_assertion(1,"Screen too wide");}
	SPRINTF2(buff2,"LIN %3d %s\n",y,buff);
        A4GL_monitor_puts_int(buff2);
    }
        A4GL_monitor_puts_int("EOS\n");

}


void A4GL_monitor_key_pressed(int a) {
char buff[255];
if (a!=-1) {
	SPRINTF1(buff,"KYP %d\n",a);
	A4GL_monitor_puts_int(buff);
}
}



void
UILIB_A4GL_set_option_value_for_current_window (char type, long keyval)
{
  struct s_form_attr *scr;
  if (currwinno<0) return;
  scr=&windows[currwinno].winattr;
  switch (type)
    {
    case 'C': scr->comment_line = keyval; break;
    case 'E': scr->error_line = keyval; break;
    case 'F': scr->form_line = keyval; break;
    case 'M': scr->menu_line = keyval; break;
    case 'm': scr->message_line = keyval; break;
    case 'P': scr->prompt_line = keyval; break;
    case 'A': scr->acckey = keyval; break;
    case 'D': scr->delkey = keyval; break;
    case 'I': scr->inskey = keyval; break;
    case 'N': scr->nextkey = keyval; break;
    case 'p': scr->prevkey = keyval; break;
    case 'H': scr->helpkey = keyval; break;
    case 'd': scr->dispattr = keyval; break;
    case 'i': scr->inpattr = keyval; break;
    case 'W': scr->input_wrapmode = keyval; break;
    case 'f': scr->fieldconstr = keyval; break;
    case 'S': scr->sqlintr = keyval; break;
    case 'r': scr->run_ui_mode=keyval;break;
    case '|': scr->pipe_ui_mode=keyval;break;
    }
}

long
UILIB_A4GL_get_option_value_for_current_window (char type)
{
  struct s_form_attr *scr;
  if (currwinno<0)  return 0;
  scr=&windows[currwinno].winattr;

  switch (type)
    {
    case 'C': return scr->comment_line; break;
    case 'E': return scr->error_line ; break;
    case 'F': return scr->form_line; break;
    case 'M': return scr->menu_line ; break;
    case 'm': return scr->message_line ; break;
    case 'P': return scr->prompt_line ; break;
    case 'A': return scr->acckey ; break;
    case 'D': return scr->delkey ; break;
    case 'I': return scr->inskey ; break;
    case 'N': return scr->nextkey ; break;
    case 'p': return scr->prevkey ; break;
    case 'H': return scr->helpkey ; break;
    case 'd': return scr->dispattr ; break;
    case 'i': return scr->inpattr ; break;
    case 'W': return scr->input_wrapmode ; break;
    case 'f': return scr->fieldconstr ; break;
    case 'S': return scr->sqlintr ; break;
    case 'r': return scr->run_ui_mode; break;
    case '|': return scr->pipe_ui_mode; break;
    }
A4GL_assertion(1,"Unknown option value");
return 0;
}








int A4GL_get_currwinno(void) {
        return currwinno;
}



int use_invisible_as_color_9() {
static int yes=-1;
if (yes>=0) return yes;
if (COLOR_PAIRS>8) {
		//@env INVISIBLEASCOLOR 
		//  use extended colors to define INVISIBLE with color attributes
		//  rather than removing the O_PUBLIC attribute (which may cause blanking of DISPLAYed data)
	if (A4GL_isno(acl_getenv("INVISIBLEASCOLOR"))) {
		yes=0;
	} else {
		yes=1;
	}
} else {
	yes=0;
}
return yes;
}


void resize_screen_window(int w,int h) {
		A4GL_chkwin();
		A4GL_debug("In resize_screen_window : %d %d\n", w,h);
		if (windows[0].w==w && windows[0].h==h) return; // There already...
                        windows[0].w=w;
                        windows[0].h=h;
                        wresize(windows[0].win,h,w);
}

void dumpCurrentFormInfo() {
FILE *outFile;
outFile=stdout;
      if (A4GL_isscrmode ())
        {
          A4GL_mja_endwin ();
        }

      fflush (stdout);

      struct s_form_dets *s;
                s=UILIB_A4GL_get_curr_form(0);
                if (s) {
      //strcpy(menu->parent_window_name, UILIB_A4GL_get_currwin_name());
      fprintf(outFile,"\n<!-- SCREEN DEFINITION -->\n");
      fprintf(outFile,"<Window Name=\"%s\" Border=\"%d\" x=\"%d\" y=\"%d\" form_line=\"%d\" w=\"%d\" h=\"%d\">\n", UILIB_A4GL_get_currwin_name(), 
		windows[currwinno].winattr.border,
		windows[currwinno].x,
		windows[currwinno].y,
		A4GL_getform_line(),
		windows[currwinno].w,
		windows[currwinno].h
	);
	int x;
	int y;
	fprintf(outFile,"<Dump>\n<![CDATA[\n");
	for (y=windows[currwinno].winattr.border;y<windows[currwinno].h+windows[currwinno].winattr.border;y++) {
	//fprintf(outFile, "Y%02d:", y);
	  for (x=windows[currwinno].winattr.border;x<windows[currwinno].w+windows[currwinno].winattr.border;x++) {
		int attr;
 		attr = mvwinch ( windows[currwinno].win, y, x);
              if ((attr & 0xff) == (ACS_VLINE & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '|';
                }
              if ((attr & 0xff) == (ACS_HLINE & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '-';
                }
              if ((attr & 0xff) == (ACS_LLCORNER & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr & 0xff) == (ACS_LRCORNER & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr & 0xff) == (ACS_URCORNER & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              if ((attr & 0xff) == (ACS_ULCORNER & 0xff) && (attr & A_ALTCHARSET))
                {
                  attr = (int) '+';
                }
              fprintf (outFile,"%c", attr & 255);
	  }
	  fprintf(outFile, "\n");
        }
	fprintf(outFile, "]]>\n</Dump>\n");
	
      fprintf(outFile,"<Form dbName=\"%s\" maxCol=\"%d\" maxLine=\"%d\" >\n", s->fileform->dbname, s->fileform->maxcol,  s->fileform->maxline);
	int a;
	for (a=0;a<s->fileform->attributes. attributes_len;a++) {
		fprintf(outFile,"<Field id=\"%d\" tabname=\"%s\" colname=\"%s\" dtype=\"%d\" dtypeSize=\"%d\">\n", a, 
				s->fileform->attributes. attributes_val[a].tabname, 
				s->fileform->attributes. attributes_val[a].colname, 
				s->fileform->attributes. attributes_val[a].datatype, 
				s->fileform->attributes. attributes_val[a].dtype_size
		);
		int fno;
		fno=s->fileform->attributes. attributes_val[a].field_no;
		int b;

		for (b=0;b<s->fileform->fields.fields_val[fno].metric.metric_len;b++) {
			int metricNo=s->fileform->fields.fields_val[fno].metric.metric_val[b];
			fprintf(outFile,"<Location x=\"%d\" y=\"%d\" w=\"%d\" h=\"%d\"/>\n", s->fileform->metrics.metrics_val[metricNo].x, s->fileform->metrics.metrics_val[metricNo].y, s->fileform->metrics.metrics_val[metricNo].w, s->fileform->metrics.metrics_val[metricNo].h);
		}

		fprintf(outFile,"</Field>\n");
	}
      fprintf(outFile,"</Form>\n");
      fprintf(outFile,"</Window>\n");
      fprintf(outFile,"<!-- END SCREEN DEFINITION -->\n");
      fflush (outFile);
                }

                  clearok (curscr, 1);
                  A4GL_mja_refresh ();
}

/* =============================== EOF =============================== */
